/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         VLparse
#define yylex           VLlex
#define yyerror         VLerror
#define yylval          VLlval
#define yychar          VLchar
#define yydebug         VLdebug
#define yynerrs         VLnerrs
#define yylloc          VLlloc

/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 2 "./parse.y"

/*
 * Copyright (c) 1998-2011 Stephen Williams (steve@icarus.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

# include "config.h"

# include  "parse_misc.h"
# include  "compiler.h"
# include  "pform.h"
# include  "Statement.h"
# include  "PSpec.h"
# include  <stack>
# include  <cstring>
# include  <sstream>

class PSpecPath;

extern void lex_start_table();
extern void lex_end_table();

static svector<PExpr*>* param_active_range = 0;
static bool param_active_signed = false;
static ivl_variable_type_t param_active_type = IVL_VT_LOGIC;

/* Port declaration lists use this structure for context. */
static struct {
      NetNet::Type port_net_type;
      NetNet::PortType port_type;
      ivl_variable_type_t var_type;
      bool sign_flag;
      svector<PExpr*>* range;
} port_declaration_context = {NetNet::NONE, NetNet::NOT_A_PORT,
                              IVL_VT_NO_TYPE, false, 0};

/* The task and function rules need to briefly hold the pointer to the
   task/function that is currently in progress. */
static PTask* current_task = 0;
static PFunction* current_function = 0;
static stack<PBlock*> current_block_stack;

/* This is used to keep track of the extra arguments after the notifier
 * in the $setuphold and $recrem timing checks. This allows us to print
 * a warning message that the delayed signals will not be created. We
 * need to do this since not driving these signals creates real
 * simulation issues. */
static unsigned args_after_notifier;

/* Later version of bison (including 1.35) will not compile in stack
   extension if the output is compiled with C++ and either the YYSTYPE
   or YYLTYPE are provided by the source code. However, I can get the
   old behavior back by defining these symbols. */
# define YYSTYPE_IS_TRIVIAL 1
# define YYLTYPE_IS_TRIVIAL 1

/* Recent version of bison expect that the user supply a
   YYLLOC_DEFAULT macro that makes up a yylloc value from existing
   values. I need to supply an explicit version to account for the
   text field, that otherwise won't be copied. */
# define YYLLOC_DEFAULT(Current, Rhs, N)  do {       \
  (Current).first_line   = (Rhs)[1].first_line;      \
  (Current).first_column = (Rhs)[1].first_column;    \
  (Current).last_line    = (Rhs)[N].last_line;       \
  (Current).last_column  = (Rhs)[N].last_column;     \
  (Current).text         = (Rhs)[1].text;   } while (0)

/*
 * These are some common strength pairs that are used as defaults when
 * the user is not otherwise specific.
 */
const static struct str_pair_t pull_strength = { PGate::PULL,  PGate::PULL };
const static struct str_pair_t str_strength = { PGate::STRONG, PGate::STRONG };

static list<pair<perm_string,PExpr*> >* make_port_list(char*id, PExpr*expr)
{
      list<pair<perm_string,PExpr*> >*tmp = new list<pair<perm_string,PExpr*> >;
      tmp->push_back(make_pair(lex_strings.make(id), expr));
      delete[]id;
      return tmp;
}
static list<pair<perm_string,PExpr*> >* make_port_list(list<pair<perm_string,
                                                                 PExpr*> >*tmp,
                                                       char*id, PExpr*expr)
{
      tmp->push_back(make_pair(lex_strings.make(id), expr));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(char*id)
{
      list<perm_string>*tmp = new list<perm_string>;
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static list<perm_string>* list_from_identifier(list<perm_string>*tmp, char*id)
{
      tmp->push_back(lex_strings.make(id));
      delete[]id;
      return tmp;
}

static svector<PExpr*>* copy_range(svector<PExpr*>* orig)
{
      svector<PExpr*>*copy = 0;

      if (orig) {
	    copy = new svector<PExpr*>(2);
	    (*copy)[0] = (*orig)[0];
	    (*copy)[1] = (*orig)[1];
      }

      return copy;
}

template <class T> void append(vector<T>&out, const vector<T>&in)
{
      for (size_t idx = 0 ; idx < in.size() ; idx += 1)
	    out.push_back(in[idx]);
}

/*
 * This is a shorthand for making a PECallFunction that takes a single
 * arg. This is used by some of the code that detects built-ins.
 */
static PECallFunction*make_call_function(perm_string tn, PExpr*arg)
{
      svector<PExpr*> parms(1);
      parms[0] = arg;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}

static PECallFunction*make_call_function(perm_string tn, PExpr*arg1, PExpr*arg2)
{
      svector<PExpr*> parms(2);
      parms[0] = arg1;
      parms[1] = arg2;
      PECallFunction*tmp = new PECallFunction(tn, parms);
      return tmp;
}



/* Line 268 of yacc.c  */
#line 241 "parse.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENTIFIER = 258,
     SYSTEM_IDENTIFIER = 259,
     STRING = 260,
     DISCIPLINE_IDENTIFIER = 261,
     PATHPULSE_IDENTIFIER = 262,
     BASED_NUMBER = 263,
     DEC_NUMBER = 264,
     REALTIME = 265,
     K_LE = 266,
     K_GE = 267,
     K_EG = 268,
     K_EQ = 269,
     K_NE = 270,
     K_CEQ = 271,
     K_CNE = 272,
     K_LS = 273,
     K_RS = 274,
     K_RSS = 275,
     K_SG = 276,
     K_CONTRIBUTE = 277,
     K_PO_POS = 278,
     K_PO_NEG = 279,
     K_POW = 280,
     K_PSTAR = 281,
     K_STARP = 282,
     K_LOR = 283,
     K_LAND = 284,
     K_NAND = 285,
     K_NOR = 286,
     K_NXOR = 287,
     K_TRIGGER = 288,
     K_edge_descriptor = 289,
     K_always = 290,
     K_and = 291,
     K_assign = 292,
     K_begin = 293,
     K_buf = 294,
     K_bufif0 = 295,
     K_bufif1 = 296,
     K_case = 297,
     K_casex = 298,
     K_casez = 299,
     K_cmos = 300,
     K_deassign = 301,
     K_default = 302,
     K_defparam = 303,
     K_disable = 304,
     K_edge = 305,
     K_else = 306,
     K_end = 307,
     K_endcase = 308,
     K_endfunction = 309,
     K_endmodule = 310,
     K_endprimitive = 311,
     K_endspecify = 312,
     K_endtable = 313,
     K_endtask = 314,
     K_event = 315,
     K_for = 316,
     K_force = 317,
     K_forever = 318,
     K_fork = 319,
     K_function = 320,
     K_highz0 = 321,
     K_highz1 = 322,
     K_if = 323,
     K_ifnone = 324,
     K_initial = 325,
     K_inout = 326,
     K_input = 327,
     K_integer = 328,
     K_join = 329,
     K_large = 330,
     K_macromodule = 331,
     K_medium = 332,
     K_module = 333,
     K_nand = 334,
     K_negedge = 335,
     K_nmos = 336,
     K_nor = 337,
     K_not = 338,
     K_notif0 = 339,
     K_notif1 = 340,
     K_or = 341,
     K_output = 342,
     K_parameter = 343,
     K_pmos = 344,
     K_posedge = 345,
     K_primitive = 346,
     K_pull0 = 347,
     K_pull1 = 348,
     K_pulldown = 349,
     K_pullup = 350,
     K_rcmos = 351,
     K_real = 352,
     K_realtime = 353,
     K_reg = 354,
     K_release = 355,
     K_repeat = 356,
     K_rnmos = 357,
     K_rpmos = 358,
     K_rtran = 359,
     K_rtranif0 = 360,
     K_rtranif1 = 361,
     K_scalared = 362,
     K_small = 363,
     K_specify = 364,
     K_specparam = 365,
     K_strong0 = 366,
     K_strong1 = 367,
     K_supply0 = 368,
     K_supply1 = 369,
     K_table = 370,
     K_task = 371,
     K_time = 372,
     K_tran = 373,
     K_tranif0 = 374,
     K_tranif1 = 375,
     K_tri = 376,
     K_tri0 = 377,
     K_tri1 = 378,
     K_triand = 379,
     K_trior = 380,
     K_trireg = 381,
     K_vectored = 382,
     K_wait = 383,
     K_wand = 384,
     K_weak0 = 385,
     K_weak1 = 386,
     K_while = 387,
     K_wire = 388,
     K_wor = 389,
     K_xnor = 390,
     K_xor = 391,
     K_Shold = 392,
     K_Snochange = 393,
     K_Speriod = 394,
     K_Srecovery = 395,
     K_Ssetup = 396,
     K_Ssetuphold = 397,
     K_Sskew = 398,
     K_Swidth = 399,
     KK_attribute = 400,
     K_bool = 401,
     K_logic = 402,
     K_automatic = 403,
     K_endgenerate = 404,
     K_generate = 405,
     K_genvar = 406,
     K_localparam = 407,
     K_noshowcancelled = 408,
     K_pulsestyle_onevent = 409,
     K_pulsestyle_ondetect = 410,
     K_showcancelled = 411,
     K_signed = 412,
     K_unsigned = 413,
     K_Sfullskew = 414,
     K_Srecrem = 415,
     K_Sremoval = 416,
     K_Stimeskew = 417,
     K_cell = 418,
     K_config = 419,
     K_design = 420,
     K_endconfig = 421,
     K_incdir = 422,
     K_include = 423,
     K_instance = 424,
     K_liblist = 425,
     K_library = 426,
     K_use = 427,
     K_wone = 428,
     K_uwire = 429,
     K_always_comb = 430,
     K_always_ff = 431,
     K_always_latch = 432,
     K_assert = 433,
     K_abs = 434,
     K_abstol = 435,
     K_access = 436,
     K_acos = 437,
     K_acosh = 438,
     K_analog = 439,
     K_asin = 440,
     K_asinh = 441,
     K_atan = 442,
     K_atan2 = 443,
     K_atanh = 444,
     K_ceil = 445,
     K_continuous = 446,
     K_cos = 447,
     K_cosh = 448,
     K_ddt_nature = 449,
     K_discipline = 450,
     K_discrete = 451,
     K_domain = 452,
     K_enddiscipline = 453,
     K_endnature = 454,
     K_exclude = 455,
     K_exp = 456,
     K_floor = 457,
     K_flow = 458,
     K_from = 459,
     K_ground = 460,
     K_hypot = 461,
     K_idt_nature = 462,
     K_inf = 463,
     K_ln = 464,
     K_log = 465,
     K_max = 466,
     K_min = 467,
     K_nature = 468,
     K_potential = 469,
     K_pow = 470,
     K_sin = 471,
     K_sinh = 472,
     K_sqrt = 473,
     K_string = 474,
     K_tan = 475,
     K_tanh = 476,
     K_units = 477,
     K_TAND = 478,
     UNARY_PREC = 479,
     less_than_K_else = 480
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 163 "./parse.y"

      bool flag;

      char letter;

	/* text items are C strings allocated by the lexor using
	   strdup. They can be put into lists with the texts type. */
      char*text;
      list<perm_string>*perm_strings;

      list<pair<perm_string,PExpr*> >*port_list;

      pform_name_t*pform_name;

      ivl_discipline_t discipline;

      hname_t*hier;

      list<string>*strings;

      struct str_pair_t drive;

      PCase::Item*citem;
      svector<PCase::Item*>*citems;

      lgate*gate;
      svector<lgate>*gates;

      Module::port_t *mport;
      LexicalScope::range_t* value_range;
      vector<Module::port_t*>*mports;

      named_pexpr_t*named_pexpr;
      svector<named_pexpr_t*>*named_pexprs;
      struct parmvalue_t*parmvalue;

      PExpr*expr;
      svector<PExpr*>*exprs;

      svector<PEEvent*>*event_expr;

      NetNet::Type nettype;
      PGBuiltin::Type gatetype;
      NetNet::PortType porttype;
      ivl_variable_type_t datatype;

      PWire*wire;
      svector<PWire*>*wires;

      PEventStatement*event_statement;
      Statement*statement;
      svector<Statement*>*statement_list;

      PTaskFuncArg function_type;

      net_decl_assign_t*net_decl_assign;

      verinum* number;

      verireal* realtime;

      PSpecPath* specpath;
      list<index_component_t> *dimensions;



/* Line 293 of yacc.c  */
#line 569 "parse.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 594 "parse.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  26
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   11375

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  271
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  195
/* YYNRULES -- Number of rules.  */
#define YYNRULES  741
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1804

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   480

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   247,     2,   243,     2,   235,   228,     2,
     238,   242,   233,   231,   239,   232,   244,   234,   252,   253,
       2,     2,     2,     2,     2,     2,     2,     2,   225,   241,
     229,   240,   230,   224,   245,     2,   260,     2,     2,     2,
     257,     2,     2,     2,     2,     2,     2,   263,   265,     2,
     267,   268,   262,     2,     2,     2,     2,     2,     2,     2,
       2,   250,     2,   251,   227,   270,     2,     2,   255,     2,
       2,     2,   256,     2,   259,     2,     2,     2,   258,     2,
     264,     2,   266,   269,   261,     2,     2,     2,     2,     2,
     254,     2,     2,   248,   226,   249,   246,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   236,
     237
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     6,     8,    11,    13,    15,    18,
      20,    22,    24,    25,    28,    32,    36,    41,    45,    47,
      49,    53,    61,    68,    73,    78,    83,    88,    92,    96,
     100,   105,   110,   115,   120,   125,   129,   133,   135,   138,
     140,   141,   145,   149,   152,   156,   159,   161,   165,   169,
     173,   175,   176,   180,   182,   185,   189,   192,   197,   200,
     205,   212,   221,   223,   224,   226,   230,   232,   238,   240,
     242,   244,   246,   248,   250,   252,   254,   263,   265,   266,
     267,   274,   277,   279,   283,   287,   291,   295,   296,   303,
     306,   308,   313,   318,   323,   328,   333,   342,   343,   346,
     347,   350,   355,   361,   368,   374,   381,   382,   385,   387,
     391,   392,   395,   401,   407,   413,   419,   425,   431,   433,
     434,   436,   438,   440,   442,   444,   446,   448,   450,   453,
     458,   463,   465,   469,   473,   476,   479,   481,   488,   493,
     495,   498,   501,   504,   507,   510,   513,   516,   520,   524,
     528,   531,   534,   537,   540,   543,   547,   551,   555,   559,
     563,   567,   571,   575,   579,   583,   587,   591,   595,   599,
     603,   607,   611,   615,   619,   623,   627,   631,   635,   639,
     643,   649,   651,   657,   661,   663,   664,   667,   671,   673,
     675,   677,   679,   681,   683,   688,   693,   698,   703,   708,
     713,   718,   723,   730,   735,   740,   745,   750,   755,   762,
     767,   772,   779,   784,   789,   794,   799,   804,   809,   816,
     823,   827,   831,   838,   846,   848,   851,   853,   855,   860,
     866,   870,   873,   878,   884,   889,   895,   899,   901,   903,
     905,   907,   909,   911,   913,   915,   917,   919,   921,   923,
     925,   927,   929,   931,   933,   935,   937,   939,   941,   943,
     945,   947,   949,   951,   955,   960,   967,   974,   981,   983,
     987,   989,   993,   997,  1003,  1005,  1009,  1011,  1015,  1019,
    1022,  1025,  1032,  1039,  1046,  1053,  1062,  1064,  1065,  1067,
    1068,  1070,  1074,  1078,  1082,  1084,  1085,  1086,  1098,  1100,
    1102,  1111,  1112,  1116,  1120,  1121,  1122,  1127,  1130,  1134,
    1139,  1148,  1157,  1165,  1172,  1179,  1186,  1193,  1200,  1207,
    1214,  1218,  1220,  1224,  1229,  1235,  1241,  1248,  1253,  1259,
    1263,  1267,  1274,  1283,  1292,  1299,  1308,  1317,  1323,  1329,
    1335,  1339,  1343,  1347,  1348,  1357,  1358,  1370,  1371,  1382,
    1388,  1389,  1399,  1400,  1413,  1420,  1424,  1428,  1429,  1444,
    1445,  1451,  1454,  1455,  1463,  1469,  1470,  1479,  1482,  1486,
    1490,  1494,  1497,  1503,  1507,  1511,  1521,  1527,  1529,  1530,
    1535,  1538,  1540,  1541,  1546,  1547,  1552,  1555,  1557,  1559,
    1560,  1562,  1566,  1572,  1574,  1576,  1580,  1584,  1586,  1588,
    1590,  1592,  1594,  1595,  1597,  1599,  1601,  1603,  1605,  1607,
    1609,  1611,  1613,  1615,  1617,  1619,  1621,  1623,  1624,  1628,
    1629,  1634,  1635,  1639,  1640,  1644,  1645,  1649,  1651,  1655,
    1660,  1662,  1663,  1666,  1668,  1675,  1682,  1689,  1696,  1699,
    1701,  1703,  1706,  1709,  1711,  1713,  1717,  1719,  1720,  1724,
    1725,  1730,  1731,  1735,  1736,  1740,  1741,  1745,  1747,  1751,
    1756,  1761,  1764,  1767,  1768,  1774,  1779,  1781,  1785,  1787,
    1793,  1797,  1805,  1807,  1808,  1810,  1817,  1822,  1827,  1829,
    1833,  1839,  1845,  1850,  1854,  1856,  1858,  1860,  1862,  1868,
    1870,  1871,  1872,  1874,  1880,  1887,  1889,  1892,  1894,  1896,
    1898,  1900,  1901,  1904,  1908,  1910,  1914,  1917,  1921,  1923,
    1927,  1930,  1932,  1936,  1940,  1943,  1946,  1953,  1960,  1964,
    1968,  1981,  1992,  2005,  2014,  2025,  2038,  2049,  2060,  2073,
    2084,  2095,  2106,  2114,  2118,  2122,  2126,  2130,  2132,  2135,
    2141,  2145,  2147,  2149,  2160,  2172,  2183,  2195,  2197,  2199,
    2201,  2207,  2211,  2217,  2224,  2231,  2235,  2237,  2242,  2246,
    2253,  2257,  2265,  2269,  2277,  2279,  2283,  2285,  2287,  2288,
    2291,  2294,  2299,  2304,  2310,  2318,  2322,  2324,  2328,  2330,
    2331,  2333,  2335,  2338,  2341,  2345,  2347,  2353,  2357,  2363,
    2367,  2371,  2372,  2380,  2383,  2388,  2392,  2393,  2401,  2404,
    2409,  2413,  2417,  2420,  2424,  2430,  2437,  2444,  2451,  2458,
    2465,  2472,  2478,  2486,  2492,  2500,  2514,  2526,  2540,  2546,
    2552,  2558,  2561,  2565,  2570,  2577,  2582,  2587,  2592,  2597,
    2603,  2609,  2615,  2625,  2631,  2641,  2647,  2653,  2656,  2662,
    2667,  2670,  2673,  2676,  2678,  2680,  2682,  2687,  2689,  2691,
    2693,  2694,  2701,  2708,  2715,  2720,  2725,  2730,  2735,  2740,
    2745,  2750,  2755,  2760,  2763,  2765,  2767,  2768,  2774,  2780,
    2786,  2790,  2794,  2798,  2802,  2806,  2810,  2814,  2818,  2822,
    2826,  2828,  2832,  2835,  2838,  2839,  2844,  2846,  2848,  2853,
    2855,  2858,  2860,  2863,  2870,  2876,  2878,  2879,  2881,  2884,
    2886,  2888,  2890,  2892,  2894,  2896,  2898,  2900,  2902,  2904,
    2906,  2908,  2910,  2912,  2914,  2916,  2918,  2920,  2922,  2924,
    2926,  2928,  2930,  2932,  2934,  2936,  2938,  2942,  2946,  2950,
    2955,  2957,  2960,  2962,  2966,  2968,  2969,  2972,  2973,  2976,
    2981,  2992
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     272,     0,    -1,   273,    -1,    -1,   295,    -1,   273,   295,
      -1,     8,    -1,     9,    -1,     9,     8,    -1,    97,    -1,
      98,    -1,   277,    -1,    -1,    26,    27,    -1,    26,   278,
      27,    -1,   277,    26,    27,    -1,   277,    26,   278,    27,
      -1,   278,   239,   279,    -1,   279,    -1,     3,    -1,     3,
     240,   320,    -1,   276,    99,   373,   338,   407,   413,   241,
      -1,   276,    99,   373,   338,   413,   241,    -1,   276,    73,
     413,   241,    -1,   276,   117,   413,   241,    -1,   276,    97,
     415,   241,    -1,   276,    98,   415,   241,    -1,    60,   332,
     241,    -1,    88,   376,   241,    -1,   152,   390,   241,    -1,
     276,    99,     1,   241,    -1,   276,    73,     1,   241,    -1,
     276,   117,     1,   241,    -1,   276,    97,     1,   241,    -1,
     276,    98,     1,   241,    -1,    88,     1,   241,    -1,   152,
       1,   241,    -1,   280,    -1,   281,   280,    -1,   281,    -1,
      -1,   323,   225,   438,    -1,    47,   225,   438,    -1,    47,
     438,    -1,     1,   225,   438,    -1,   284,   283,    -1,   283,
      -1,   238,   108,   242,    -1,   238,    77,   242,    -1,   238,
      75,   242,    -1,   285,    -1,    -1,   331,   240,   320,    -1,
     287,    -1,   407,   287,    -1,   288,   239,   287,    -1,   243,
     294,    -1,   243,   238,   293,   242,    -1,   243,   294,    -1,
     243,   238,   293,   242,    -1,   243,   238,   293,   239,   293,
     242,    -1,   243,   238,   293,   239,   293,   239,   293,   242,
      -1,   290,    -1,    -1,   293,    -1,   292,   239,   293,    -1,
     320,    -1,   320,   225,   320,   225,   320,    -1,     9,    -1,
      10,    -1,     3,    -1,   342,    -1,   465,    -1,   305,    -1,
     301,    -1,   297,    -1,   145,   238,     3,   239,     5,   239,
       5,   242,    -1,   241,    -1,    -1,    -1,   195,     3,   296,
     298,   299,   198,    -1,   299,   300,    -1,   300,    -1,   197,
     196,   241,    -1,   197,   191,   241,    -1,   214,     3,   241,
      -1,   203,     3,   241,    -1,    -1,   213,     3,   296,   302,
     303,   199,    -1,   303,   304,    -1,   304,    -1,   222,   240,
       5,   241,    -1,   180,   240,   320,   241,    -1,   181,   240,
       3,   241,    -1,   207,   240,     3,   241,    -1,   194,   240,
       3,   241,    -1,   164,     3,   241,   165,   306,   241,   307,
     166,    -1,    -1,   306,   310,    -1,    -1,   307,   308,    -1,
      47,   170,   311,   241,    -1,   169,   331,   170,   311,   241,
      -1,   169,   331,   172,   310,   309,   241,    -1,   163,   310,
     170,   311,   241,    -1,   163,   310,   172,   310,   309,   241,
      -1,    -1,   225,   164,    -1,     3,    -1,     3,   244,     3,
      -1,    -1,   311,     3,    -1,   238,   314,   239,   315,   242,
      -1,   238,   315,   239,   314,   242,    -1,   238,   314,   239,
      67,   242,    -1,   238,   315,   239,    66,   242,    -1,   238,
      67,   239,   314,   242,    -1,   238,    66,   239,   315,   242,
      -1,   312,    -1,    -1,   113,    -1,   111,    -1,    92,    -1,
     130,    -1,   114,    -1,   112,    -1,    93,    -1,   131,    -1,
     245,   331,    -1,   245,   238,   317,   242,    -1,   245,   238,
       1,   242,    -1,   318,    -1,   317,    86,   318,    -1,   317,
     239,   318,    -1,    90,   320,    -1,    80,   320,    -1,   320,
      -1,     3,   238,     3,   239,     3,   242,    -1,     3,   238,
       3,   242,    -1,   324,    -1,   231,   324,    -1,   232,   324,
      -1,   246,   324,    -1,   228,   324,    -1,   247,   324,    -1,
     226,   324,    -1,   227,   324,    -1,   246,   228,   324,    -1,
     246,   226,   324,    -1,   246,   227,   324,    -1,    30,   324,
      -1,    31,   324,    -1,    32,   324,    -1,   247,     1,    -1,
     227,     1,    -1,   320,   227,   320,    -1,   320,    25,   320,
      -1,   320,   233,   320,    -1,   320,   234,   320,    -1,   320,
     235,   320,    -1,   320,   231,   320,    -1,   320,   232,   320,
      -1,   320,   228,   320,    -1,   320,   226,   320,    -1,   320,
      30,   320,    -1,   320,    31,   320,    -1,   320,    32,   320,
      -1,   320,   229,   320,    -1,   320,   230,   320,    -1,   320,
      18,   320,    -1,   320,    19,   320,    -1,   320,    20,   320,
      -1,   320,    14,   320,    -1,   320,    16,   320,    -1,   320,
      11,   320,    -1,   320,    12,   320,    -1,   320,    15,   320,
      -1,   320,    17,   320,    -1,   320,    28,   320,    -1,   320,
      29,   320,    -1,   320,   224,   320,   225,   320,    -1,   320,
      -1,   320,   225,   320,   225,   320,    -1,   322,   239,   320,
      -1,   320,    -1,    -1,   322,   239,    -1,   323,   239,   320,
      -1,   320,    -1,   274,    -1,    10,    -1,     5,    -1,     4,
      -1,   331,    -1,   331,   238,   323,   242,    -1,     4,   238,
     323,   242,    -1,   182,   238,   320,   242,    -1,   183,   238,
     320,   242,    -1,   185,   238,   320,   242,    -1,   186,   238,
     320,   242,    -1,   187,   238,   320,   242,    -1,   189,   238,
     320,   242,    -1,   188,   238,   320,   239,   320,   242,    -1,
     190,   238,   320,   242,    -1,   192,   238,   320,   242,    -1,
     193,   238,   320,   242,    -1,   201,   238,   320,   242,    -1,
     202,   238,   320,   242,    -1,   206,   238,   320,   239,   320,
     242,    -1,   209,   238,   320,   242,    -1,   210,   238,   320,
     242,    -1,   215,   238,   320,   239,   320,   242,    -1,   216,
     238,   320,   242,    -1,   217,   238,   320,   242,    -1,   218,
     238,   320,   242,    -1,   220,   238,   320,   242,    -1,   221,
     238,   320,   242,    -1,   179,   238,   320,   242,    -1,   211,
     238,   320,   239,   320,   242,    -1,   212,   238,   320,   239,
     320,   242,    -1,   238,   321,   242,    -1,   248,   323,   249,
      -1,   248,   320,   248,   323,   249,   249,    -1,   248,   320,
     248,   323,   249,     1,   249,    -1,   326,    -1,   325,   326,
      -1,   442,    -1,   280,    -1,     3,   238,   322,   242,    -1,
       3,   407,   238,   322,   242,    -1,   238,   322,   242,    -1,
       3,   407,    -1,     3,   238,   405,   242,    -1,     3,   407,
     238,   405,   242,    -1,     3,   238,     1,   242,    -1,     3,
     407,   238,     1,   242,    -1,   328,   239,   327,    -1,   327,
      -1,    36,    -1,    79,    -1,    86,    -1,    82,    -1,   136,
      -1,   135,    -1,    39,    -1,    40,    -1,    41,    -1,    83,
      -1,    84,    -1,    85,    -1,    81,    -1,   102,    -1,    89,
      -1,   103,    -1,    45,    -1,    96,    -1,   118,    -1,   104,
      -1,   119,    -1,   120,    -1,   105,    -1,   106,    -1,     3,
      -1,   331,   244,     3,    -1,   331,   250,   320,   251,    -1,
     331,   250,   320,   225,   320,   251,    -1,   331,   250,   320,
      23,   320,   251,    -1,   331,   250,   320,    24,   320,   251,
      -1,     3,    -1,   332,   239,     3,    -1,     3,    -1,     3,
     240,   320,    -1,   333,   239,     3,    -1,   333,   239,     3,
     240,   320,    -1,   401,    -1,   334,   239,   401,    -1,   336,
      -1,   335,   239,   336,    -1,   335,   239,     3,    -1,   335,
     239,    -1,   335,   241,    -1,   276,    72,   337,   338,   408,
       3,    -1,   276,    71,   337,   338,   408,     3,    -1,   276,
      87,   337,   338,   408,     3,    -1,   276,    87,   375,   338,
     408,     3,    -1,   276,    87,   375,   338,   408,     3,   240,
     320,    -1,   374,    -1,    -1,   157,    -1,    -1,   331,    -1,
     248,   323,   249,    -1,   339,   240,   320,    -1,   341,   239,
     340,    -1,   340,    -1,    -1,    -1,   276,   345,     3,   343,
     348,   347,   346,   241,   344,   367,    55,    -1,    78,    -1,
      76,    -1,    26,     3,    73,     3,   240,     5,   241,    27,
      -1,    -1,   238,   334,   242,    -1,   238,   335,   242,    -1,
      -1,    -1,   243,   238,   349,   242,    -1,    88,   383,    -1,
     349,   239,   383,    -1,   349,   239,    88,   383,    -1,   276,
     374,   373,   338,   408,   291,   417,   241,    -1,   276,   374,
     373,   338,   408,   291,   371,   241,    -1,   276,   374,   373,
     338,   312,   371,   241,    -1,   126,   286,   408,   291,   332,
     241,    -1,   406,   338,   408,   291,   332,   241,    -1,   406,
     374,   338,   408,   332,   241,    -1,    87,   375,   338,   408,
     333,   241,    -1,    72,   375,   338,   408,   332,   241,    -1,
      71,   375,   338,   408,   332,   241,    -1,   406,   338,   408,
     291,     1,   241,    -1,     6,   332,   241,    -1,   280,    -1,
      48,   288,   241,    -1,   276,   329,   328,   241,    -1,   276,
     329,   290,   328,   241,    -1,   276,   329,   312,   328,   241,
      -1,   276,   329,   312,   290,   328,   241,    -1,   276,   330,
     328,   241,    -1,   276,   330,   290,   328,   241,    -1,    95,
     328,   241,    -1,    94,   328,   241,    -1,    95,   238,   315,
     242,   328,   241,    -1,    95,   238,   315,   239,   314,   242,
     328,   241,    -1,    95,   238,   314,   239,   315,   242,   328,
     241,    -1,    94,   238,   314,   242,   328,   241,    -1,    94,
     238,   315,   239,   314,   242,   328,   241,    -1,    94,   238,
     314,   239,   315,   242,   328,   241,    -1,   276,     3,   397,
     328,   241,    -1,   276,     3,   397,     1,   241,    -1,    37,
     313,   291,   341,   241,    -1,   276,    35,   434,    -1,   276,
      70,   434,    -1,   276,   184,   439,    -1,    -1,   116,   360,
       3,   241,   351,   444,   438,    59,    -1,    -1,   116,   360,
       3,   238,   352,   446,   242,   241,   282,   438,    59,    -1,
      -1,   116,   360,     3,   238,   242,   241,   353,   282,   438,
      59,    -1,   116,   360,     3,     1,    59,    -1,    -1,    65,
     360,   411,     3,   241,   354,   325,   434,    54,    -1,    -1,
      65,   360,   411,     3,   355,   238,   446,   242,   241,   282,
     434,    54,    -1,    65,   360,   411,     3,     1,    54,    -1,
     150,   367,   149,    -1,   151,   332,   241,    -1,    -1,    61,
     238,     3,   240,   320,   241,   320,   241,     3,   240,   320,
     242,   356,   368,    -1,    -1,   361,   369,    51,   357,   368,
      -1,   361,   369,    -1,    -1,    42,   238,   320,   242,   358,
     362,    53,    -1,   150,    38,   367,    52,   149,    -1,    -1,
     150,    38,   225,     3,   359,   367,    52,   149,    -1,   109,
      57,    -1,   109,   419,    57,    -1,   109,     1,    57,    -1,
      78,     1,   241,    -1,     1,   241,    -1,    37,     1,   240,
     320,   241,    -1,    37,     1,   241,    -1,    65,     1,    54,
      -1,   145,   238,     3,   239,     5,   239,     5,   242,   241,
      -1,   145,   238,     1,   242,   241,    -1,   148,    -1,    -1,
      68,   238,   320,   242,    -1,   362,   363,    -1,   363,    -1,
      -1,   323,   225,   364,   369,    -1,    -1,    47,   225,   365,
     369,    -1,   366,   350,    -1,   350,    -1,   366,    -1,    -1,
     350,    -1,    38,   367,    52,    -1,    38,   225,     3,   367,
      52,    -1,   368,    -1,   241,    -1,     3,   240,   320,    -1,
     371,   239,   370,    -1,   370,    -1,   147,    -1,   146,    -1,
      97,    -1,   372,    -1,    -1,   133,    -1,   121,    -1,   123,
      -1,   113,    -1,   129,    -1,   124,    -1,   122,    -1,   114,
      -1,   134,    -1,   125,    -1,   173,    -1,   174,    -1,    99,
      -1,   382,    -1,    -1,   407,   377,   382,    -1,    -1,   157,
     407,   378,   382,    -1,    -1,    73,   379,   382,    -1,    -1,
     117,   380,   382,    -1,    -1,   275,   381,   382,    -1,   383,
      -1,   382,   239,   383,    -1,     3,   240,   320,   384,    -1,
     385,    -1,    -1,   385,   386,    -1,   386,    -1,   388,   250,
     387,   225,   387,   251,    -1,   388,   250,   387,   225,   387,
     242,    -1,   388,   238,   387,   225,   387,   251,    -1,   388,
     238,   387,   225,   387,   242,    -1,   200,   320,    -1,   320,
      -1,   208,    -1,   231,   208,    -1,   232,   208,    -1,   204,
      -1,   200,    -1,     3,   240,   320,    -1,   396,    -1,    -1,
     407,   391,   396,    -1,    -1,   157,   407,   392,   396,    -1,
      -1,    73,   393,   396,    -1,    -1,   117,   394,   396,    -1,
      -1,   275,   395,   396,    -1,   389,    -1,   396,   239,   389,
      -1,   243,   238,   322,   242,    -1,   243,   238,   399,   242,
      -1,   243,     9,    -1,   243,     1,    -1,    -1,   244,     3,
     238,   320,   242,    -1,   244,     3,   238,   242,    -1,   398,
      -1,   399,   239,   398,    -1,   402,    -1,   244,     3,   238,
     402,   242,    -1,   248,   403,   249,    -1,   244,     3,   238,
     248,   403,   249,   242,    -1,   400,    -1,    -1,     3,    -1,
       3,   250,   320,   225,   320,   251,    -1,     3,   250,   320,
     251,    -1,     3,   250,     1,   251,    -1,   402,    -1,   403,
     239,   402,    -1,   244,     3,   238,   320,   242,    -1,   244,
       3,   238,     1,   242,    -1,   244,     3,   238,   242,    -1,
     405,   239,   404,    -1,   404,    -1,    72,    -1,    87,    -1,
      71,    -1,   250,   320,   225,   320,   251,    -1,   407,    -1,
      -1,    -1,   410,    -1,   250,   320,   225,   320,   251,    -1,
     410,   250,   320,   225,   320,   251,    -1,   407,    -1,   157,
     407,    -1,    73,    -1,    97,    -1,    98,    -1,   117,    -1,
      -1,     3,   409,    -1,     3,   240,   320,    -1,   412,    -1,
     413,   239,   412,    -1,     3,   409,    -1,     3,   240,   320,
      -1,   414,    -1,   415,   239,   414,    -1,     3,   409,    -1,
     416,    -1,   417,   239,   416,    -1,   110,   428,   241,    -1,
     424,   241,    -1,   420,   241,    -1,    68,   238,   320,   242,
     424,   241,    -1,    68,   238,   320,   242,   420,   241,    -1,
      69,   424,   241,    -1,    69,   420,   241,    -1,   159,   238,
     430,   239,   430,   239,   293,   239,   293,   432,   242,   241,
      -1,   137,   238,   430,   239,   430,   239,   293,   432,   242,
     241,    -1,   138,   238,   430,   239,   430,   239,   293,   239,
     293,   432,   242,   241,    -1,   139,   238,   430,   239,   293,
     432,   242,   241,    -1,   140,   238,   430,   239,   430,   239,
     293,   432,   242,   241,    -1,   160,   238,   430,   239,   430,
     239,   293,   239,   293,   432,   242,   241,    -1,   161,   238,
     430,   239,   430,   239,   293,   432,   242,   241,    -1,   141,
     238,   430,   239,   430,   239,   293,   432,   242,   241,    -1,
     142,   238,   430,   239,   430,   239,   293,   239,   293,   432,
     242,   241,    -1,   143,   238,   430,   239,   430,   239,   293,
     432,   242,   241,    -1,   162,   238,   430,   239,   430,   239,
     293,   432,   242,   241,    -1,   144,   238,   430,   239,   293,
     239,   320,   432,   242,   241,    -1,   144,   238,   430,   239,
     293,   242,   241,    -1,   154,   426,   241,    -1,   155,   426,
     241,    -1,   156,   426,   241,    -1,   153,   426,   241,    -1,
     418,    -1,   419,   418,    -1,   422,   240,   238,   292,   242,
      -1,   422,   240,   294,    -1,    90,    -1,    80,    -1,   238,
     426,   429,    13,   238,   426,   423,   320,   242,   242,    -1,
     238,   421,   426,   429,    13,   238,   426,   423,   320,   242,
     242,    -1,   238,   426,   429,    21,   238,   426,   423,   320,
     242,   242,    -1,   238,   421,   426,   429,    21,   238,   426,
     423,   320,   242,   242,    -1,    23,    -1,    24,    -1,   225,
      -1,   425,   240,   238,   292,   242,    -1,   425,   240,   294,
      -1,   425,   240,   238,     1,   242,    -1,   238,   426,   429,
      13,   426,   242,    -1,   238,   426,   429,    21,   426,   242,
      -1,   238,     1,   242,    -1,     3,    -1,     3,   250,   324,
     251,    -1,   426,   239,     3,    -1,   426,   239,     3,   250,
     324,   251,    -1,     3,   240,   320,    -1,     3,   240,   320,
     225,   320,   225,   320,    -1,     7,   240,   320,    -1,     7,
     240,   238,   320,   239,   320,   242,    -1,   427,    -1,   428,
     239,   427,    -1,   231,    -1,   232,    -1,    -1,    90,   320,
      -1,    80,   320,    -1,    90,   324,   223,   320,    -1,    80,
     324,   223,   320,    -1,    50,   250,   431,   251,   324,    -1,
      50,   250,   431,   251,   324,   223,   320,    -1,   324,   223,
     320,    -1,   324,    -1,   431,   239,    34,    -1,    34,    -1,
      -1,   433,    -1,   239,    -1,   239,   331,    -1,   433,   239,
      -1,   433,   239,   331,    -1,     3,    -1,    37,   339,   240,
     320,   241,    -1,    46,   339,   241,    -1,    62,   339,   240,
     320,   241,    -1,   100,   339,   241,    -1,    38,   437,    52,
      -1,    -1,    38,   225,     3,   435,   282,   437,    52,    -1,
      38,    52,    -1,    38,   225,     3,    52,    -1,    38,     1,
      52,    -1,    -1,    64,   225,     3,   436,   282,   437,    74,
      -1,    64,    74,    -1,    64,   225,     3,    74,    -1,    49,
     331,   241,    -1,    33,   331,   241,    -1,    63,   434,    -1,
      64,   437,    74,    -1,   101,   238,   320,   242,   434,    -1,
      42,   238,   320,   242,   284,    53,    -1,    43,   238,   320,
     242,   284,    53,    -1,    44,   238,   320,   242,   284,    53,
      -1,    42,   238,   320,   242,     1,    53,    -1,    43,   238,
     320,   242,     1,    53,    -1,    44,   238,   320,   242,     1,
      53,    -1,    68,   238,   320,   242,   438,    -1,    68,   238,
     320,   242,   438,    51,   438,    -1,    68,   238,     1,   242,
     438,    -1,    68,   238,     1,   242,   438,    51,   438,    -1,
      61,   238,   339,   240,   320,   241,   320,   241,   339,   240,
     320,   242,   434,    -1,    61,   238,   339,   240,   320,   241,
     320,   241,     1,   242,   434,    -1,    61,   238,   339,   240,
     320,   241,     1,   241,   339,   240,   320,   242,   434,    -1,
      61,   238,     1,   242,   434,    -1,   132,   238,   320,   242,
     434,    -1,   132,   238,     1,   242,   434,    -1,   289,   438,
      -1,   316,   276,   438,    -1,   245,   233,   276,   438,    -1,
     245,   238,   233,   242,   276,   438,    -1,   339,   240,   320,
     241,    -1,     1,   240,   320,   241,    -1,   339,    11,   320,
     241,    -1,     1,    11,   320,   241,    -1,   339,   240,   289,
     320,   241,    -1,   339,    11,   289,   320,   241,    -1,   339,
     240,   316,   320,   241,    -1,   339,   240,   101,   238,   320,
     242,   316,   320,   241,    -1,   339,    11,   316,   320,   241,
      -1,   339,    11,   101,   238,   320,   242,   316,   320,   241,
      -1,   128,   238,   320,   242,   438,    -1,     4,   238,   322,
     242,   241,    -1,     4,   241,    -1,   331,   238,   323,   242,
     241,    -1,   331,   238,   242,   241,    -1,   331,   241,    -1,
       1,   241,    -1,   437,   434,    -1,   434,    -1,   434,    -1,
     241,    -1,   319,    22,   320,   241,    -1,   280,    -1,   442,
      -1,    99,    -1,    -1,    72,   441,   338,   408,   332,   241,
      -1,    87,   441,   338,   408,   332,   241,    -1,    71,   441,
     338,   408,   332,   241,    -1,    72,    73,   332,   241,    -1,
      87,    73,   332,   241,    -1,    71,    73,   332,   241,    -1,
      72,   117,   332,   241,    -1,    87,   117,   332,   241,    -1,
      71,   117,   332,   241,    -1,    72,   275,   332,   241,    -1,
      87,   275,   332,   241,    -1,    71,   275,   332,   241,    -1,
     443,   440,    -1,   440,    -1,   443,    -1,    -1,    72,   441,
     338,   408,     3,    -1,    87,   441,   338,   408,     3,    -1,
      71,   441,   338,   408,     3,    -1,    72,    73,     3,    -1,
      87,    73,     3,    -1,    71,    73,     3,    -1,    72,   117,
       3,    -1,    87,   117,     3,    -1,    71,   117,     3,    -1,
      72,   275,     3,    -1,    87,   275,     3,    -1,    71,   275,
       3,    -1,   446,   239,   445,    -1,   445,    -1,   446,   239,
       3,    -1,   446,   239,    -1,   446,   241,    -1,    -1,   115,
     448,   449,    58,    -1,   451,    -1,   452,    -1,   456,   225,
     458,   241,    -1,   450,    -1,   451,   450,    -1,   453,    -1,
     452,   453,    -1,   456,   225,   457,   225,   458,   241,    -1,
      70,     3,   240,   274,   241,    -1,   454,    -1,    -1,   457,
      -1,   456,   457,    -1,   252,    -1,   253,    -1,   254,    -1,
     224,    -1,   255,    -1,   233,    -1,   235,    -1,   256,    -1,
     257,    -1,   258,    -1,   259,    -1,   260,    -1,   261,    -1,
     262,    -1,   263,    -1,   264,    -1,   265,    -1,   266,    -1,
     267,    -1,   268,    -1,   269,    -1,   270,    -1,   231,    -1,
     252,    -1,   253,    -1,   254,    -1,   232,    -1,    72,   332,
     241,    -1,    87,     3,   241,    -1,    99,     3,   241,    -1,
      99,    87,     3,   241,    -1,   459,    -1,   460,   459,    -1,
       3,    -1,   461,   239,     3,    -1,    99,    -1,    -1,   240,
     320,    -1,    -1,    72,     3,    -1,   464,   239,    72,     3,
      -1,    91,     3,   238,   461,   242,   241,   460,   455,   447,
      56,    -1,    91,     3,   238,    87,   462,     3,   463,   239,
     464,   242,   241,   447,    56,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   393,   393,   393,   396,   397,   400,   402,   404,   412,
     413,   420,   421,   425,   426,   427,   428,   440,   446,   455,
     462,   480,   493,   507,   512,   521,   523,   526,   530,   531,
     536,   541,   546,   550,   554,   558,   562,   569,   570,   574,
     575,   579,   586,   591,   596,   603,   609,   617,   618,   619,
     623,   624,   628,   635,   636,   640,   644,   649,   657,   662,
     667,   673,   683,   684,   688,   693,   701,   705,   711,   722,
     732,   741,   742,   743,   744,   745,   746,   758,   758,   762,
     761,   768,   769,   773,   775,   777,   779,   785,   784,   792,
     793,   797,   799,   800,   802,   804,   809,   819,   822,   825,
     827,   831,   832,   834,   836,   837,   840,   842,   845,   847,
     851,   853,   857,   861,   865,   869,   873,   877,   884,   885,
     889,   890,   891,   892,   896,   897,   898,   899,   903,   911,
     917,   924,   926,   932,   941,   948,   955,   969,   971,   976,
     978,   980,   985,   990,   995,  1000,  1005,  1010,  1015,  1020,
    1025,  1030,  1035,  1040,  1045,  1050,  1055,  1060,  1065,  1070,
    1075,  1080,  1085,  1090,  1095,  1100,  1105,  1110,  1115,  1120,
    1125,  1130,  1135,  1140,  1145,  1150,  1155,  1160,  1165,  1170,
    1175,  1183,  1185,  1232,  1237,  1243,  1248,  1256,  1261,  1269,
    1275,  1280,  1285,  1296,  1307,  1313,  1324,  1331,  1338,  1345,
    1352,  1359,  1366,  1373,  1380,  1387,  1394,  1401,  1408,  1415,
    1422,  1429,  1436,  1443,  1450,  1457,  1464,  1475,  1481,  1487,
    1495,  1500,  1506,  1513,  1529,  1531,  1546,  1548,  1555,  1565,
    1578,  1589,  1606,  1617,  1632,  1645,  1660,  1668,  1677,  1678,
    1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,  1688,
    1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,
    1702,  1703,  1713,  1718,  1724,  1733,  1743,  1753,  1769,  1771,
    1776,  1778,  1780,  1782,  1804,  1810,  1818,  1824,  1829,  1848,
    1853,  1861,  1878,  1895,  1912,  1929,  1954,  1955,  1958,  1958,
    1965,  1971,  1983,  1992,  1998,  2008,  2012,  2007,  2034,  2034,
    2037,  2038,  2042,  2043,  2044,  2050,  2052,  2056,  2057,  2058,
    2069,  2090,  2109,  2124,  2130,  2138,  2143,  2163,  2169,  2175,
    2186,  2192,  2196,  2202,  2206,  2210,  2214,  2219,  2223,  2230,
    2234,  2239,  2243,  2247,  2251,  2255,  2259,  2267,  2275,  2286,
    2291,  2295,  2300,  2312,  2311,  2326,  2325,  2341,  2340,  2356,
    2368,  2367,  2382,  2381,  2396,  2406,  2408,  2414,  2411,  2421,
    2418,  2425,  2430,  2429,  2436,  2443,  2443,  2456,  2459,  2463,
    2472,  2479,  2484,  2490,  2496,  2505,  2512,  2517,  2518,  2521,
    2524,  2525,  2529,  2529,  2531,  2531,  2536,  2537,  2541,  2542,
    2552,  2553,  2554,  2558,  2558,  2569,  2580,  2586,  2592,  2593,
    2594,  2597,  2597,  2600,  2601,  2602,  2603,  2604,  2605,  2606,
    2607,  2608,  2609,  2610,  2615,  2619,  2626,  2628,  2627,  2638,
    2637,  2648,  2647,  2665,  2664,  2682,  2681,  2694,  2695,  2699,
    2707,  2707,  2710,  2712,  2717,  2719,  2721,  2723,  2725,  2730,
    2731,  2732,  2733,  2736,  2736,  2744,  2755,  2757,  2756,  2767,
    2766,  2777,  2776,  2794,  2793,  2811,  2810,  2823,  2824,  2844,
    2850,  2856,  2868,  2874,  2878,  2885,  2895,  2900,  2923,  2931,
    2942,  2951,  2960,  2961,  2977,  2985,  3008,  3030,  3044,  3046,
    3059,  3066,  3074,  3084,  3090,  3098,  3099,  3100,  3104,  3113,
    3114,  3117,  3118,  3121,  3129,  3140,  3141,  3142,  3143,  3144,
    3145,  3146,  3155,  3171,  3181,  3187,  3196,  3211,  3220,  3226,
    3235,  3254,  3260,  3269,  3270,  3273,  3276,  3284,  3292,  3300,
    3305,  3310,  3314,  3319,  3323,  3327,  3332,  3336,  3340,  3345,
    3349,  3353,  3358,  3361,  3364,  3367,  3370,  3376,  3377,  3381,
    3383,  3390,  3390,  3393,  3397,  3401,  3405,  3412,  3413,  3414,
    3418,  3420,  3425,  3433,  3436,  3439,  3446,  3452,  3458,  3464,
    3473,  3478,  3516,  3520,  3528,  3529,  3533,  3534,  3535,  3539,
    3541,  3543,  3547,  3551,  3553,  3557,  3561,  3570,  3571,  3576,
    3577,  3581,  3583,  3585,  3587,  3596,  3608,  3614,  3624,  3629,
    3641,  3649,  3648,  3664,  3669,  3675,  3684,  3683,  3699,  3704,
    3711,  3717,  3723,  3728,  3735,  3740,  3745,  3750,  3755,  3757,
    3759,  3761,  3766,  3771,  3775,  3779,  3785,  3790,  3795,  3799,
    3804,  3808,  3815,  3826,  3833,  3840,  3845,  3850,  3855,  3860,
    3867,  3874,  3879,  3885,  3890,  3895,  3903,  3910,  3917,  3929,
    3936,  3943,  3951,  3956,  3964,  3966,  3971,  3978,  3979,  3983,
    3984,  3988,  3997,  4006,  4019,  4034,  4049,  4067,  4081,  4095,
    4112,  4120,  4128,  4139,  4145,  4150,  4153,  4158,  4172,  4185,
    4201,  4222,  4243,  4267,  4287,  4307,  4330,  4343,  4356,  4372,
    4378,  4380,  4394,  4399,  4408,  4408,  4414,  4415,  4419,  4432,
    4438,  4447,  4453,  4462,  4476,  4487,  4488,  4492,  4498,  4510,
    4511,  4512,  4513,  4514,  4515,  4516,  4517,  4518,  4519,  4520,
    4521,  4522,  4523,  4524,  4525,  4526,  4527,  4528,  4529,  4530,
    4531,  4532,  4536,  4537,  4538,  4539,  4546,  4548,  4556,  4564,
    4575,  4577,  4586,  4592,  4600,  4600,  4603,  4604,  4608,  4614,
    4627,  4642
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENTIFIER", "SYSTEM_IDENTIFIER",
  "STRING", "DISCIPLINE_IDENTIFIER", "PATHPULSE_IDENTIFIER",
  "BASED_NUMBER", "DEC_NUMBER", "REALTIME", "K_LE", "K_GE", "K_EG", "K_EQ",
  "K_NE", "K_CEQ", "K_CNE", "K_LS", "K_RS", "K_RSS", "K_SG",
  "K_CONTRIBUTE", "K_PO_POS", "K_PO_NEG", "K_POW", "K_PSTAR", "K_STARP",
  "K_LOR", "K_LAND", "K_NAND", "K_NOR", "K_NXOR", "K_TRIGGER",
  "K_edge_descriptor", "K_always", "K_and", "K_assign", "K_begin", "K_buf",
  "K_bufif0", "K_bufif1", "K_case", "K_casex", "K_casez", "K_cmos",
  "K_deassign", "K_default", "K_defparam", "K_disable", "K_edge", "K_else",
  "K_end", "K_endcase", "K_endfunction", "K_endmodule", "K_endprimitive",
  "K_endspecify", "K_endtable", "K_endtask", "K_event", "K_for", "K_force",
  "K_forever", "K_fork", "K_function", "K_highz0", "K_highz1", "K_if",
  "K_ifnone", "K_initial", "K_inout", "K_input", "K_integer", "K_join",
  "K_large", "K_macromodule", "K_medium", "K_module", "K_nand",
  "K_negedge", "K_nmos", "K_nor", "K_not", "K_notif0", "K_notif1", "K_or",
  "K_output", "K_parameter", "K_pmos", "K_posedge", "K_primitive",
  "K_pull0", "K_pull1", "K_pulldown", "K_pullup", "K_rcmos", "K_real",
  "K_realtime", "K_reg", "K_release", "K_repeat", "K_rnmos", "K_rpmos",
  "K_rtran", "K_rtranif0", "K_rtranif1", "K_scalared", "K_small",
  "K_specify", "K_specparam", "K_strong0", "K_strong1", "K_supply0",
  "K_supply1", "K_table", "K_task", "K_time", "K_tran", "K_tranif0",
  "K_tranif1", "K_tri", "K_tri0", "K_tri1", "K_triand", "K_trior",
  "K_trireg", "K_vectored", "K_wait", "K_wand", "K_weak0", "K_weak1",
  "K_while", "K_wire", "K_wor", "K_xnor", "K_xor", "K_Shold",
  "K_Snochange", "K_Speriod", "K_Srecovery", "K_Ssetup", "K_Ssetuphold",
  "K_Sskew", "K_Swidth", "KK_attribute", "K_bool", "K_logic",
  "K_automatic", "K_endgenerate", "K_generate", "K_genvar", "K_localparam",
  "K_noshowcancelled", "K_pulsestyle_onevent", "K_pulsestyle_ondetect",
  "K_showcancelled", "K_signed", "K_unsigned", "K_Sfullskew", "K_Srecrem",
  "K_Sremoval", "K_Stimeskew", "K_cell", "K_config", "K_design",
  "K_endconfig", "K_incdir", "K_include", "K_instance", "K_liblist",
  "K_library", "K_use", "K_wone", "K_uwire", "K_always_comb",
  "K_always_ff", "K_always_latch", "K_assert", "K_abs", "K_abstol",
  "K_access", "K_acos", "K_acosh", "K_analog", "K_asin", "K_asinh",
  "K_atan", "K_atan2", "K_atanh", "K_ceil", "K_continuous", "K_cos",
  "K_cosh", "K_ddt_nature", "K_discipline", "K_discrete", "K_domain",
  "K_enddiscipline", "K_endnature", "K_exclude", "K_exp", "K_floor",
  "K_flow", "K_from", "K_ground", "K_hypot", "K_idt_nature", "K_inf",
  "K_ln", "K_log", "K_max", "K_min", "K_nature", "K_potential", "K_pow",
  "K_sin", "K_sinh", "K_sqrt", "K_string", "K_tan", "K_tanh", "K_units",
  "K_TAND", "'?'", "':'", "'|'", "'^'", "'&'", "'<'", "'>'", "'+'", "'-'",
  "'*'", "'/'", "'%'", "UNARY_PREC", "less_than_K_else", "'('", "','",
  "'='", "';'", "')'", "'#'", "'.'", "'@'", "'~'", "'!'", "'{'", "'}'",
  "'['", "']'", "'0'", "'1'", "'x'", "'b'", "'f'", "'F'", "'l'", "'h'",
  "'B'", "'r'", "'R'", "'M'", "'n'", "'N'", "'p'", "'P'", "'Q'", "'q'",
  "'_'", "$accept", "main", "source_file", "number", "real_or_realtime",
  "attribute_list_opt", "attribute_instance_list", "attribute_list",
  "attribute", "block_item_decl", "block_item_decls",
  "block_item_decls_opt", "case_item", "case_items", "charge_strength",
  "charge_strength_opt", "defparam_assign", "defparam_assign_list",
  "delay1", "delay3", "delay3_opt", "delay_value_list", "delay_value",
  "delay_value_simple", "description", "optional_semicolon",
  "discipline_declaration", "$@1", "discipline_items", "discipline_item",
  "nature_declaration", "$@2", "nature_items", "nature_item",
  "config_declaration", "lib_cell_identifiers",
  "list_of_config_rule_statements", "config_rule_statement", "opt_config",
  "lib_cell_id", "list_of_libraries", "drive_strength",
  "drive_strength_opt", "dr_strength0", "dr_strength1", "event_control",
  "event_expression_list", "event_expression", "branch_probe_expression",
  "expression", "expr_mintypmax", "expression_list_with_nuls",
  "expression_list_proper", "expr_primary", "function_item_list",
  "function_item", "gate_instance", "gate_instance_list", "gatetype",
  "switchtype", "hierarchy_identifier", "list_of_identifiers",
  "list_of_port_identifiers", "list_of_ports", "list_of_port_declarations",
  "port_declaration", "net_type_opt", "signed_opt", "lpvalue",
  "cont_assign", "cont_assign_list", "module", "$@3", "$@4",
  "module_start", "module_attribute_foreign", "module_port_list_opt",
  "module_parameter_port_list_opt", "module_parameter_port_list",
  "module_item", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12",
  "$@13", "automatic_opt", "generate_if", "generate_case_items",
  "generate_case_item", "$@14", "$@15", "module_item_list",
  "module_item_list_opt", "generate_block", "generate_block_opt",
  "net_decl_assign", "net_decl_assigns", "primitive_type",
  "primitive_type_opt", "net_type", "var_type", "parameter_assign_decl",
  "$@16", "$@17", "$@18", "$@19", "$@20", "parameter_assign_list",
  "parameter_assign", "parameter_value_ranges_opt",
  "parameter_value_ranges", "parameter_value_range",
  "value_range_expression", "from_exclude", "localparam_assign",
  "localparam_assign_decl", "$@21", "$@22", "$@23", "$@24", "$@25",
  "localparam_assign_list", "parameter_value_opt",
  "parameter_value_byname", "parameter_value_byname_list", "port",
  "port_opt", "port_reference", "port_reference_list", "port_name",
  "port_name_list", "port_type", "range", "range_opt", "dimensions_opt",
  "dimensions", "function_range_or_type_opt", "register_variable",
  "register_variable_list", "real_variable", "real_variable_list",
  "net_variable", "net_variable_list", "specify_item", "specify_item_list",
  "specify_edge_path_decl", "edge_operator", "specify_edge_path",
  "polarity_operator", "specify_simple_path_decl", "specify_simple_path",
  "specify_path_identifiers", "specparam", "specparam_list",
  "spec_polarity", "spec_reference_event", "edge_descriptor_list",
  "spec_notifier_opt", "spec_notifier", "statement", "$@26", "$@27",
  "statement_list", "statement_or_null", "analog_statement", "task_item",
  "reg_opt", "task_port_item", "task_item_list", "task_item_list_opt",
  "task_port_decl", "task_port_decl_list", "udp_body", "$@28",
  "udp_entry_list", "udp_comb_entry", "udp_comb_entry_list",
  "udp_sequ_entry_list", "udp_sequ_entry", "udp_initial", "udp_init_opt",
  "udp_input_list", "udp_input_sym", "udp_output_sym", "udp_port_decl",
  "udp_port_decls", "udp_port_list", "udp_reg_opt", "udp_initial_expr_opt",
  "udp_input_declaration_list", "udp_primitive", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,    63,    58,   124,    94,    38,    60,
      62,    43,    45,    42,    47,    37,   479,   480,    40,    44,
      61,    59,    41,    35,    46,    64,   126,    33,   123,   125,
      91,    93,    48,    49,   120,    98,   102,    70,   108,   104,
      66,   114,    82,    77,   110,    78,   112,    80,    81,   113,
      95
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   271,   272,   272,   273,   273,   274,   274,   274,   275,
     275,   276,   276,   277,   277,   277,   277,   278,   278,   279,
     279,   280,   280,   280,   280,   280,   280,   280,   280,   280,
     280,   280,   280,   280,   280,   280,   280,   281,   281,   282,
     282,   283,   283,   283,   283,   284,   284,   285,   285,   285,
     286,   286,   287,   288,   288,   288,   289,   289,   290,   290,
     290,   290,   291,   291,   292,   292,   293,   293,   294,   294,
     294,   295,   295,   295,   295,   295,   295,   296,   296,   298,
     297,   299,   299,   300,   300,   300,   300,   302,   301,   303,
     303,   304,   304,   304,   304,   304,   305,   306,   306,   307,
     307,   308,   308,   308,   308,   308,   309,   309,   310,   310,
     311,   311,   312,   312,   312,   312,   312,   312,   313,   313,
     314,   314,   314,   314,   315,   315,   315,   315,   316,   316,
     316,   317,   317,   317,   318,   318,   318,   319,   319,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   321,   321,   322,   322,   322,   322,   323,   323,   324,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   325,   325,   326,   326,   327,   327,
     327,   327,   327,   327,   327,   327,   328,   328,   329,   329,
     329,   329,   329,   329,   329,   329,   329,   329,   329,   329,
     330,   330,   330,   330,   330,   330,   330,   330,   330,   330,
     330,   330,   331,   331,   331,   331,   331,   331,   332,   332,
     333,   333,   333,   333,   334,   334,   335,   335,   335,   335,
     335,   336,   336,   336,   336,   336,   337,   337,   338,   338,
     339,   339,   340,   341,   341,   343,   344,   342,   345,   345,
     346,   346,   347,   347,   347,   348,   348,   349,   349,   349,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   350,   350,   350,
     350,   350,   350,   351,   350,   352,   350,   353,   350,   350,
     354,   350,   355,   350,   350,   350,   350,   356,   350,   357,
     350,   350,   358,   350,   350,   359,   350,   350,   350,   350,
     350,   350,   350,   350,   350,   350,   350,   360,   360,   361,
     362,   362,   364,   363,   365,   363,   366,   366,   367,   367,
     368,   368,   368,   369,   369,   370,   371,   371,   372,   372,
     372,   373,   373,   374,   374,   374,   374,   374,   374,   374,
     374,   374,   374,   374,   374,   375,   376,   377,   376,   378,
     376,   379,   376,   380,   376,   381,   376,   382,   382,   383,
     384,   384,   385,   385,   386,   386,   386,   386,   386,   387,
     387,   387,   387,   388,   388,   389,   390,   391,   390,   392,
     390,   393,   390,   394,   390,   395,   390,   396,   396,   397,
     397,   397,   397,   397,   398,   398,   399,   399,   400,   400,
     400,   400,   401,   401,   402,   402,   402,   402,   403,   403,
     404,   404,   404,   405,   405,   406,   406,   406,   407,   408,
     408,   409,   409,   410,   410,   411,   411,   411,   411,   411,
     411,   411,   412,   412,   413,   413,   414,   414,   415,   415,
     416,   417,   417,   418,   418,   418,   418,   418,   418,   418,
     418,   418,   418,   418,   418,   418,   418,   418,   418,   418,
     418,   418,   418,   418,   418,   418,   418,   419,   419,   420,
     420,   421,   421,   422,   422,   422,   422,   423,   423,   423,
     424,   424,   424,   425,   425,   425,   426,   426,   426,   426,
     427,   427,   427,   427,   428,   428,   429,   429,   429,   430,
     430,   430,   430,   430,   430,   430,   430,   431,   431,   432,
     432,   433,   433,   433,   433,   433,   434,   434,   434,   434,
     434,   435,   434,   434,   434,   434,   436,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   437,   437,   438,   438,   439,   440,   440,   441,
     441,   442,   442,   442,   442,   442,   442,   442,   442,   442,
     442,   442,   442,   443,   443,   444,   444,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   446,
     446,   446,   446,   446,   448,   447,   449,   449,   450,   451,
     451,   452,   452,   453,   454,   455,   455,   456,   456,   457,
     457,   457,   457,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   457,   457,   457,   457,   457,   457,   457,   457,
     457,   457,   458,   458,   458,   458,   459,   459,   459,   459,
     460,   460,   461,   461,   462,   462,   463,   463,   464,   464,
     465,   465
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     0,     1,     2,     1,     1,     2,     1,
       1,     1,     0,     2,     3,     3,     4,     3,     1,     1,
       3,     7,     6,     4,     4,     4,     4,     3,     3,     3,
       4,     4,     4,     4,     4,     3,     3,     1,     2,     1,
       0,     3,     3,     2,     3,     2,     1,     3,     3,     3,
       1,     0,     3,     1,     2,     3,     2,     4,     2,     4,
       6,     8,     1,     0,     1,     3,     1,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     8,     1,     0,     0,
       6,     2,     1,     3,     3,     3,     3,     0,     6,     2,
       1,     4,     4,     4,     4,     4,     8,     0,     2,     0,
       2,     4,     5,     6,     5,     6,     0,     2,     1,     3,
       0,     2,     5,     5,     5,     5,     5,     5,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     4,
       4,     1,     3,     3,     2,     2,     1,     6,     4,     1,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       5,     1,     5,     3,     1,     0,     2,     3,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     4,
       4,     4,     6,     4,     4,     4,     4,     4,     6,     4,
       4,     6,     4,     4,     4,     4,     4,     4,     6,     6,
       3,     3,     6,     7,     1,     2,     1,     1,     4,     5,
       3,     2,     4,     5,     4,     5,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     4,     6,     6,     6,     1,     3,
       1,     3,     3,     5,     1,     3,     1,     3,     3,     2,
       2,     6,     6,     6,     6,     8,     1,     0,     1,     0,
       1,     3,     3,     3,     1,     0,     0,    11,     1,     1,
       8,     0,     3,     3,     0,     0,     4,     2,     3,     4,
       8,     8,     7,     6,     6,     6,     6,     6,     6,     6,
       3,     1,     3,     4,     5,     5,     6,     4,     5,     3,
       3,     6,     8,     8,     6,     8,     8,     5,     5,     5,
       3,     3,     3,     0,     8,     0,    11,     0,    10,     5,
       0,     9,     0,    12,     6,     3,     3,     0,    14,     0,
       5,     2,     0,     7,     5,     0,     8,     2,     3,     3,
       3,     2,     5,     3,     3,     9,     5,     1,     0,     4,
       2,     1,     0,     4,     0,     4,     2,     1,     1,     0,
       1,     3,     5,     1,     1,     3,     3,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     3,     0,
       4,     0,     3,     0,     3,     0,     3,     1,     3,     4,
       1,     0,     2,     1,     6,     6,     6,     6,     2,     1,
       1,     2,     2,     1,     1,     3,     1,     0,     3,     0,
       4,     0,     3,     0,     3,     0,     3,     1,     3,     4,
       4,     2,     2,     0,     5,     4,     1,     3,     1,     5,
       3,     7,     1,     0,     1,     6,     4,     4,     1,     3,
       5,     5,     4,     3,     1,     1,     1,     1,     5,     1,
       0,     0,     1,     5,     6,     1,     2,     1,     1,     1,
       1,     0,     2,     3,     1,     3,     2,     3,     1,     3,
       2,     1,     3,     3,     2,     2,     6,     6,     3,     3,
      12,    10,    12,     8,    10,    12,    10,    10,    12,    10,
      10,    10,     7,     3,     3,     3,     3,     1,     2,     5,
       3,     1,     1,    10,    11,    10,    11,     1,     1,     1,
       5,     3,     5,     6,     6,     3,     1,     4,     3,     6,
       3,     7,     3,     7,     1,     3,     1,     1,     0,     2,
       2,     4,     4,     5,     7,     3,     1,     3,     1,     0,
       1,     1,     2,     2,     3,     1,     5,     3,     5,     3,
       3,     0,     7,     2,     4,     3,     0,     7,     2,     4,
       3,     3,     2,     3,     5,     6,     6,     6,     6,     6,
       6,     5,     7,     5,     7,    13,    11,    13,     5,     5,
       5,     2,     3,     4,     6,     4,     4,     4,     4,     5,
       5,     5,     9,     5,     9,     5,     5,     2,     5,     4,
       2,     2,     2,     1,     1,     1,     4,     1,     1,     1,
       0,     6,     6,     6,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     2,     1,     1,     0,     5,     5,     5,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       1,     3,     2,     2,     0,     4,     1,     1,     4,     1,
       2,     1,     2,     6,     5,     1,     0,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     4,
       1,     2,     1,     3,     1,     0,     2,     0,     2,     4,
      10,    13
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
      12,     0,     0,     0,     0,     0,     0,     0,    12,     0,
      11,     4,    75,    74,    73,    71,    72,    19,    13,     0,
      18,     0,     0,     0,    78,    78,     1,     5,   299,   298,
       0,     0,     0,    14,     0,     0,     0,     0,    77,    79,
      87,   295,    15,     0,   262,   192,   191,     6,     7,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   189,    20,   139,   193,
      17,   732,   735,     0,     0,    97,     0,     0,   305,    16,
       0,     8,   150,   151,   152,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   145,
     154,   146,   143,   140,   141,   181,     0,     0,     0,     0,
     142,   153,   144,   188,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   734,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,    90,     0,   304,   188,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   220,   148,   149,   147,     0,     0,   221,   174,   175,
     172,   176,   173,   177,   169,   170,   171,   156,   178,   179,
     164,   165,   166,     0,   163,   155,   162,   167,   168,   160,
     161,   157,   158,   159,     0,   263,     0,   737,   733,     0,
       0,   108,    99,    98,     0,     0,     0,     0,    80,    81,
       0,     0,     0,     0,     0,    88,    89,     0,    12,   301,
     195,   217,   196,   197,   198,   199,   200,     0,   201,   203,
     204,   205,   206,   207,     0,   209,   210,     0,     0,     0,
     212,   213,   214,   215,   216,     0,     0,   187,     0,   194,
       0,     0,     0,   264,     0,     0,     0,     0,     0,   730,
     696,     0,     0,     0,    84,    83,    86,    85,     0,     0,
       0,     0,     0,     0,     0,   474,     0,     0,     0,     0,
       0,   276,   472,   274,   468,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   180,     0,     0,     0,   736,     0,
     268,     0,     0,     0,     0,     0,   695,     0,   731,    76,
     109,     0,     0,    96,     0,   100,    92,    93,    95,    94,
      91,     0,   307,     0,   306,     0,     0,   478,     0,   287,
     287,   287,   473,   302,    12,   280,   303,     0,   296,   202,
     208,   218,   219,   211,   182,     0,   222,   266,   267,   265,
       0,     0,     0,   726,   727,   728,     0,     0,   684,     0,
     110,     0,     0,     0,     0,   308,     0,     0,     0,     0,
     470,   406,   410,   404,   409,   405,   408,   412,   407,   403,
     411,   413,   414,   289,   286,   289,   415,   289,   289,   275,
     278,   277,     0,     0,   223,   738,     0,     0,   269,   729,
       0,     0,   740,     0,   110,     0,   110,     0,   431,   309,
     477,     0,   476,     0,     0,   479,   288,   490,   490,   490,
     490,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   487,   485,     0,   486,     0,     0,     0,     0,   378,
      51,     0,     0,     0,     0,     0,   321,   387,     0,     0,
       0,   289,     0,     0,     0,   702,   721,   704,   705,   699,
     700,   701,   703,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   716,   717,   718,   719,   720,     0,   689,
     686,   687,   691,     0,   697,   111,   101,     0,   106,     0,
     106,   444,   443,   429,   430,   433,     0,     0,     0,   469,
       0,   489,     0,     0,     0,     0,     0,   371,     0,     0,
       0,   118,    63,     0,    53,     0,     0,     0,     0,     0,
       0,   377,   501,     0,   289,   289,     0,   289,     0,   421,
       9,    10,   423,     0,   425,     0,   416,   427,   417,     0,
     185,   237,     0,   185,     0,     0,   367,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   537,     0,     0,
       0,     0,     0,     0,     0,    50,   490,     0,     0,     0,
       0,     0,     0,   451,   453,     0,   455,   457,     0,   446,
     447,   463,     0,   238,   244,   245,   246,   254,     0,     0,
     239,   250,   241,   247,   248,   249,   240,   252,   255,     0,
       0,     0,   251,   253,   257,   260,   261,     0,   256,   258,
     259,   243,   242,     0,     0,     0,   402,     0,   394,   390,
     393,   361,   386,   297,   490,   289,   739,     0,   694,   685,
     690,     0,   692,     0,     0,   698,   104,     0,     0,   102,
       0,   438,   432,     0,     0,   475,     0,     0,   282,   281,
     283,   284,     0,   320,     0,   373,     0,     0,   122,   126,
     121,   125,   120,   124,   123,   127,     0,     0,     0,    62,
       0,     0,     0,   322,     0,    54,    27,     0,   374,   497,
     498,   499,   500,     0,   495,     0,     0,   490,   490,   370,
     490,    35,     0,     0,   419,     0,    28,     0,     0,     0,
     231,     0,     0,   184,     0,     0,   330,     0,     0,   329,
     369,     0,     0,     0,     0,     0,   564,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   556,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   542,   541,     0,   568,
     368,   538,   515,     0,   514,     0,     0,     0,     0,     0,
      63,     0,     0,     0,     0,   355,   356,    36,     0,     0,
       0,   449,     0,    29,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    12,   290,     0,   340,   341,     0,   491,   504,     0,
       0,   491,   508,     0,     0,     0,     0,   400,   399,   398,
     401,   289,     0,     0,     0,     0,   342,   185,     0,     0,
       0,   185,     0,     0,   289,     0,     0,   359,    63,   490,
     741,     0,     0,   725,   699,   700,   701,     0,     0,   107,
     105,   103,   440,     0,     0,   439,     0,     0,   471,     0,
       0,     0,     0,     0,     0,     0,     0,    70,    68,    69,
       0,    58,   290,     0,   294,     0,   362,    55,    52,     0,
     496,     0,   379,     0,     0,     0,   422,   424,     0,   426,
     428,   418,     0,     0,     0,   484,     0,     0,     0,     0,
       0,   186,   230,   236,     0,     0,     0,     0,   519,   518,
       0,     0,     0,   513,     0,     0,     0,   576,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   536,   533,
     534,   535,     0,     0,     0,     0,   555,   568,   566,   567,
       0,     0,   540,     0,   551,     0,   345,   343,    49,    48,
      47,     0,     0,     0,   365,     0,   445,   452,   454,     0,
     456,   458,   448,   462,   461,   185,     0,     0,     0,     0,
     641,   185,   637,     0,     0,     0,   593,     0,   643,     0,
       0,     0,     0,     0,     0,     0,     0,   602,   598,     0,
       0,     0,     0,     0,     0,     0,     0,    56,    12,     0,
     128,     0,   645,   644,   621,     0,     0,   640,     0,     0,
      31,     0,     0,   502,   492,     0,    23,    33,     0,   506,
       0,    25,    34,    26,    30,     0,    32,    24,     0,     0,
       0,     0,     0,   323,     0,   327,   490,     0,   391,     0,
       0,     0,   722,   723,   724,     0,   688,   441,   442,     0,
       0,     0,   285,   300,   372,     0,     0,     0,     0,     0,
       0,     0,    66,     0,     0,   339,     0,     0,     0,   350,
       0,     0,     0,   270,     0,   420,   234,     0,   228,     0,
     232,     0,     0,     0,     0,     0,     0,   183,     0,     0,
       0,     0,   560,     0,   562,   565,     0,   570,   139,   569,
     139,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   558,     0,     0,     0,     0,     0,     0,     0,     0,
      64,     0,     0,   349,     0,     0,   666,     0,   376,     0,
       0,   364,   450,     0,     0,   466,     0,   338,   337,     0,
       0,     0,   601,     0,   595,   591,   590,   642,     0,     0,
       0,   587,   600,     0,     0,     0,   596,   603,     0,     0,
     589,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   131,   136,   291,   622,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   503,     0,     0,
     505,   507,   509,     0,     0,     0,     0,   324,     0,   325,
     328,     0,    63,     0,   360,     0,     0,     0,     0,     0,
       0,   488,   117,   116,   114,   112,   115,   113,     0,    59,
       0,   292,   293,     0,     0,     0,   381,     0,   354,    12,
       0,   318,   317,     0,     0,   316,     0,   483,   235,   229,
     233,     0,   334,     0,     0,     0,   331,     0,     0,     0,
     181,   578,     0,     0,     0,   575,     0,     0,   579,     0,
       0,     0,     0,     0,   557,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   539,   552,   550,
     347,   650,   650,   650,   680,     0,   650,   650,   650,     0,
     647,   664,   648,   665,     0,   313,     0,     0,     0,   459,
       0,   460,   628,   626,     0,     0,   594,    40,     0,     0,
       0,     0,     0,     0,   599,    40,     0,     0,     0,     0,
       0,     0,    57,   623,   130,   135,   134,    12,     0,     0,
     129,   639,     0,     0,     0,     0,     0,   627,     0,     0,
       0,   625,     0,     0,     0,    22,     0,   138,   646,   326,
       0,   397,     0,     0,   392,   319,   314,   315,   693,   437,
     436,   435,   434,     0,     0,   384,   382,   363,   380,     0,
     227,     0,   224,   226,     0,   271,   272,     0,   482,     0,
       0,     0,     0,     0,   517,   516,     0,     0,     0,     0,
     572,   571,     0,     0,   585,   581,     0,   580,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   553,     0,   554,    65,    40,     0,   649,     0,
       0,   289,     0,     0,     0,   289,     0,     0,     0,   289,
     682,   683,     0,     0,     0,     0,   289,     0,     0,     0,
     289,     0,     0,     0,   289,   663,     0,     0,     0,     0,
     467,   636,   586,    37,    39,     0,     0,     0,    46,     0,
       0,     0,     0,     0,     0,   618,     0,   588,     0,   613,
     611,   604,   635,   620,   619,     0,   132,   133,   638,     0,
     630,   633,     0,   629,   631,     0,     0,    21,     0,     0,
       0,   312,   491,     0,   511,     0,     0,    60,     0,     0,
       0,     0,   225,     0,     0,     0,   481,   480,   336,   335,
     333,   332,     0,     0,   577,   573,   579,     0,   582,     0,
     583,   579,   579,     0,   579,   579,   532,   559,     0,     0,
     579,   579,     0,     0,   547,   548,   549,     0,     0,     0,
     672,   675,   678,   490,   670,   673,   676,   490,   671,   674,
     677,   490,   681,   679,    40,     0,     0,     0,   490,     0,
       0,     0,   490,     0,     0,     0,   490,   344,     0,   366,
     465,     0,    38,     0,   608,     0,     0,    43,     0,   605,
      45,     0,   609,   606,   610,   607,     0,     0,     0,     0,
     624,     0,     0,   493,     0,   137,   395,   396,   510,   311,
       0,   310,     0,    67,   385,   383,     0,   351,    40,   273,
     561,   563,     0,     0,     0,   523,   584,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   656,   659,   662,     0,   654,
     657,   660,     0,   655,   658,   661,     0,   375,   464,   592,
      44,    42,    41,     0,     0,   597,   614,   612,     0,     0,
     494,   491,   512,    61,     0,     0,   574,     0,   579,     0,
       0,   579,     0,     0,   579,   579,     0,     0,     0,     0,
       0,     0,   348,   669,   667,   668,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   521,     0,   524,   527,
       0,   529,   531,     0,     0,   526,   530,     0,     0,   543,
     545,   346,   653,   651,   652,     0,     0,     0,   634,   632,
     357,   353,     0,     0,     0,     0,   544,   546,     0,     0,
       0,     0,   522,   528,   520,   525,     0,   616,     0,   358,
       0,     0,   617,   615
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     7,     8,    86,   594,   505,    10,    19,    20,   506,
    1514,  1515,  1518,  1519,   635,   636,   574,   575,   860,   739,
     740,  1179,  1180,   931,    11,    39,    12,    96,   183,   184,
      13,    97,   190,   191,    14,   179,   323,   375,   708,   263,
     463,   571,   572,   736,   737,   861,  1231,  1232,   885,  1122,
     136,   774,  1520,    88,  1431,  1432,   601,   602,   684,   685,
      89,   361,  1134,   339,   340,   341,   443,   477,   863,   934,
     935,    15,    98,   453,    30,   346,   279,   193,   334,   507,
    1186,  1185,  1476,  1289,  1130,  1791,  1099,  1126,  1190,   582,
     508,  1285,  1286,  1560,  1559,   509,   510,   690,   691,  1411,
    1412,   880,   881,   444,   448,   595,   768,   948,   762,   763,
     765,   596,   597,   553,   554,   555,   916,   556,   647,   648,
     835,  1019,   829,   830,   832,   649,   837,  1195,  1196,   342,
     343,   344,   388,   955,   956,   511,   561,   562,  1658,  1074,
     755,   868,   869,   872,   873,  1554,  1555,   627,   628,   629,
     808,   630,  1597,   631,   632,   797,   786,   787,  1000,   978,
    1312,  1456,  1457,  1063,  1367,  1375,  1039,  1064,   886,  1351,
    1481,  1352,  1353,  1354,  1344,  1345,   419,   461,   538,   539,
     540,   541,   542,   366,   367,   543,   544,   908,   319,   320,
      93,   175,   315,   411,    16
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1329
static const yytype_int16 yypact[] =
{
     476,   175,    67,  -127,   236,   293,   345,   363,   935,   139,
     367, -1329, -1329, -1329, -1329, -1329, -1329,   168, -1329,    14,
   -1329,   184,   455,   239,   254,   254, -1329, -1329, -1329, -1329,
     503,   182,  5313, -1329,   554,   237,   310,   405, -1329, -1329,
   -1329, -1329, -1329,    17, -1329,   356, -1329, -1329,   595, -1329,
    5844,  5844,  5844,   385,   435,   477,   487,   500,   518,   525,
     532,   538,   549,   555,   561,   567,   574,   604,   632,   645,
     658,   720,   747,   775,   786,   790,   818,  5844,  1460,  5844,
    5844,  5844,  5313,   763,  3529,  5313, -1329, 10310, -1329,   260,
   -1329, -1329,   737,   370,   812, -1329,   203,   822,   704, -1329,
    5313, -1329, -1329, -1329, -1329,  5313,  5313,  5313,  5313,  5313,
    5313,  5313,  5313,  5313,  5313,  5313,  5313,  5313,  5313,  5313,
    5313,  5313,  5313,  5313,  5313,  5313,  5313,  5313,  5313, -1329,
   -1329, -1329, -1329, -1329, -1329,  9874,   825,  5844,  5844,  5844,
   -1329, -1329, -1329,  6212,   233,  5313,  5313,  5313,  5313,  5313,
    5313,  5313,  5313,  5313,  5313,  5313,  5313,  5313,  5313,  5313,
    5313,  5313,  5313,  5313,  5313,  5313,  5313,  5313,  5313,  5313,
    5313,  5313,  1087,  5313, -1329,  1093,  1100,   838,   888,    30,
     378,  1125,  1166,   588, -1329,   891,   899,   953,   965,   970,
     760, -1329,   930,   982, 10310,   615,  6058,  6293,  6315,  6337,
    6359,  6381,  9195,  6403,  6468,  6632,  6654,  6697,  6719,  9217,
    6741,  6763,  9239,  9261,  9337,  6785,  6807,  6883,  7036,  7058,
    5313, -1329, -1329, -1329, -1329,  5313,  5313, -1329,   422,   422,
     617,   617,   617,   617,   217,   217,   217, -1329,   688,  1490,
     599,  3846,  3846,  9901,  1314,  3846,   599,   422,   422,   232,
     232,  1203,  1203,  1203,   619, -1329,  1370,   996, -1329,   427,
    1224,   993, -1329, -1329,  1000,  1001,  1005,  1008, -1329, -1329,
    5313,  1251,  1256,  1259,  1268, -1329, -1329,  1191,   150,  1254,
   -1329, -1329, -1329, -1329, -1329, -1329, -1329,  5313, -1329, -1329,
   -1329, -1329, -1329, -1329,  5313, -1329, -1329,  5313,  5313,  5313,
   -1329, -1329, -1329, -1329, -1329,  9923,   297, 10310,  5313, -1329,
    5313,  5313,  5313, -1329,  5313,  1048,  1289,  1292,   243, -1329,
     994,  1054,  1299,   324, -1329, -1329, -1329, -1329,  8335,  1062,
    1067,  1086,  1094,  1339,   718,  1097,  1345,  1357,   501,   791,
     650, -1329, -1329, -1329, -1329,  1361,  1127,  7112,  7134,  7156,
    7178,  7200,  5313,    26, 10310,  4084,  4413,  4762, 10310,  1306,
   -1329,   452,  1138,  1142,  1388,  1394, -1329,  1305, -1329, -1329,
   -1329,  1258,  1429, -1329,  1431, -1329, -1329, -1329, -1329, -1329,
   -1329,  1195, -1329,   180, -1329,  2836,  1199, -1329,   342,  1110,
    1110,  1176,    25, -1329,   142, -1329, -1329,  1365, -1329, -1329,
   -1329, -1329, -1329, -1329, 10310,  1190, -1329, -1329, -1329, -1329,
    1437,   793,  1438, -1329, -1329, -1329,  1201,  1205, -1329,  1395,
   -1329,   622,   225,  5313,  1339, -1329,  1206,   647,    49,  1357,
   -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329,
   -1329, -1329, -1329,  1293, -1329,  1293, -1329,  1293,  1293, -1329,
   -1329, -1329,  1449, 10803, -1329, -1329,  1386,  1218, -1329, -1329,
     638, 10159, -1329,    59, -1329,  1429, -1329,  1429,  9850, -1329,
   -1329,  5313, -1329,  1357,  1220, -1329, -1329,  1216,  1216,  1216,
    1216,  1227,  1232,  1289,    56,  1236,    31,  1289,  1237,   229,
    1238,  1379,  1379,  1478,  1379,   106,    36,   109,  2200,  1332,
    1244,  1245, 10663,  1289,   211, 11191, -1329, -1329,  6065, 10523,
    1430,  1837,  1481,  1305,  1247, -1329, -1329, -1329, -1329, -1329,
   -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329,
   -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329,  1428, -1329,
   10159, 10159, -1329,  2855, -1329, -1329, -1329,   101,  1264,   102,
    1264,  5544, -1329, -1329,   330, -1329,    20,  4876,   343, -1329,
    5313, -1329,  1488,  1491,  1492,  1493,  1494, -1329,   490,   507,
     466, -1329,  1250,  5313, -1329,   572,   130,  1431,   596,  1495,
    1443, -1329,   380,  5313,  1293,  1293,  1262,  1293,  1270, -1329,
   -1329, -1329, -1329,  1216, -1329,  1271,  1261, -1329, -1329,   206,
    4157, -1329,   624,  4157,   667,  1456, -1329,  1278,  1280,   583,
    1285,  1286,  1287,  1290,  1291,  1294,  1296,  1297,  1524,  1524,
    1524,  1524,  1298,  1300,  1301,  1312,   348, -1329,  2576,  1310,
    1313,  1311,  1315,  1527,   475, -1329,  1216,   991,  9547,  1382,
     685,  1318,  1320, -1329, -1329,  1216, -1329, -1329,  1323,  1328,
   -1329,  1325,  3960, -1329, -1329, -1329, -1329, -1329,  3960,   997,
   -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329,  1017,
    1042,    64, -1329, -1329, -1329, -1329, -1329,  1144, -1329, -1329,
   -1329, -1329, -1329,  1534,    34,    69,   362,  9703, -1329, -1329,
   -1329,  1518, -1329, -1329,  1216,  1293, -1329,  1514, -1329, -1329,
   -1329,  3337, -1329,  9251, 10112, -1329, -1329,  1407,  1331, -1329,
    1333, 10310, -1329,  4737,  4737, -1329,  1334,  9945, -1329, -1329,
   -1329,  1335,  1336, -1329,  5313, -1329,  1340,  1341, -1329, -1329,
   -1329, -1329, -1329, -1329, -1329, -1329,  1342,  1343,   172, -1329,
      55,  7222,  1431, -1329,  5313, -1329, -1329,  1338, -1329, -1329,
   -1329, -1329, -1329,  1216, -1329,  1570,  7287,  1216,  1216, -1329,
    1216, -1329,  1339,  1339, -1329,  1339, -1329,  1339,  1339,  1553,
    1348,   799,  1349, 10310,   819,   163, -1329,  1350,   826, -1329,
   -1329,  5313,  1346,  1351,  1353,  1367, -1329,   933,  5625,  5625,
    5625,  5625,  5625,  5625,  5625,  5625,  1358,   936,   937,   940,
     941,  5625,  5625,  5625,  5625,  1368, -1329, -1329,  1524,   495,
   -1329, -1329, -1329,   186, -1329,   198,    96,  1369,  1371,  1373,
    1250,  1374,  1352,  1587,  1557, -1329, -1329, -1329,  5313,  1609,
    1609, -1329,  1609, -1329,  1609,  1609,    60,   107,   135,   725,
    1431,    55,  3722,  1380,  1384,  1385,    55,  1431,  1387,    55,
    3960,  3769,  1390,    55,  1399,  1400,  1403,   219,   149,  5313,
    2386,  1591,   560,    52, -1329, -1329,  1383,   355, -1329,   948,
    1391,   447, -1329,   951,  1392,   959,  1410, -1329, -1329, -1329,
   -1329,  1293,  1418,   962,  1406,  1598, -1329,  4027,   163,    69,
     963,  5313,   163,   977,  1293,  1623,  1608, -1329,  1250,  1216,
   -1329,   291, 10159, -1329,  1422,  1423,  1424,  1442,  1427, -1329,
   -1329, -1329, -1329,  5679,  5774, 10310,  1454,  1457, -1329,  5313,
    5313,  1647,  8357,   529,   598,   473,   798, -1329, -1329, -1329,
    5313, -1329,    91,  1444, -1329,   980, -1329, -1329, 10310,  5313,
   -1329,    98, -1329,  1289,  1289,  1680,  1261,  1261,  1339,  1261,
   -1329,  1261,  1446,  1682,   850, -1329,   856,  1626,   529,   163,
     598,  5313, -1329, -1329,   529,   598,   163,  7451, -1329, -1329,
    5313,  5430,   583, -1329,  1439,  5313,  5313,  1467,  1452,  1455,
    1463,  1464,  1468,  1470,  1471,  1472,  5844,  1690, -1329, -1329,
   -1329, -1329,  1473,  1474,  1475,  1476, -1329,   495, -1329, -1329,
     151,  5313, -1329,  3068, -1329,  1636,  1487, -1329, -1329, -1329,
   -1329,  1289,  1496,  1691, -1329,  1582, 10310,  1328,  1328,  1609,
    1328, -1329,  1328, -1329, -1329,  4851,  1503,   986,  5313,  5313,
   -1329,  5313, -1329,   559,  1507,   138, -1329,  1730, -1329,  1935,
    5313,  5313,  5313,  1508,   612,    37,  1510, -1329, -1329,  1731,
    2762,  3138,  1511,  5313,  5313,  3208,  5313, -1329,  1591,  1696,
      91,   484, -1329, -1329, -1329,  2386,  4968, -1329,  4275,  4388,
   -1329,  5313,  5313, -1329,  1498,  1748, -1329, -1329,  5313, -1329,
    1750, -1329, -1329, -1329, -1329,    40, -1329, -1329,  1754,  5313,
     999,   163,  1006, -1329,  1011, -1329,   265, 10943, -1329, 11083,
    1257,  1289, -1329, -1329, -1329,   291, -1329, -1329, -1329,  4737,
    4737,  5224, 10310, -1329, -1329,  1519,  1525,  1530,  1533,  1535,
    1536,   858,  9967,  5313,    55, -1329,  5082,  8379,  1706, -1329,
    1528,  1024,  1027,  1542,  1030,  1261, -1329,  1545, -1329,  1543,
   -1329,  1546,   862,   866,  1547,  1033,  1548, 10310,  1551,  1552,
    1037,  1280,  9989,  5313, 10310, -1329,  1762, 10310,  1575, 10310,
    1579,  5313,  5625,  5625,  5313,  5625,  5625,  5625,  5625,  5313,
    1555,  1554,  5625,  5625,  5625,  5625,   424,   167,   174,   868,
   -1329,  1561,   872, -1329,  1566,   614,  1957,  1047, -1329,  1571,
   10943, -1329,  1328,  1814,   893, -1329,   894, -1329, -1329,  8401,
    8423,   898, -1329,  5313, -1329,  1768, -1329, -1329,  7473,  7516,
    7538, -1329, -1329,  1580,  1581,  5313,  1749, -1329,  1583,  7560,
   -1329,  7582,  7604,  1584,  7626,  1588,  2386,  1589,  5313,  5313,
    1592,    83, -1329, 10310, -1329, -1329,  1599,   902,  1586,   177,
    5313,  5313,  8445,  1595,  5313,  5313,  8521, 10310, 10011,  5313,
   -1329, 10310, -1329,  1748,  1052,   904,  8673, -1329,  1072, -1329,
   -1329,  1826,  1250,  1787, -1329,  1604,  1075,  1076,  1607,    10,
     222, -1329, -1329, -1329, -1329, -1329, -1329, -1329,  5313, -1329,
    5313, 10310, -1329,  1624,   -34,  4506, -1329,  5313, -1329,   383,
     614, -1329, -1329,  5313,  1847, -1329,  2390, -1329, -1329, -1329,
   -1329,   163, -1329,   163,   163,   163, -1329,  1610,  1614,  5313,
    9173, -1329,   288,  5313,  5313, 10310,  1617,  1620,    99,  1621,
    1622,  1627,  1628,   922, -1329,  5844,  1630,  1632,  1637,  1638,
    1625,  1642,  1524,   923,  1524,   924,  5313, -1329, -1329, -1329,
   -1329,   535,   709,   724, -1329,   729,   787,   796,   889,   989,
   -1329, -1329, -1329,  1957,  2386, -1329,  1857,  1835,  1652, -1329,
    1648, -1329, -1329, -1329,  1650,  8695, -1329,   662,  2464,  2696,
    2766,  3960,  5313,  8749, -1329,   662,  2386,  2386,  3960,  2386,
    3960,  3960, -1329, -1329, -1329, 10310, 10310,  1591,  4620,  4620,
   -1329, -1329,  1653,  5313,  1944,  8771,  8793, -1329,  5313,  8815,
    8837, -1329,  5313, 10041,  1082, -1329,  1890, -1329, -1329, -1329,
    1655, -1329,  1083,  1893, -1329, -1329, -1329, -1329, -1329, -1329,
   -1329, -1329, -1329,   928, 10266, -1329, -1329, -1329, -1329,  8859,
   -1329,  3456, -1329, -1329,   773, 10310,  1659,  1658, -1329,  7702,
    1102,  1112,  1113,  1128, -1329, -1329, 10288,  5313,  1867,  5844,
   10310, 10310,  5313,  5313, -1329,  1431,  1661,  1665,  5313,  5313,
    5313,  5313,  5313,  1668,  1664,  5313,  5313,  5313,  5313,  1524,
    1524,   221, -1329,   221, -1329, -1329,   662,  1907, -1329,  1915,
    1916,  1293,  1917,  1918,  1922,  1293,  1923,  1927,  1928,  1293,
     429, -1329,  1692,  1289,  1289,  1289,  1293,  1289,  1289,  1289,
    1293,  1289,  1289,  1289,  1293, -1329,  1873,  1693,  1788,  5199,
   -1329, -1329, -1329, -1329,   662,  3960,    -7,  3841, -1329,  2017,
       8,    -5,  2088,    11,  2320, -1329,  8923, -1329,  3960,  1889,
    1895, -1329, -1329, -1329, -1329,  2386, -1329, -1329, -1329,  7855,
   -1329, -1329,  7877, -1329, -1329,  5338,  5313, -1329,  1699,  5313,
    1826, -1329,   474,  1132, -1329,  1135,  5313, -1329,  5313,  6065,
    6065,  1952, -1329,  1902,  1716,  5313, -1329, -1329, -1329, -1329,
   -1329, -1329,  5313,  7931, -1329,  1740,    99,  1725,    91,  1724,
    1431,    99,    99,  1728,    99,  6242, -1329, -1329,  1741,  1743,
      99,    99,   221,   221, -1329, -1329, -1329,  5313,  5313,  2386,
   -1329, -1329, -1329,  1216, -1329, -1329, -1329,  1216, -1329, -1329,
   -1329,  1216, -1329, -1329,   662,  1136,  1164,  1165,  1216,  1168,
    1169,  1172,  1216,  1173,  1177,  1178,  1216, -1329,  1744, -1329,
   -1329,  7953, -1329,  3134, -1329,  2386,  2386, -1329,  1761, -1329,
   -1329,  2386, -1329, -1329, -1329, -1329,  3440,  3888,  2386,  2386,
   -1329,  1745,  1745, -1329,  5681, -1329, 10310, -1329, -1329, -1329,
    1966, -1329,  1746, 10310, -1329, -1329,  1751, -1329,   662, 10310,
   10310, -1329,  5313,  1747,  5313, -1329,    91,  1753,  1758,  5313,
    1759,  1760,  5313,  5313,  1763,  1764,  5313,  5313,  7975,  7997,
    1933,  1990,  2001,  2004,  2386, -1329, -1329, -1329,  1289, -1329,
   -1329, -1329,  1289, -1329, -1329, -1329,  1289, -1329, -1329, -1329,
   -1329, -1329, -1329,  1767,  9087, -1329, -1329, -1329,  5313,  5313,
   -1329,  1765, -1329, -1329,  5313,  3960, 10310,  1771,    99,  1772,
    1773,    99,  1775,  1778,    99,    99,  1782,  1790,  8019,  8041,
    1791,  1795, -1329, -1329, -1329, -1329,  1950,  1184,  1185,  1188,
      55,    53,  9109,  9151,  8106,  1978, -1329,  1796, -1329, -1329,
    1797, -1329, -1329,  1798,  1799, -1329, -1329,  1800,  1801, -1329,
   -1329, -1329, -1329, -1329, -1329,  1806,  1808,  1811, -1329, -1329,
   -1329, -1329,  1812,  1816,  1817,  1818, -1329, -1329,  5313,  3960,
    5313, 11083, -1329, -1329, -1329, -1329,  8270, -1329,  8292, -1329,
    3960,  3960, -1329, -1329
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1329, -1329, -1329,  1600,  -503,     5, -1329,  2021,  2027, -1126,
   -1329, -1328,  -619,  -545, -1329, -1329,  -511, -1329,  -167,  -487,
    -800,  1059,  -905,  -319,  2057,  2041, -1329, -1329, -1329,  1885,
   -1329, -1329, -1329,  1879, -1329, -1329, -1329, -1329,  1521,  -148,
     967,  -661, -1329,  -497,  -568, -1053, -1329,  -457, -1329,   -32,
   -1329,  -738,   -71,   281, -1329,   641,  1302,  -485, -1329, -1329,
    -329,  -343, -1329, -1329, -1329,  1679,   546,  -274,  -691,   952,
   -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329,  -506,
   -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329, -1329,  1576,
   -1329, -1329,   794, -1329, -1329, -1329,  -495, -1095,  -583,   528,
     668, -1329,  1396,   169,   513, -1329, -1329, -1329, -1329, -1329,
   -1329,  -279,  -282, -1329, -1329,  1526,  -684, -1329,  1249, -1329,
   -1329, -1329, -1329, -1329, -1329,  -514, -1329,   726, -1329, -1329,
    1695,  -178,  1611,   946,  1131, -1329,  -339,  -469,  -173, -1329,
   -1329,  1015,  -669,  1014,  1425,   439, -1329,  1477, -1329,  -587,
   -1329, -1329, -1101,  -586, -1329,  -602,  1129, -1329,  1103,   -50,
   -1329,  -801, -1329,  -616, -1329, -1329,  -845, -1010, -1329,   749,
    -698, -1218, -1329, -1329,   613,   814,  1593, -1329, -1329,  1567,
   -1329, -1329,  1569, -1329, -1329,   579,  -517,  1003,  1792, -1329,
   -1329, -1329, -1329, -1329, -1329
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -725
static const yytype_int16 yytable[] =
{
      87,   646,   689,   692,  1264,     9,  1050,   639,   883,   563,
     564,   565,   604,     9,   144,  1241,  1245,   798,   799,   800,
    1011,   782,   783,   889,   809,  1121,   705,   405,   335,   195,
     917,   954,   772,   261,    44,   778,   864,   599,  1213,   599,
      44,    33,   865,   867,    99,   422,  1634,  1528,  1642,   933,
     135,   382,   335,   143,  1776,  1235,    44,   569,    44,  -119,
    1350,  1023,   545,  1068,  1644,   876,   745,  -402,   194,  1024,
      21,  1433,   599,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,  1005,  1100,  1128,
     254,   425,  1454,   771,   545,   545,   777,   588,  1026,   381,
     599,    22,   599,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   194,
     568,   256,   469,   824,   578,   450,  1028,   577,  1599,  1028,
    1034,  1225,    44,   335,   306,  1043,   598,   576,  1046,   387,
     640,   877,  1052,  1430,  1177,   650,   599,   820,     1,  1388,
     796,   478,  1178,   479,   480,   927,     1,   796,    17,   589,
      44,   928,   929,   381,   705,    17,   705,   907,   305,   927,
    1204,  1426,   896,   194,   307,   928,   929,   888,   892,   890,
     893,   927,    18,   590,   591,   226,   997,   928,   929,    42,
     878,   879,   641,  1433,   642,    28,  1383,    29,  1635,  1142,
    1635,  -402,   927,   592,   421,   898,  1038,  1350,   928,   929,
     580,   937,  -378,  1641,  1047,  1038,  1635,   694,   328,    23,
      91,  1513,   154,   754,  1594,  1595,   363,   226,   576,  1513,
     474,   475,  1419,    34,   764,   347,    34,   154,   713,  1318,
     770,  1420,   348,   593,  1323,   349,   350,   351,   424,   336,
     714,   262,   887,   337,   600,   406,   354,   738,   355,   356,
     357,   560,   358,   338,   643,   859,  1694,  1194,   943,   944,
     560,   945,  1069,  1201,   570,   387,    24,   473,  1025,  -119,
     546,   859,  -378,   859,  -119,  1430,   831,   891,   590,   591,
     757,   758,   738,   760,  -402,  1017,  1018,   548,  1020,   550,
     404,  1022,  1389,   862,    92,  1390,  -378,  -378,   644,   862,
     364,   102,   103,   104,  1006,   172,  -352,  1007,  1455,  1129,
    1725,   173,   706,   709,  1506,   891,  -378,   603,    25,   805,
    1513,   796,  1027,   427,  1214,  1115,   560,  1118,   129,   131,
     132,   133,   134,    26,   140,   142,  1529,  1530,   645,  1532,
     744,   371,  1598,  1423,   172,  1029,  1030,   581,  1029,  1030,
     173,  -279,  1058,  -279,  -279,   907,  -378,  1059,  1632,  -473,
    1144,   468,  -473,    31,   336,   466,  1148,   467,   337,   338,
     180,   891,  1091,  1090,  1092,  1332,   181,  1094,    32,     1,
     930,   932,  1334,   576,   940,  1394,  1254,   182,   222,   223,
     224,   899,    35,  1207,  1001,  1269,  1270,  1116,   806,  1120,
    1101,  1475,  1612,   933,  1207,  1261,  1003,  1330,   807,   557,
     151,   152,   153,   487,   769,  1331,  1596,   154,   166,   167,
     168,   169,   170,   749,  1346,  1347,   560,  1056,    36,   877,
     987,   560,  1413,  1146,  1421,   168,   169,   170,  1149,   172,
    1348,   495,   226,  1422,  1145,   173,    -3,   750,   751,  -378,
      37,  1150,   227,   946,   947,   950,   949,   372,  1513,   951,
     373,  1686,  1687,   374,  1002,    38,  1004,   752,   171,   316,
    1341,  1342,     1,   570,   172,  1192,    41,  1637,   878,   879,
     173,  1033,   932,   862,   317,   560,  1343,   932,  1044,   711,
     932,   862,   862,   903,   932,  1650,   318,  1448,   717,  1060,
     551,   862,   726,   727,   552,   504,   226,   753,  1057,  1449,
    1117,   741,  1513,  1102,  1103,  1104,   353,  1576,  1577,    94,
     817,   756,   818,  1581,  1582,  1583,  1584,    17,   728,   729,
    1588,  1589,  1590,  1591,  1307,  1308,   729,     2,   773,   264,
      95,   773,   389,   390,   265,  1333,  1335,   730,   731,   732,
     733,   429,   429,   819,  1404,   731,   784,   733,   391,  1690,
     785,   430,   716,   689,   100,  1071,   734,   735,  1718,  1719,
    1131,  1132,  1263,   101,   735,  1072,  1258,  1085,  1477,   176,
     145,   146,   177,   147,   148,   149,   150,   151,   152,   153,
    1096,     3,   729,   105,   154,  1710,  1711,  1262,   145,   146,
     560,  1712,   590,   591,  1478,   151,   152,   153,  1716,  1717,
       4,   731,   154,   733,  1485,  1489,    47,    48,  1496,  1500,
    1504,  1662,  1479,   166,   167,   168,   169,   170,   145,   146,
     735,   147,   148,   149,   150,   151,   152,   153,  1187,  1135,
    1633,     5,   154,   106,   686,   155,   156,   157,   158,   159,
     695,   915,   915,  1647,  1746,  1341,  1342,  1078,     1,     6,
     728,   412,   922,   413,  1073,  1357,  1799,  1072,  1079,   145,
     146,  1343,   147,   148,   149,   150,   151,   152,   153,   730,
     862,   732,   938,   154,  1549,   107,   932,   156,   157,   158,
     159,   862,   487,   226,  1072,   108,   998,   999,   734,   412,
    1471,   723,  1473,  1234,   987,   -12,   862,   773,   109,   979,
     980,   981,   982,   983,   984,   985,  1253,   724,   725,   967,
     495,   992,   993,   994,   995,  1525,   110,  1266,  1267,   -12,
     -12,   -12,  1531,   111,  1533,  1534,    44,    45,    46,  1728,
     112,    47,    48,    49,  1731,  1673,   113,  1734,  1735,   -12,
    1677,  1678,  1482,  1680,  1681,   180,   268,   114,  1061,  1684,
    1685,   181,   464,   115,   465,   932,  1016,  1486,  1066,   116,
    1202,  1067,   182,   172,   172,   117,   590,   591,  1478,   173,
     173,   742,   118,   743,   504,  1563,  1440,   178,  1441,  1442,
    1443,   590,   591,  1478,  1522,  1524,  1483,   194,   164,   165,
     166,   167,   168,   169,   170,   412,   174,   746,  1480,  1484,
    1488,  1487,   119,  1495,  1499,  1503,   164,   165,   166,   167,
     168,   169,   170,  1212,   226,   773,   172,   280,   226,   773,
    1493,   309,   173,   775,  1119,   776,  1065,  1592,  1593,  1497,
     120,   160,   471,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   121,   590,   591,  1478,  1111,  1112,   394,
     728,   395,   396,   590,   591,  1478,   122,   862,   472,  1038,
    1640,  1240,  1244,  1640,  1494,  1640,   775,  1127,   779,   730,
    1060,   732,  1038,  1498,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   412,   773,   826,  1757,   734,  1147,
    1760,  1536,  1537,  1763,  1764,    -2,   445,   447,  1152,  1154,
     185,   186,    53,  1157,  1159,    54,    55,   192,    56,    57,
      58,    59,    60,    61,   187,    62,    63,   383,   123,   275,
     384,     1,  1501,  1031,    64,    65,  1032,   188,  1490,    66,
    1491,  1492,    67,    68,    69,    70,  1664,  1665,    71,    72,
      73,    74,   189,    75,    76,   124,   590,   591,  1478,   137,
     138,   139,   821,   773,   822,  1237,  1199,  1200,   866,   773,
     867,    82,   185,   186,   584,   585,  1502,   587,  1208,  1209,
    1210,    85,  1490,   125,  1491,  1564,   187,  1207,   870,  1219,
     871,  1221,  1222,  1224,   126,   862,     2,  1233,   127,   188,
     392,  1207,   456,   393,   194,   457,  1242,  1246,   958,  1247,
    1248,   959,   862,   874,   189,   871,  1251,   862,   862,   862,
     862,   862,   862,   689,   689,  1284,   128,  1256,   961,  1775,
    1777,   962,   659,  1226,   365,   965,   316,   221,   966,   977,
     977,   977,   977,   977,   977,   977,   977,   915,   915,   259,
       3,   317,   977,   977,   977,   977,   669,   670,   671,   961,
     255,  1281,  1138,   318,   194,  1139,   257,  1278,  1140,     4,
    1279,   961,   862,   258,  1299,  1139,   677,  1336,  1300,  1755,
    1337,  1336,  1316,  1317,  1339,  1319,  1320,  1321,  1322,   701,
     703,  1310,  1326,  1327,  1328,  1329,  1578,   260,   266,  1315,
       5,   270,   961,  1360,  1691,  1359,  1361,   961,  1692,   271,
    1364,   226,  1693,  1406,  1392,   882,  1407,   867,     6,  1698,
    1615,  1616,  1617,  1702,  1619,  1620,  1621,  1706,  1623,  1624,
    1625,  1462,   987,   987,  1463,  1472,  1474,  1556,   277,   267,
    1557,  1365,   972,  1797,   973,   987,   987,   988,   989,   987,
     987,   990,   991,  1373,  1802,  1803,   862,  1075,   862,  1076,
    1080,  1349,  1081,   272,   133,   134,  1385,  1386,  1080,   862,
    1083,  1075,   775,  1087,  1093,   273,   862,  1603,  1395,  1396,
     274,  1607,  1399,  1400,  1284,  1611,   775,  1403,  1095,  1124,
     278,  1125,  1618,   431,   432,   775,  1622,  1198,   154,   321,
    1626,   433,   434,   435,   436,   437,   314,   322,   775,   438,
    1257,   324,   325,   439,   440,   775,   326,  1259,  1424,   327,
     775,  1676,  1260,   194,   329,  1429,  1158,  1160,  1265,   330,
     360,  1435,   331,   412,  1439,  1291,   412,  1170,  1292,  1294,
     862,  1295,   775,   332,  1302,   446,   775,  1446,  1306,   333,
     345,  1450,  1451,   441,   442,   689,   412,   359,  1355,   431,
     432,  1075,   360,  1405,  1349,   362,   369,   433,   434,   435,
     436,   437,   370,   377,   862,   438,   862,   862,   378,   439,
     440,   775,   862,  1409,   412,   412,  1416,  1417,   862,   862,
     862,  1075,  1550,  1547,  1551,   145,   146,   379,   147,   148,
     149,   150,   151,   152,   153,   380,   194,   194,   194,   154,
    1526,   775,   381,  1568,   157,   158,   159,   385,   386,   441,
     442,   775,   775,  1569,  1570,  1747,  1233,  1233,  1349,  1748,
     335,  1539,  1233,  1749,   397,   862,  1542,   775,   398,  1571,
    1545,  1550,  1349,  1659,  1660,   412,  1661,  1695,   410,   414,
    1349,   145,   146,   415,   147,   148,   149,   150,   151,   152,
     153,   416,  1535,   310,   311,   154,   862,   417,   155,   156,
     157,   158,   159,   412,   412,  1696,  1697,   412,   412,  1699,
    1700,   412,   412,  1701,  1703,  1573,   412,   412,  1704,  1705,
     418,   932,   932,   412,   412,  1772,  1773,   412,   420,  1774,
    1585,   547,   261,   549,    44,   423,  1349,   428,   452,   454,
     455,   458,   459,   977,   977,   460,   977,   977,   977,   977,
     476,   462,   481,   977,   977,   977,   977,   470,   512,   513,
     862,   130,   559,    44,    45,    46,   560,   566,    47,    48,
      49,   862,   862,   567,   573,   579,   583,  1631,   446,   586,
     581,  1349,   634,   637,   696,   693,   699,   194,   698,   707,
     194,   718,   194,   738,   719,   720,   721,   748,   747,   722,
     767,   145,   146,   759,   147,   148,   149,   150,   151,   152,
     153,   761,   766,   780,  1654,   154,   781,  1656,   626,  1349,
     157,   158,   159,   788,   789,   790,  1663,   796,   791,   792,
     816,   825,   793,  1669,   794,   795,   801,   884,   802,   803,
    1670,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     804,   812,   814,   813,   952,   815,    44,    45,    46,   827,
     828,    47,    48,    49,   833,  1688,  1689,   834,   836,   897,
     900,   909,   910,   941,   911,   920,   918,   921,   939,   923,
     924,   925,   926,    50,    51,    52,   957,   968,   960,   964,
    1014,  1013,   969,   970,   160,   312,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,  1464,   971,   986,  1015,
     996,  1008,   642,  1009,  1714,  1010,  1012,     1,  1040,  1349,
    1089,   313,  1041,  1042,  1070,  1045,  1097,  1141,  1051,    44,
      45,    46,  1077,  1082,    47,    48,    49,  1053,  1054,    53,
    1726,  1055,    54,    55,  1088,    56,    57,    58,    59,    60,
      61,  1084,    62,    63,  1738,  1739,    50,    51,    52,  1086,
    1098,    64,    65,  -722,  -723,  -724,    66,  1105,  1106,    67,
      68,    69,    70,  1349,  1113,    71,    72,    73,    74,  1109,
      75,    76,  1110,  1133,  1123,  1137,  1752,  1753,  1136,  1156,
    1161,  1162,  1754,  1171,  1163,  1183,  1189,  1227,    82,    44,
      45,    46,  1164,  1165,    47,    48,    49,  1166,    85,  1167,
    1168,  1169,  1172,  1173,  1174,  1175,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,    50,    51,    52,  1184,
    1575,  1191,    53,  1205,  1216,    54,    55,  1188,    56,    57,
      58,    59,    60,    61,  1197,    62,    63,  1203,  1249,  1211,
    1215,   867,  1220,   871,    64,    65,  1796,  1255,  1798,    66,
    1288,  1272,    67,    68,    69,    70,  1290,  1273,    71,    72,
      73,    74,  1274,    75,    76,  1275,  1228,  1276,  1277,    77,
      78,    79,  1293,  1296,    80,    81,  1229,   953,  1298,  1301,
    1303,    82,  -185,  1304,  1305,  -185,  1311,   953,  1313,    83,
      84,    85,  1314,  1338,  1325,    53,  1324,  1340,    54,    55,
    1356,    56,    57,    58,    59,    60,    61,  1358,    62,    63,
    1366,  1372,  1371,  1374,  1393,  1376,  1380,    64,    65,  1410,
    1382,  1384,    66,  1398,  1387,    67,    68,    69,    70,  1414,
    1391,    71,    72,    73,    74,  1415,    75,    76,  1418,  1425,
    1436,  1444,    77,    78,    79,  1445,  1452,    80,    81,  1453,
    1458,  1459,  1507,  1469,    82,  -185,  1460,  1461,  -185,  1465,
     953,  1466,    83,    84,    85,    53,  1467,  1468,    54,    55,
    1470,    56,    57,    58,    59,    60,    61,  1508,    62,    63,
    1509,  1511,  1193,  1548,  1538,  1549,  1552,    64,    65,  1565,
    1566,  1574,    66,  1579,  1580,    67,    68,    69,    70,  1586,
    1600,    71,    72,    73,    74,  1587,    75,    76,  1601,  1602,
    1604,  1605,    77,    78,    79,  1606,  1608,    80,    81,  1230,
    1609,  1610,  1627,  1614,    82,  1628,   838,  1629,    44,   839,
    1648,  1655,    83,    84,    85,  1227,  1649,    44,    45,    46,
     431,   432,    47,    48,    49,  1666,  1667,  1668,   433,   434,
     435,   436,   437,  1672,  1674,  1675,   438,  1679,   840,  1721,
     439,   440,   841,   842,    50,    51,    52,   843,   844,   845,
    1682,   846,  1683,     1,   847,  1707,  1635,  1206,  1723,  1727,
    1239,  1724,  1742,  1743,   476,  1729,   848,   849,   850,   851,
    1730,  1732,  1733,   852,  1744,  1736,  1737,  1745,  1750,  1771,
     441,   442,  1756,  1758,  1759,  1072,  1761,   487,  1638,  1762,
      44,    45,    46,  1765,  1228,    47,    48,    49,  1346,  1347,
     -12,  1766,  1781,  1769,  1229,   853,   854,  1770,  1782,  1783,
    1784,  1785,  1786,  1787,  1348,   495,  1788,    50,    51,    52,
    1789,  1790,    43,  1792,   -12,   -12,   -12,  1793,  1794,  1795,
     514,    90,  1182,   855,  1517,    27,    40,   856,   269,   276,
    1639,   710,  1562,   451,   -12,   633,  1282,   963,  1657,  1428,
     712,  1553,   894,  1021,   558,  1297,  1510,   449,  1143,  1638,
    1250,    44,    45,    46,  1252,   875,    47,    48,    49,  1722,
    1176,  1155,  1505,  1613,  1434,   811,   697,   700,  1268,   504,
     702,     0,   368,     0,     0,     0,     0,     0,    50,    51,
      52,     0,     0,    53,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,  1517,    62,    63,     0,     0,
       0,  1643,     0,     0,     0,    64,    65,     0,     0,     0,
      66,     0,     0,    67,    68,    69,    70,     0,     0,    71,
      72,    73,    74,     0,    75,    76,     0,     0,     0,     0,
      77,    78,    79,     0,     0,    80,    81,     0,   857,     0,
     858,     0,    82,   859,     0,     0,     0,     0,     0,     0,
      83,    84,    85,     0,     0,     0,    53,     0,     0,    54,
      55,   605,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,     0,
       0,     0,     0,    77,    78,    79,     0,     0,    80,    81,
       0,     0,     0,     0,     0,    82,     0,   606,     0,     0,
       0,     0,     0,    83,    84,    85,     0,    53,   607,   608,
      54,    55,     0,    56,    57,    58,    59,    60,    61,     0,
      62,    63,     0,     0,     0,     0,     0,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,    67,    68,    69,
      70,     0,     0,    71,    72,    73,    74,     0,    75,    76,
     609,     0,     0,     0,    77,    78,    79,     0,     0,    80,
      81,  1638,     0,    44,    45,    46,    82,     0,    47,    48,
      49,     0,     0,     0,    83,    84,    85,   610,   611,   612,
     613,   614,   615,   616,   617,     0,     0,     0,     0,     0,
      50,    51,    52,   618,   619,   620,   621,     0,     0,   622,
     623,   624,   625,     0,     0,     0,     0,  1517,     0,     0,
       0,     0,     0,  1645,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   838,     0,    44,
     839,  1437,     0,    44,    45,    46,     0,     0,    47,    48,
      49,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   840,
      50,    51,    52,   841,   842,     0,     0,     0,   843,   844,
     845,     0,   846,     0,     0,   847,     0,     0,   626,     0,
       0,     0,     0,     0,     0,     0,     0,   848,   849,   850,
     851,     0,     0,     0,   852,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1516,     0,    44,    45,    46,
       0,     0,    47,    48,    49,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   853,   854,     0,     0,
       0,     0,     0,     0,    50,    51,    52,     0,     0,    53,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,  1517,    62,    63,   855,     0,     0,     0,   856,     0,
       0,    64,    65,     0,     0,     0,    66,     0,     0,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,    77,    78,    79,     0,
       0,    80,    81,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,    83,    84,    85,    53,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,     0,    62,    63,     0,     0,     0,     0,     0,     0,
       0,    64,    65,     0,     0,     0,    66,     0,     0,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,    77,    78,    79,     0,
       0,    80,    81,     0,     0,     0,     0,  1062,    82,   857,
       0,   858,  1438,   810,   859,     0,    83,    84,    85,     0,
       0,     0,     0,    53,   607,   608,    54,    55,     0,    56,
      57,    58,    59,    60,    61,     0,    62,    63,     0,     0,
       0,     0,     0,     0,     0,    64,    65,     0,     0,     0,
      66,     0,     0,    67,    68,    69,    70,     0,     0,    71,
      72,    73,    74,     0,    75,    76,   609,     0,     0,     0,
      77,    78,    79,     0,     0,    80,    81,  1521,     0,    44,
      45,    46,    82,     0,    47,    48,    49,     0,     0,     0,
      83,    84,    85,   610,   611,   612,   613,   614,   615,   616,
     617,     0,     0,     0,     0,     0,    50,    51,    52,   618,
     619,   620,   621,     0,     0,   622,   623,   624,   625,     0,
       0,     0,     0,  1517,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   838,     0,    44,   839,  1523,     0,    44,
      45,    46,     0,     0,    47,    48,    49,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   840,    50,    51,    52,   841,
     842,     0,     0,     0,   843,   844,   845,     0,   846,     0,
       0,   847,     0,  1517,   626,     0,     0,     0,     0,     0,
       0,     0,     0,   848,   849,   850,   851,     0,     0,     0,
     852,     0,     0,     0,     0,     0,  1217,   426,     0,    44,
      45,    46,     0,     0,    47,    48,    49,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   853,   854,     0,     0,    50,    51,    52,     0,
       0,     0,     0,     0,     0,    53,     0,     0,    54,    55,
       0,    56,    57,    58,    59,    60,    61,     0,    62,    63,
     855,     0,     0,     0,   856,     0,     0,    64,    65,     0,
       0,     0,    66,     0,     0,    67,    68,    69,    70,     0,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,    77,    78,    79,     0,     0,    80,    81,     0,
       0,     0,     0,     0,    82,     0,     0,     0,     0,     0,
       0,     0,    83,    84,    85,    53,     0,     0,    54,    55,
       0,    56,    57,    58,    59,    60,    61,     0,    62,    63,
       0,     0,     0,     0,     0,     0,     0,    64,    65,     0,
       0,     0,    66,     0,     0,    67,    68,    69,    70,     0,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,    77,    78,    79,     0,     0,    80,    81,     0,
       0,     0,     0,     0,    82,   857,     0,   858,     0,     0,
     859,     0,    83,    84,    85,    53,     0,     0,    54,    55,
       0,    56,    57,    58,    59,    60,    61,     0,    62,    63,
       0,     0,     0,     0,     0,     0,     0,    64,    65,     0,
       0,     0,    66,     0,     0,    67,    68,    69,    70,     0,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,    77,    78,    79,     0,     0,    80,    81,  1181,
       0,    44,    45,    46,    82,     0,    47,    48,    49,   515,
     704,     0,    83,    84,    85,     0,   516,     0,   517,     0,
     518,     0,     0,     0,     0,     0,     0,     0,    50,    51,
      52,     0,     0,     0,     0,     0,     0,   519,   520,   521,
     522,   523,   524,   525,   526,   527,   528,   529,   530,   531,
     532,   533,   534,   535,   536,   537,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   838,     0,    44,   839,  1218,
       0,    44,    45,    46,     0,     0,    47,    48,    49,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   840,    50,    51,
      52,   841,   842,     0,     0,     0,   843,   844,   845,     0,
     846,     0,     0,   847,     0,     0,  1709,     0,     0,     0,
       0,     0,     0,     0,     0,   848,   849,   850,   851,     0,
       0,     0,   852,     0,     0,     0,     0,     0,     0,  1223,
       0,    44,    45,    46,     0,     0,    47,    48,    49,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   853,   854,     0,     0,    50,    51,
      52,     0,     0,     0,     0,     0,     0,    53,     0,     0,
      54,    55,     0,    56,    57,    58,    59,    60,    61,     0,
      62,    63,   855,     0,     0,     0,   856,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,    67,    68,    69,
      70,     0,     0,    71,    72,    73,    74,     0,    75,    76,
       0,     0,     0,     0,    77,    78,    79,     0,     0,    80,
      81,     0,     0,     0,     0,     0,    82,     0,     0,     0,
       0,     0,     0,     0,    83,    84,    85,    53,     0,     0,
      54,    55,     0,    56,    57,    58,    59,    60,    61,     0,
      62,    63,     0,     0,     0,     0,     0,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,    67,    68,    69,
      70,     0,     0,    71,    72,    73,    74,     0,    75,    76,
       0,     0,     0,     0,    77,    78,    79,     0,     0,    80,
      81,     0,     0,     0,     0,     0,    82,   857,     0,   858,
       0,     0,   859,     0,    83,    84,    85,    53,     0,     0,
      54,    55,     0,    56,    57,    58,    59,    60,    61,     0,
      62,    63,     0,     0,     0,     0,     0,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,    67,    68,    69,
      70,     0,     0,    71,    72,    73,    74,     0,    75,    76,
       0,     0,     0,     0,    77,    78,    79,     0,     0,    80,
      81,  1713,     0,    44,    45,    46,    82,     0,    47,    48,
      49,     0,     0,     0,    83,    84,    85,   838,     0,    44,
     839,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      50,    51,    52,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     1,     0,     0,     0,     0,     0,     0,   840,
       0,     0,     0,   841,   842,     0,     0,     0,   843,   844,
     845,     0,   846,     0,     0,   847,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   487,   848,   849,   850,
     851,     0,     0,     0,   852,     0,     0,  1346,  1347,   -12,
     141,     0,    44,    45,    46,     0,     0,    47,    48,    49,
       0,     0,     0,  1348,   495,     0,     0,     0,     0,     0,
       0,     0,     0,   -12,   -12,   -12,   853,   854,     0,     0,
       0,   515,   901,     0,     0,     0,     0,     0,   516,     0,
     517,     0,   518,   -12,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   855,     0,     0,     0,   856,   519,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   533,   534,   535,   536,   537,   504,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    53,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,     0,    62,    63,     0,     0,     0,     0,     0,     0,
       0,    64,    65,     0,     0,     0,    66,     0,     0,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,    77,    78,    79,     0,
       0,    80,    81,     0,     0,     0,     0,     0,    82,     0,
       0,     0,     0,     0,     0,     0,    83,    84,    85,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   857,
       0,   858,     0,     0,   859,     0,     0,     0,    53,     0,
       0,    54,    55,     0,    56,    57,    58,    59,    60,    61,
       0,    62,    63,  1035,     0,    44,   839,     0,     0,     0,
      64,    65,     0,     0,     0,    66,     0,     0,    67,    68,
      69,    70,     0,     0,    71,    72,    73,    74,     0,    75,
      76,     0,     0,     0,     0,   840,     0,     0,     0,   841,
     842,     0,     0,     0,   843,   844,   845,    82,   846,     0,
     838,   847,    44,   839,  1036,     0,     0,    85,     0,     0,
       0,     0,     0,   848,   849,   850,   851,     0,     0,     0,
     852,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   840,     0,     0,     0,   841,   842,     0,     0,
       0,   843,   844,   845,     0,   846,     0,     0,   847,     0,
       0,     0,   853,   854,     0,     0,     0,     0,     0,     0,
     848,   849,   850,   851,     0,     0,     0,   852,     0,     0,
       0,     0,   838,  1048,    44,   839,     0,     0,     0,     0,
     855,     0,     0,     0,   856,     0,     0,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,   853,
     854,   154,     0,     0,   840,     0,   157,     0,   841,   842,
       0,     0,     0,   843,   844,   845,     0,   846,     0,   838,
     847,    44,   839,     0,     0,     0,     0,   855,     0,     0,
       0,   856,   848,   849,   850,   851,     0,     0,     0,   852,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   840,     0,     0,     0,   841,   842,     0,     0,     0,
     843,   844,   845,     0,   846,     0,     0,   847,     0,     0,
       0,   853,   854,     0,     0,     0,     0,  1037,     0,   848,
     849,   850,   851,     0,     0,     0,   852,     0,     0,     0,
       0,   838,  1715,    44,   839,   857,     0,   858,     0,   855,
     859,     0,     0,   856,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   853,   854,
       0,     0,     0,   840,  1049,     0,     0,   841,   842,     0,
       0,     0,   843,   844,   845,     0,   846,     0,     0,   847,
       0,     0,   857,     0,   858,     0,   855,   859,     0,     0,
     856,   848,   849,   850,   851,     0,     0,     0,   852,     0,
      44,    45,    46,     0,     0,    47,    48,    49,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    50,    51,    52,
     853,   854,     0,     0,     0,     0,  1636,     0,     0,     0,
       0,     0,     0,     0,   163,   164,   165,   166,   167,   168,
     169,   170,  1062,     0,   857,     0,   858,     0,   855,   859,
       0,     0,   856,   726,   727,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,     0,     0,   728,
     729,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   857,     0,   858,     0,     0,   859,     0,   730,   731,
     732,   733,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   734,   735,     0,
      44,    45,    46,     0,     0,    47,    48,    49,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    50,    51,    52,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   857,     0,   858,    53,     0,   859,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,   728,
     729,     0,     0,    77,    78,    79,     0,     0,    80,    81,
       0,     0,     0,     0,     0,    82,     0,     0,   730,   731,
     732,   733,     0,    83,    84,    85,     0,     0,    44,    45,
      46,     0,     0,    47,    48,    49,     0,   734,   735,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    50,    51,    52,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   407,    53,     0,     0,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,     0,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,  1238,    75,    76,     0,
       0,     0,     0,    77,    78,    79,     0,     0,    80,    81,
       0,    44,    45,    46,     0,    82,    47,    48,    49,     0,
       0,     0,     0,    83,    84,    85,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    50,    51,
      52,     0,     0,     0,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,     0,     0,     0,     0,
       0,     0,     0,     0,    53,     0,     0,    54,    55,     0,
      56,    57,    58,    59,    60,    61,     0,    62,    63,     0,
       0,     0,     0,     0,     0,     0,    64,    65,     0,     0,
       0,    66,     0,     0,    67,    68,    69,    70,     0,  1243,
      71,    72,    73,    74,     0,    75,    76,     0,     0,     0,
       0,    77,    78,    79,     0,     0,    80,    81,     0,    44,
      45,    46,     0,    82,    47,    48,    49,     0,   857,     0,
    1239,    83,    84,    85,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    50,    51,    52,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1283,     0,     0,     0,     0,     0,  1427,
       0,     0,     0,     0,     0,     0,     0,    53,     0,     0,
      54,    55,     0,    56,    57,    58,    59,    60,    61,     0,
      62,    63,     0,     0,     0,     0,     0,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,    67,    68,    69,
      70,     0,     0,    71,    72,    73,    74,     0,    75,    76,
       0,     0,     0,     0,    77,    78,    79,     0,     0,    80,
      81,     0,     0,    44,    45,    46,    82,     0,    47,    48,
      49,   857,     0,  1239,    83,    84,    85,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
      50,    51,    52,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   408,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    53,     0,     0,    54,    55,
       0,    56,    57,    58,    59,    60,    61,     0,    62,    63,
    1228,     0,     0,     0,     0,     0,     0,    64,    65,     0,
    1229,     0,    66,     0,     0,    67,    68,    69,    70,     0,
       0,    71,    72,    73,    74,     0,    75,    76,     0,     0,
       0,     0,    77,    78,    79,     0,     0,    80,    81,     0,
      44,    45,    46,     0,    82,    47,    48,    49,     0,     0,
       0,     0,    83,    84,    85,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    50,    51,    52,
       0,     0,     0,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,     0,     0,     0,     0,    53,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,     0,    62,    63,     0,     0,     0,     0,     0,     0,
       0,    64,    65,     0,     0,     0,    66,     0,     0,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,    77,    78,    79,     0,
       0,    80,    81,     0,    44,    45,    46,     0,    82,    47,
      48,    49,     0,     0,     0,     0,    83,    84,    85,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    50,    51,    52,     0,     0,     0,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,     0,
       0,     0,     0,     0,     0,     0,    53,     0,     0,    54,
      55,     0,    56,    57,    58,    59,    60,    61,     0,    62,
      63,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,    66,     0,   912,    67,    68,    69,    70,
       0,     0,    71,    72,    73,    74,     0,    75,    76,     0,
       0,     0,     0,    77,    78,    79,     0,     0,   913,   914,
       0,    44,    45,    46,     0,    82,    47,    48,    49,     0,
       0,     0,     0,    83,    84,    85,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,    50,    51,
      52,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   409,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      53,     0,     0,    54,    55,     0,    56,    57,    58,    59,
      60,    61,     0,    62,    63,     0,     0,     0,     0,     0,
       0,     0,    64,    65,     0,     0,     0,    66,     0,     0,
      67,    68,    69,    70,     0,     0,    71,    72,    73,    74,
       0,    75,    76,     0,     0,     0,     0,    77,    78,    79,
       0,     0,    80,    81,     0,    44,    45,    46,     0,    82,
      47,    48,    49,     0,     0,  1193,     0,    83,    84,    85,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,    50,    51,    52,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   715,     0,  1283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    53,     0,     0,
      54,    55,     0,    56,    57,    58,    59,    60,    61,     0,
      62,    63,     0,     0,     0,     0,     0,     0,     0,    64,
      65,     0,     0,     0,    66,     0,     0,    67,    68,    69,
      70,     0,     0,    71,    72,    73,    74,     0,    75,    76,
       0,     0,     0,     0,    77,    78,    79,     0,     0,    80,
      81,     0,    44,    45,    46,     0,    82,    47,    48,    49,
    1236,     0,     0,     0,    83,    84,    85,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    50,
      51,    52,     0,     0,     0,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,     0,     0,     0,
       0,    53,     0,     0,    54,    55,     0,    56,    57,    58,
      59,    60,    61,     0,    62,    63,     0,     0,     0,     0,
       0,     0,     0,    64,    65,     0,     0,     0,    66,     0,
       0,    67,    68,    69,    70,     0,     0,    71,    72,    73,
      74,     0,    75,    76,     0,     0,     0,     0,    77,    78,
      79,     0,     0,    80,    81,     0,    44,    45,    46,     0,
      82,    47,    48,    49,     0,     0,     0,     0,    83,    84,
      85,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    50,    51,    52,     0,     0,     0,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,     0,     0,     0,     0,     0,     0,     0,    53,     0,
       0,    54,    55,     0,    56,    57,    58,    59,    60,    61,
       0,    62,    63,     0,     0,     0,     0,     0,     0,     0,
      64,    65,     0,     0,     0,    66,     0,     0,    67,    68,
      69,    70,     0,     0,    71,    72,    73,    74,     0,    75,
      76,     0,     0,     0,     0,    77,    78,    79,     0,     0,
      80,    81,     0,    44,    45,    46,     0,    82,    47,    48,
      49,  1630,     0,     0,     0,    83,    84,    85,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
      50,    51,    52,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1271,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    53,     0,     0,    54,    55,     0,    56,    57,
      58,    59,    60,    61,     0,    62,    63,     0,     0,     0,
       0,     0,     0,     0,    64,    65,     0,     0,     0,    66,
       0,     0,    67,    68,    69,    70,     0,     0,    71,    72,
      73,    74,     0,    75,    76,     0,     0,     0,     0,    77,
      78,    79,     0,     0,    80,    81,     0,    44,    45,    46,
       0,    82,    47,    48,    49,     0,     0,     0,     0,    83,
      84,    85,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,    50,    51,    52,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1653,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    53,
       0,     0,    54,    55,     0,    56,    57,    58,    59,    60,
      61,     0,    62,    63,     0,     0,     0,     0,    44,    45,
      46,    64,    65,    47,    48,    49,    66,     0,     0,    67,
      68,    69,    70,     0,     0,    71,    72,    73,    74,     0,
      75,    76,     0,     0,     0,     0,    77,    78,    79,     0,
       0,    80,    81,     0,     0,     0,     0,     0,  1153,     0,
       0,     0,     0,     0,     0,   974,    83,    84,    85,     0,
       0,     0,    44,    45,    46,     0,     0,    47,    48,    49,
       0,     0,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,   975,   154,     0,     0,   155,
     156,   157,   158,   159,     0,   976,     0,     0,     0,     0,
       0,     0,     0,    53,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,     0,    62,    63,     0,     0,
       0,     0,     0,     0,     0,    64,    65,     0,     0,     0,
      66,     0,     0,    67,    68,    69,    70,     0,     0,    71,
      72,    73,    74,     0,    75,    76,     0,     0,     0,     0,
      77,    78,    79,     0,     0,    80,    81,    44,    45,    46,
       0,     0,    47,    48,    49,     0,     0,     0,     0,     0,
      83,    84,    85,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    53,     0,     0,    54,    55,     0,
      56,    57,    58,    59,    60,    61,     0,    62,    63,     0,
       0,     0,     0,     0,     0,     0,    64,    65,     0,     0,
       0,    66,     0,     0,    67,    68,    69,    70,     0,     0,
      71,    72,    73,    74,     0,    75,    76,    44,    45,    46,
       0,     0,    47,    48,    49,     0,     0,     0,    53,     0,
       0,    54,    55,    82,    56,    57,    58,    59,    60,    61,
       0,    62,    63,    85,     0,     0,     0,     0,     0,     0,
      64,    65,     0,     0,     0,    66,     0,  1107,    67,    68,
      69,    70,     0,     0,    71,    72,    73,    74,     0,    75,
      76,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    85,     0,     0,
       0,     0,  1720,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    53,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,     0,    62,    63,     0,     0,
       0,     0,     0,     0,     0,    64,    65,     0,     0,     0,
      66,     0,  1108,    67,    68,    69,    70,     0,     0,    71,
      72,    73,    74,     0,    75,    76,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    85,    53,     0,     0,    54,    55,     0,    56,
      57,    58,    59,    60,    61,     0,    62,    63,     0,     0,
       0,     0,     0,     0,     0,    64,    65,     0,     0,     0,
      66,     0,     0,    67,    68,    69,    70,     0,     0,    71,
      72,    73,    74,     0,    75,    76,   482,     0,   -12,   145,
     146,   483,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,    82,   154,     0,     0,   155,   156,   157,   158,
     159,     1,    85,     0,     0,     0,     0,     0,     0,     0,
     -12,   -12,   484,   687,   -12,   -12,   -12,   485,     0,     0,
     -12,     0,     0,   486,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   487,   488,     0,     0,     0,
     489,     0,     0,   490,     0,   -12,   491,   492,   -12,     0,
       0,     0,     0,   493,   -12,     0,   -12,   -12,   -12,   -12,
     -12,   -12,   494,   495,   -12,     0,     0,     0,     0,   496,
     497,   -12,   -12,   -12,   -12,     0,     0,   -12,   -12,   -12,
     -12,   -12,     0,     0,   498,     0,     0,     0,   -12,   -12,
       0,   499,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,   500,     0,     0,   -12,     0,     0,     0,   -12,   -12,
     -12,   -12,     0,     0,     0,     0,     0,     0,     0,     0,
     501,     0,     0,     0,     0,   502,   503,   504,     0,     0,
       0,     0,     0,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,   -12,   -12,
     155,   156,   157,   158,   159,  1454,     0,     0,     0,   -12,
       0,     0,     0,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,     0,     0,     0,     0,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
     281,     0,     0,     0,   145,   146,   688,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     225,     0,     0,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,   145,
     146,  1455,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,   282,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,   283,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,   284,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,   285,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,   286,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,   145,   146,   288,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,     0,     0,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,   145,   146,
     289,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,   290,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,   145,   146,   291,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,     0,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,   292,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,   293,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,   295,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,   296,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,   300,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,   145,   146,   301,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,   145,   146,   302,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,     0,     0,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,   303,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,   145,   146,
     304,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,   399,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,   400,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,   401,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
     402,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,   403,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,   145,   146,   936,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,     0,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,   145,   146,   942,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,   145,   146,     0,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,  1151,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,   145,   146,  1368,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,     0,     0,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,  1369,     0,
       0,     0,   160,     0,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     0,     0,     0,     0,     0,     0,
    1370,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,  1377,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,     0,     0,  1378,     0,     0,     0,   160,     0,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,  1379,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,   145,   146,  1381,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,   145,   146,  1567,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,     0,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,  1651,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,   145,   146,  1652,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,  1671,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,  1708,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,  1740,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,  1741,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,  1767,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,   145,   146,  1768,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,     0,     0,   155,   156,
     157,   158,   159,   145,   146,     0,   147,   148,   149,   150,
     151,   152,   153,     0,     0,     0,     0,   154,     0,     0,
     155,   156,   157,   158,   159,     0,     0,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,   145,   146,  1780,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,  1800,     0,     0,     0,   160,     0,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,     0,     0,
       0,     0,   145,   146,  1801,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,     0,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,   376,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,  1114,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
    1287,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,  1362,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,  1363,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,   145,   146,  1397,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
     145,   146,  1401,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,     0,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,  1408,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,   145,   146,  1512,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
    1527,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,  1540,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,  1541,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,  1543,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,  1544,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,   145,   146,
    1561,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,     0,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,   145,   146,  1646,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,  1751,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,   145,   146,
    1778,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
       0,     0,     0,     0,     0,   160,     0,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,  1779,     0,     0,     0,     0,   160,   220,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,  1447,     0,     0,     0,     0,     0,     0,   160,
       0,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,   287,     0,     0,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,   294,     0,     0,     0,
       0,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   515,   902,     0,   297,     0,
       0,     0,   516,     0,   517,   160,   518,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
     298,     0,     0,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   482,     0,
     -12,     0,     0,   483,     0,     0,     0,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     1,     0,     0,   299,     0,     0,     0,
       0,     0,   -12,   -12,   484,     0,   -12,   -12,   -12,   485,
       0,     0,   -12,     0,     0,   486,     0,     0,     0,  -389,
       0,     0,     0,     0,     0,     0,     0,   487,   488,     0,
       0,     0,   489,     0,     0,   490,     0,   -12,   491,   492,
     -12,     0,     0,     0,     0,   493,   -12,     0,   -12,   -12,
     -12,   -12,   -12,   -12,   494,   495,   -12,     0,     0,     0,
       0,   496,   497,   -12,   -12,   -12,   -12,     0,     0,   -12,
     -12,   -12,   -12,   -12,     0,     0,   498,     0,     0,     0,
     -12,   -12,     0,   499,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   500,     0,     0,   -12,     0,     0,     0,
     -12,   -12,   -12,   -12,     0,     0,     0,     0,     0,     0,
       0,     0,   501,     0,     0,     0,     0,   502,   503,   504,
       0,     0,     0,     0,   482,     0,   -12,     0,     0,   483,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     -12,   -12,     0,     0,     0,     0,     0,     0,     0,     1,
       0,   -12,     0,     0,     0,     0,     0,     0,   -12,   -12,
     484,     0,   -12,   -12,   -12,   485,     0,     0,   -12,     0,
       0,   486,     0,     0,     0,  -389,     0,     0,     0,     0,
       0,     0,     0,   487,   488,     0,     0,     0,   489,     0,
       0,   490,   823,   -12,   491,   492,   -12,     0,     0,     0,
       0,   493,   -12,     0,   -12,   -12,   -12,   -12,   -12,   -12,
     494,   495,   -12,     0,     0,     0,     0,   496,   497,   -12,
     -12,   -12,   -12,     0,     0,   -12,   -12,   -12,   -12,   -12,
       0,     0,   498,     0,     0,     0,   -12,   -12,     0,   499,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   500,
       0,     0,   -12,     0,     0,     0,   -12,   -12,   -12,   -12,
       0,     0,     0,     0,     0,     0,     0,     0,   501,     0,
       0,     0,     0,   502,   503,   504,     0,     0,     0,     0,
       0,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,   -12,   -12,   155,   156,
     157,   158,   159,     0,     0,   145,   146,   -12,   147,   148,
     149,   150,   151,   152,   153,     0,     0,     0,     0,   154,
       0,     0,   155,   156,   157,   158,   159,     0,     0,     0,
       0,     0,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,   895,   155,
     156,   157,   158,   159,   145,   146,     0,   147,   148,   149,
     150,   151,   152,   153,     0,     0,     0,     0,   154,     0,
       0,   155,   156,   157,   158,   159,   145,   146,     0,   147,
     148,   149,   150,   151,   152,   153,     0,     0,     0,     0,
     154,     0,     0,   155,   156,   157,   158,   159,   145,   146,
       0,   147,   148,   149,   150,   151,   152,   153,     0,     0,
       0,     0,   154,     0,     0,   155,   156,   157,   158,   159,
     145,   146,     0,   147,   148,   149,   150,   151,   152,   153,
       0,     0,     0,     0,   154,     0,     0,   155,   156,   157,
     158,   159,   145,   146,     0,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,     0,     0,     0,     0,     0,     0,
     551,     0,   145,   146,   552,   147,   148,   149,   150,   151,
     152,   153,     0,     0,     0,     0,   154,     0,     0,   155,
     156,   157,   158,   159,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   160,   220,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,   308,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   160,   352,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   160,
     919,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   160,  1280,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   160,  1309,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,  1402,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   160,  1546,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   145,   146,     0,
     147,   148,   149,   150,   151,   152,   153,     0,     0,     0,
       0,   154,     0,     0,   155,   156,   157,   158,   159,   145,
     146,     0,   147,   148,   149,   150,   151,   152,   153,     0,
       0,     0,     0,   154,     0,     0,   155,   156,   157,   158,
     159,   145,   146,     0,   147,   148,   149,   150,   151,   152,
     153,     0,     0,     0,     0,   154,   515,     0,   155,   156,
     157,   158,   159,   516,   903,   517,     0,   518,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   904,   905,   906,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   515,     0,     0,     0,     0,     0,     0,
     516,     0,   517,     0,   518,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   519,   520,   521,   522,   523,   524,   525,   526,   527,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   537,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     160,  1558,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   160,  1572,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   482,     0,   -12,     0,     0,   483,
       0,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,     0,     0,   -12,   -12,
     484,     0,   -12,   -12,   -12,   485,     0,     0,   -12,     0,
       0,   486,     0,     0,     0,  -388,     0,     0,  -388,     0,
       0,     0,     0,   487,   488,     0,     0,     0,   489,     0,
       0,   490,     0,   -12,   491,   492,   -12,     0,     0,     0,
       0,   493,   -12,     0,   -12,   -12,   -12,   -12,   -12,   -12,
     494,   495,   -12,     0,     0,     0,     0,   496,   497,   -12,
     -12,   -12,   -12,     0,     0,   -12,   -12,   -12,   -12,   -12,
       0,     0,   498,     0,     0,     0,   -12,   -12,     0,   499,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   500,
       0,     0,   -12,     0,     0,     0,   -12,   -12,   -12,   -12,
       0,     0,     0,     0,   482,     0,   -12,     0,   501,   483,
       0,     0,  -388,   502,   503,   504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,   -12,   -12,   -12,   -12,
     484,   638,   -12,   -12,   -12,   485,     0,   -12,   -12,     0,
       0,   486,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   487,   488,     0,     0,     0,   489,     0,
       0,   490,     0,   -12,   491,   492,   -12,     0,     0,     0,
       0,   493,   -12,     0,   -12,   -12,   -12,   -12,   -12,   -12,
     494,   495,   -12,     0,     0,     0,     0,   496,   497,   -12,
     -12,   -12,   -12,     0,     0,   -12,   -12,   -12,   -12,   -12,
       0,     0,   498,     0,     0,     0,   -12,   -12,     0,   499,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   500,
       0,     0,   -12,     0,     0,     0,   -12,   -12,   -12,   -12,
       0,     0,     0,     0,   482,     0,   -12,     0,   501,   483,
       0,     0,  -389,   502,   503,   504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,   -12,   -12,   -12,   -12,
     484,     0,   -12,   -12,   -12,   485,     0,   -12,   -12,     0,
       0,   486,     0,     0,     0,     0,     0,     0,  -389,     0,
       0,     0,     0,   487,   488,     0,     0,     0,   489,     0,
       0,   490,     0,   -12,   491,   492,   -12,     0,     0,     0,
       0,   493,   -12,     0,   -12,   -12,   -12,   -12,   -12,   -12,
     494,   495,   -12,     0,     0,     0,     0,   496,   497,   -12,
     -12,   -12,   -12,     0,     0,   -12,   -12,   -12,   -12,   -12,
       0,     0,   498,     0,     0,     0,   -12,   -12,     0,   499,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   500,
       0,     0,   -12,     0,     0,     0,   -12,   -12,   -12,   -12,
       0,     0,     0,     0,   482,     0,   -12,     0,   501,   483,
       0,     0,     0,   502,   503,   504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,   -12,   -12,   -12,   -12,
     484,     0,   -12,   -12,   -12,   485,     0,   -12,   -12,     0,
       0,   486,     0,     0,     0,  -389,     0,     0,     0,     0,
       0,     0,     0,   487,   488,     0,     0,     0,   489,     0,
       0,   490,     0,   -12,   491,   492,   -12,     0,     0,     0,
       0,   493,   -12,     0,   -12,   -12,   -12,   -12,   -12,   -12,
     494,   495,   -12,     0,     0,     0,     0,   496,   497,   -12,
     -12,   -12,   -12,     0,     0,   -12,   -12,   -12,   -12,   -12,
       0,     0,   498,     0,     0,     0,   -12,   -12,     0,   499,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   500,
       0,     0,   -12,     0,     0,     0,   -12,   -12,   -12,   -12,
       0,     0,     0,     0,   482,     0,   -12,     0,   501,   483,
       0,     0,     0,   502,   503,   504,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
       0,     0,     0,     0,     0,     0,   -12,   -12,   -12,   -12,
     484,   687,   -12,   -12,   -12,   485,     0,   -12,   -12,     0,
       0,   486,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   487,   488,     0,     0,     0,   489,     0,
       0,   490,     0,   -12,   491,   492,   -12,     0,     0,     0,
       0,   493,   -12,     0,   -12,   -12,   -12,   -12,   -12,   -12,
     494,   495,   -12,     0,     0,     0,     0,   496,   497,   -12,
     -12,   -12,   -12,     0,     0,   -12,   -12,   -12,   -12,   -12,
       0,     0,   498,     0,   651,     0,   -12,   -12,     0,   499,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   500,
       0,     0,   -12,     0,     0,     0,   -12,   -12,   -12,   -12,
       0,     0,     0,     0,     0,     0,   652,   653,   501,     0,
     654,   655,   656,   502,   503,   504,   657,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   -12,   -12,     0,     0,
       0,   658,     0,     0,   659,     0,     0,   -12,     0,     0,
     660,     0,   661,   662,   663,   664,   665,   666,     0,     0,
     667,     0,     0,     0,     0,     0,     0,   668,   669,   670,
     671,     0,     0,   672,   673,   674,   675,   676,     0,     0,
       0,     0,     0,     0,   431,   432,     0,     0,   677,   678,
     679,   680,   433,   434,   435,   436,   437,     0,     0,     0,
     438,     0,     0,     0,   439,   440,   681,   682,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   441,   442,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   683
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-1329))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      32,   504,   508,   509,  1099,     0,   851,   502,   677,   478,
     479,   480,   497,     8,    85,  1068,  1069,   619,   620,   621,
     820,   608,   608,   684,   626,   930,   543,     1,     3,   100,
     714,   769,   600,     3,     3,   603,   652,     3,     1,     3,
       3,    27,   658,     3,    27,   374,    53,  1375,    53,   740,
      82,   333,     3,    85,     1,  1065,     3,     1,     3,     3,
    1186,     1,     3,    11,    53,     1,   577,     3,   100,     9,
       3,  1289,     3,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,     1,   898,     1,
     171,   383,     3,   600,     3,     3,   603,     1,     1,     3,
       3,   238,     3,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     483,   173,   424,   638,   487,     3,    11,   486,  1476,    11,
     841,  1056,     3,     3,   225,   846,   495,   486,   849,   337,
     503,    97,   853,  1289,    13,   504,     3,   636,    26,    86,
       3,   445,    21,   447,   448,     3,    26,     3,     3,    73,
       3,     9,    10,     3,   701,     3,   703,   704,   220,     3,
      52,   225,   687,   225,   226,     9,    10,   684,   685,   684,
     685,     3,    27,    97,    98,   239,   808,     9,    10,    27,
     146,   147,     1,  1431,     3,    76,  1226,    78,   225,   957,
     225,   157,     3,   117,   372,   694,   842,  1353,     9,    10,
       1,   742,     3,   225,   850,   851,   225,   511,   270,     3,
       3,  1367,    25,   582,    23,    24,     3,   239,   577,  1375,
     428,   429,   242,   239,   593,   287,   239,    25,   238,  1164,
     599,   251,   294,   157,  1169,   297,   298,   299,    88,   244,
     250,   241,   238,   248,   238,   249,   308,   243,   310,   311,
     312,   250,   314,   278,    73,   248,  1614,  1025,   757,   758,
     250,   760,   240,  1031,   238,   473,     3,   248,   238,   243,
     241,   248,    73,   248,   248,  1431,   645,   238,    97,    98,
     584,   585,   243,   587,   250,   829,   830,   465,   832,   467,
     352,   835,   239,   652,    87,   242,    97,    98,   117,   658,
      87,    50,    51,    52,   238,   244,   238,   241,   239,   241,
    1668,   250,   241,   241,  1354,   238,   117,   238,     3,     1,
    1476,     3,   837,   385,  1045,   923,   250,   925,    77,    78,
      79,    80,    81,     0,    83,    84,  1376,  1377,   157,  1379,
     240,    47,  1473,  1278,   244,   240,   241,   148,   240,   241,
     250,   239,   233,   241,   242,   902,   157,   238,  1514,   239,
     958,   423,   242,    26,   244,   170,   964,   172,   248,   394,
     197,   238,   889,   888,   889,   238,   203,   892,   240,    26,
     238,   740,   238,   742,   753,   238,  1085,   214,   137,   138,
     139,   695,   238,  1039,   238,  1109,  1110,   924,    80,   926,
     899,  1336,     3,  1124,  1050,  1096,   238,    13,    90,   471,
      18,    19,    20,    60,   238,    21,   225,    25,   231,   232,
     233,   234,   235,    73,    71,    72,   250,   238,     3,    97,
     239,   250,  1262,   960,   242,   233,   234,   235,   965,   244,
      87,    88,   239,   251,   959,   250,     0,    97,    98,   250,
     241,   966,   249,   762,   763,   767,   765,   163,  1614,   768,
     166,  1592,  1593,   169,   813,   241,   815,   117,   238,    72,
      71,    72,    26,   238,   244,  1019,     3,  1517,   146,   147,
     250,   840,   841,   842,    87,   250,    87,   846,   847,   551,
     849,   850,   851,   232,   853,  1535,    99,   239,   560,   858,
     200,   860,    66,    67,   204,   152,   239,   157,   857,   251,
      67,   573,  1668,   252,   253,   254,   249,  1452,  1453,   239,
      75,   583,    77,  1458,  1459,  1460,  1461,     3,    92,    93,
    1465,  1466,  1467,  1468,  1151,  1151,    93,    91,   600,   191,
     165,   603,    71,    72,   196,  1177,  1178,   111,   112,   113,
     114,   239,   239,   108,  1253,   112,     3,   114,    87,  1599,
       7,   249,   249,  1099,   238,   240,   130,   131,  1651,  1652,
     943,   944,  1097,     8,   131,   250,  1091,   881,    73,   239,
      11,    12,   242,    14,    15,    16,    17,    18,    19,    20,
     894,   145,    93,   238,    25,  1635,  1636,  1096,    11,    12,
     250,  1641,    97,    98,    99,    18,    19,    20,  1648,  1649,
     164,   112,    25,   114,  1342,  1343,     8,     9,  1346,  1347,
    1348,  1556,   117,   231,   232,   233,   234,   235,    11,    12,
     131,    14,    15,    16,    17,    18,    19,    20,  1011,   948,
    1515,   195,    25,   238,   505,    28,    29,    30,    31,    32,
     511,   713,   714,  1528,  1694,    71,    72,   240,    26,   213,
      92,   239,   724,   241,   867,  1190,  1791,   250,   871,    11,
      12,    87,    14,    15,    16,    17,    18,    19,    20,   111,
    1039,   113,   744,    25,   240,   238,  1045,    29,    30,    31,
      32,  1050,    60,   239,   250,   238,   231,   232,   130,   239,
    1332,   241,  1334,   249,   239,    73,  1065,   769,   238,   789,
     790,   791,   792,   793,   794,   795,  1085,   240,   241,   781,
      88,   801,   802,   803,   804,  1371,   238,  1100,  1101,    97,
      98,    99,  1378,   238,  1380,  1381,     3,     4,     5,  1674,
     238,     8,     9,    10,  1679,  1576,   238,  1682,  1683,   117,
    1581,  1582,    73,  1584,  1585,   197,   198,   238,   859,  1590,
    1591,   203,   170,   238,   172,  1124,   828,    73,   238,   238,
     241,   241,   214,   244,   244,   238,    97,    98,    99,   250,
     250,   239,   238,   241,   152,  1431,  1301,     5,  1303,  1304,
    1305,    97,    98,    99,  1369,  1370,   117,   859,   229,   230,
     231,   232,   233,   234,   235,   239,    99,   241,  1341,  1342,
    1343,   117,   238,  1346,  1347,  1348,   229,   230,   231,   232,
     233,   234,   235,   241,   239,   887,   244,   242,   239,   891,
      73,   242,   250,   239,    66,   241,   861,  1469,  1470,    73,
     238,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   238,    97,    98,    99,   919,   920,   239,
      92,   241,   242,    97,    98,    99,   238,  1226,   251,  1515,
    1519,  1068,  1069,  1522,   117,  1524,   239,   939,   241,   111,
    1239,   113,  1528,   117,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   239,   957,   241,  1728,   130,   961,
    1731,  1388,  1389,  1734,  1735,     0,   390,   391,   970,   971,
     180,   181,   179,   975,   976,   182,   183,   243,   185,   186,
     187,   188,   189,   190,   194,   192,   193,   239,   238,   199,
     242,    26,    73,   238,   201,   202,   241,   207,   239,   206,
     241,   242,   209,   210,   211,   212,  1559,  1560,   215,   216,
     217,   218,   222,   220,   221,   238,    97,    98,    99,   226,
     227,   228,     1,  1025,     3,  1066,  1028,  1029,     1,  1031,
       3,   238,   180,   181,   491,   492,   117,   494,  1040,  1041,
    1042,   248,   239,   238,   241,   242,   194,  1633,     1,  1051,
       3,  1053,  1054,  1055,   238,  1354,    91,  1059,   238,   207,
     239,  1647,   239,   242,  1066,   242,  1068,  1069,   239,  1071,
    1072,   242,  1371,     1,   222,     3,  1078,  1376,  1377,  1378,
    1379,  1380,  1381,  1559,  1560,  1126,   238,  1089,   239,  1750,
    1751,   242,    73,  1058,    70,   239,    72,   242,   242,   788,
     789,   790,   791,   792,   793,   794,   795,  1109,  1110,   241,
     145,    87,   801,   802,   803,   804,    97,    98,    99,   239,
       3,  1123,   242,    99,  1126,   239,     3,   239,   242,   164,
     242,   239,  1431,     3,   242,   239,   117,   239,   242,  1725,
     242,   239,  1162,  1163,   242,  1165,  1166,  1167,  1168,   540,
     541,  1153,  1172,  1173,  1174,  1175,  1455,   239,     3,  1161,
     195,   240,   239,   239,  1603,   242,   242,   239,  1607,   240,
     242,   239,  1611,   239,   242,     1,   242,     3,   213,  1618,
    1493,  1494,  1495,  1622,  1497,  1498,  1499,  1626,  1501,  1502,
    1503,   239,   239,   239,   242,   242,   242,   239,   238,     3,
     242,  1203,   239,  1789,   241,   239,   239,   241,   241,   239,
     239,   241,   241,  1215,  1800,  1801,  1515,   239,  1517,   241,
     239,  1186,   241,   240,   913,   914,  1228,  1229,   239,  1528,
     241,   239,   239,   241,   241,   240,  1535,  1481,  1240,  1241,
     240,  1485,  1244,  1245,  1285,  1489,   239,  1249,   241,   239,
     238,   241,  1496,   113,   114,   239,  1500,   241,    25,     5,
    1504,   121,   122,   123,   124,   125,   240,   244,   239,   129,
     241,   241,   241,   133,   134,   239,   241,   241,  1280,   241,
     239,  1580,   241,  1285,     3,  1287,   975,   976,     1,     3,
       3,  1293,     3,   239,  1296,   241,   239,   986,   241,   239,
    1599,   241,   239,     5,   241,    99,   239,  1309,   241,    88,
      26,  1313,  1314,   173,   174,  1791,   239,   239,   241,   113,
     114,   239,     3,   241,  1289,     3,   242,   121,   122,   123,
     124,   125,     3,   241,  1633,   129,  1635,  1636,   241,   133,
     134,   239,  1641,   241,   239,   239,   241,   241,  1647,  1648,
    1649,   239,   239,   241,   241,    11,    12,   241,    14,    15,
      16,    17,    18,    19,    20,   241,  1368,  1369,  1370,    25,
    1372,   239,     3,   241,    30,    31,    32,   250,     3,   173,
     174,   239,   239,   241,   241,  1698,  1388,  1389,  1353,  1702,
       3,  1393,  1394,  1706,     3,  1694,  1398,   239,   241,   241,
    1402,   239,  1367,   241,   239,   239,   241,   241,    72,   241,
    1375,    11,    12,   241,    14,    15,    16,    17,    18,    19,
      20,     3,  1387,    23,    24,    25,  1725,     3,    28,    29,
      30,    31,    32,   239,   239,   241,   241,   239,   239,   241,
     241,   239,   239,   241,   241,  1447,   239,   239,   241,   241,
     115,  1750,  1751,   239,   239,   241,   241,   239,   170,   241,
    1462,   464,     3,   466,     3,   240,  1431,   238,    73,   249,
       3,     3,   241,  1162,  1163,   240,  1165,  1166,  1167,  1168,
     157,    56,     3,  1172,  1173,  1174,  1175,   251,    72,   241,
    1789,     1,   242,     3,     4,     5,   250,   240,     8,     9,
      10,  1800,  1801,   241,   238,   238,   238,  1509,    99,     1,
     148,  1476,   238,   238,     3,    55,    58,  1519,   241,   225,
    1522,     3,  1524,   243,     3,     3,     3,    54,     3,     5,
     239,    11,    12,   241,    14,    15,    16,    17,    18,    19,
      20,   241,   241,    57,  1546,    25,   238,  1549,   238,  1514,
      30,    31,    32,   238,   238,   238,  1558,     3,   238,   238,
       3,   149,   238,  1565,   238,   238,   238,     3,   238,   238,
    1572,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     238,   241,   241,   240,     1,   240,     3,     4,     5,   241,
     240,     8,     9,    10,   241,  1597,  1598,   239,   243,    51,
      56,   164,   241,     3,   241,   240,   242,   241,   240,   239,
     239,   239,   239,    30,    31,    32,   238,   241,   239,   239,
       3,   239,   241,   240,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,  1325,   240,   250,    52,
     242,   242,     3,   242,  1646,   242,   242,    26,   238,  1614,
      22,   251,   238,   238,   241,   238,     3,     1,   238,     3,
       4,     5,   241,   241,     8,     9,    10,   238,   238,   179,
    1672,   238,   182,   183,   238,   185,   186,   187,   188,   189,
     190,   241,   192,   193,  1686,  1687,    30,    31,    32,   241,
      52,   201,   202,   241,   241,   241,   206,   225,   241,   209,
     210,   211,   212,  1668,    27,   215,   216,   217,   218,   225,
     220,   221,   225,     3,   240,     3,  1718,  1719,   242,   250,
     223,   239,  1724,     3,   239,    59,     5,     1,   238,     3,
       4,     5,   239,   239,     8,     9,    10,   239,   248,   239,
     239,   239,   239,   239,   239,   239,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    30,    31,    32,   242,
    1449,   149,   179,     3,     3,   182,   183,   241,   185,   186,
     187,   188,   189,   190,   241,   192,   193,   240,   250,   241,
     240,     3,   241,     3,   201,   202,  1788,     3,  1790,   206,
      54,   242,   209,   210,   211,   212,   238,   242,   215,   216,
     217,   218,   242,   220,   221,   242,    80,   242,   242,   226,
     227,   228,   240,   238,   231,   232,    90,   244,   242,   242,
     242,   238,   239,   242,   242,   242,    34,   244,   223,   246,
     247,   248,   223,   242,   250,   179,   251,   241,   182,   183,
     239,   185,   186,   187,   188,   189,   190,     3,   192,   193,
      52,   240,   242,    74,   238,   242,   242,   201,   202,     3,
     242,   242,   206,   238,   242,   209,   210,   211,   212,    52,
     241,   215,   216,   217,   218,   241,   220,   221,   241,   225,
       3,   241,   226,   227,   228,   241,   239,   231,   232,   239,
     239,   239,     5,   238,   238,   239,   239,   239,   242,   239,
     244,   239,   246,   247,   248,   179,   239,   239,   182,   183,
     238,   185,   186,   187,   188,   189,   190,    52,   192,   193,
     238,   241,   244,     3,   241,   240,     3,   201,   202,   240,
     242,    34,   206,   242,   239,   209,   210,   211,   212,   241,
       3,   215,   216,   217,   218,   251,   220,   221,     3,     3,
       3,     3,   226,   227,   228,     3,     3,   231,   232,   233,
       3,     3,    59,   241,   238,   242,     1,   149,     3,     4,
      51,   242,   246,   247,   248,     1,    51,     3,     4,     5,
     113,   114,     8,     9,    10,     3,    54,   241,   121,   122,
     123,   124,   125,   223,   239,   241,   129,   239,    33,     3,
     133,   134,    37,    38,    30,    31,    32,    42,    43,    44,
     239,    46,   239,    26,    49,   241,   225,    52,   242,   242,
     245,   240,    59,     3,   157,   242,    61,    62,    63,    64,
     242,   242,   242,    68,     3,   242,   242,     3,   241,    59,
     173,   174,   241,   241,   241,   250,   241,    60,     1,   241,
       3,     4,     5,   241,    80,     8,     9,    10,    71,    72,
      73,   241,    54,   242,    90,   100,   101,   242,   242,   242,
     242,   242,   242,   242,    87,    88,   240,    30,    31,    32,
     242,   240,    31,   241,    97,    98,    99,   241,   241,   241,
     460,    34,  1003,   128,    47,     8,    25,   132,   183,   190,
      53,   550,  1431,   394,   117,   499,  1124,   775,  1550,  1285,
     554,  1413,   686,   834,   473,  1139,  1360,   392,   957,     1,
    1075,     3,     4,     5,  1080,   670,     8,     9,    10,  1660,
     997,   972,  1353,  1490,  1290,   628,   513,   540,  1105,   152,
     541,    -1,   320,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    47,   192,   193,    -1,    -1,
      -1,    53,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,    -1,   243,    -1,
     245,    -1,   238,   248,    -1,    -1,    -1,    -1,    -1,    -1,
     246,   247,   248,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,     1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    57,    -1,    -1,
      -1,    -1,    -1,   246,   247,   248,    -1,   179,    68,    69,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
     110,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,     1,    -1,     3,     4,     5,   238,    -1,     8,     9,
      10,    -1,    -1,    -1,   246,   247,   248,   137,   138,   139,
     140,   141,   142,   143,   144,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,   153,   154,   155,   156,    -1,    -1,   159,
     160,   161,   162,    -1,    -1,    -1,    -1,    47,    -1,    -1,
      -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,
       4,     1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      30,    31,    32,    37,    38,    -1,    -1,    -1,    42,    43,
      44,    -1,    46,    -1,    -1,    49,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,    62,    63,
      64,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,
      -1,    -1,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    47,   192,   193,   128,    -1,    -1,    -1,   132,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,    -1,    -1,    -1,   241,   238,   243,
      -1,   245,   242,    57,   248,    -1,   246,   247,   248,    -1,
      -1,    -1,    -1,   179,    68,    69,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,   110,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,     1,    -1,     3,
       4,     5,   238,    -1,     8,     9,    10,    -1,    -1,    -1,
     246,   247,   248,   137,   138,   139,   140,   141,   142,   143,
     144,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,   153,
     154,   155,   156,    -1,    -1,   159,   160,   161,   162,    -1,
      -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,     3,     4,     1,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    30,    31,    32,    37,
      38,    -1,    -1,    -1,    42,    43,    44,    -1,    46,    -1,
      -1,    49,    -1,    47,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    61,    62,    63,    64,    -1,    -1,    -1,
      68,    -1,    -1,    -1,    -1,    -1,    74,     1,    -1,     3,
       4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   100,   101,    -1,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
     128,    -1,    -1,    -1,   132,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
      -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,   247,   248,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
      -1,    -1,    -1,    -1,   238,   243,    -1,   245,    -1,    -1,
     248,    -1,   246,   247,   248,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,     1,
      -1,     3,     4,     5,   238,    -1,     8,     9,    10,   224,
     225,    -1,   246,   247,   248,    -1,   231,    -1,   233,    -1,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,     1,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    30,    31,
      32,    37,    38,    -1,    -1,    -1,    42,    43,    44,    -1,
      46,    -1,    -1,    49,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    61,    62,    63,    64,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      -1,     3,     4,     5,    -1,    -1,     8,     9,    10,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,    -1,    -1,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,   128,    -1,    -1,    -1,   132,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,   247,   248,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,    -1,    -1,    -1,    -1,   238,   243,    -1,   245,
      -1,    -1,   248,    -1,   246,   247,   248,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,     1,    -1,     3,     4,     5,   238,    -1,     8,     9,
      10,    -1,    -1,    -1,   246,   247,   248,     1,    -1,     3,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    26,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      -1,    -1,    -1,    37,    38,    -1,    -1,    -1,    42,    43,
      44,    -1,    46,    -1,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    -1,    68,    -1,    -1,    71,    72,    73,
       1,    -1,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    97,    98,    99,   100,   101,    -1,    -1,
      -1,   224,   225,    -1,    -1,    -1,    -1,    -1,   231,    -1,
     233,    -1,   235,   117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,   132,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   152,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   243,
      -1,   245,    -1,    -1,   248,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,     1,    -1,     3,     4,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,    33,    -1,    -1,    -1,    37,
      38,    -1,    -1,    -1,    42,    43,    44,   238,    46,    -1,
       1,    49,     3,     4,    52,    -1,    -1,   248,    -1,    -1,
      -1,    -1,    -1,    61,    62,    63,    64,    -1,    -1,    -1,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    -1,    -1,    -1,    37,    38,    -1,    -1,
      -1,    42,    43,    44,    -1,    46,    -1,    -1,    49,    -1,
      -1,    -1,   100,   101,    -1,    -1,    -1,    -1,    -1,    -1,
      61,    62,    63,    64,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,     1,    74,     3,     4,    -1,    -1,    -1,    -1,
     128,    -1,    -1,    -1,   132,    -1,    -1,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,   100,
     101,    25,    -1,    -1,    33,    -1,    30,    -1,    37,    38,
      -1,    -1,    -1,    42,    43,    44,    -1,    46,    -1,     1,
      49,     3,     4,    -1,    -1,    -1,    -1,   128,    -1,    -1,
      -1,   132,    61,    62,    63,    64,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    -1,    -1,    -1,    37,    38,    -1,    -1,    -1,
      42,    43,    44,    -1,    46,    -1,    -1,    49,    -1,    -1,
      -1,   100,   101,    -1,    -1,    -1,    -1,   225,    -1,    61,
      62,    63,    64,    -1,    -1,    -1,    68,    -1,    -1,    -1,
      -1,     1,    74,     3,     4,   243,    -1,   245,    -1,   128,
     248,    -1,    -1,   132,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,   101,
      -1,    -1,    -1,    33,   225,    -1,    -1,    37,    38,    -1,
      -1,    -1,    42,    43,    44,    -1,    46,    -1,    -1,    49,
      -1,    -1,   243,    -1,   245,    -1,   128,   248,    -1,    -1,
     132,    61,    62,    63,    64,    -1,    -1,    -1,    68,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
     100,   101,    -1,    -1,    -1,    -1,   225,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   228,   229,   230,   231,   232,   233,
     234,   235,   241,    -1,   243,    -1,   245,    -1,   128,   248,
      -1,    -1,   132,    66,    67,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    92,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   243,    -1,   245,    -1,    -1,   248,    -1,   111,   112,
     113,   114,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   130,   131,    -1,
       3,     4,     5,    -1,    -1,     8,     9,    10,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   243,    -1,   245,   179,    -1,   248,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    92,
      93,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,   111,   112,
     113,   114,    -1,   246,   247,   248,    -1,    -1,     3,     4,
       5,    -1,    -1,     8,     9,    10,    -1,   130,   131,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,   101,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,     3,     4,     5,    -1,   238,     8,     9,    10,    -1,
      -1,    -1,    -1,   246,   247,   248,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,   101,
     215,   216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,
      -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,     3,
       4,     5,    -1,   238,     8,     9,    10,    -1,   243,    -1,
     245,   246,   247,   248,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,    53,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,    -1,     3,     4,     5,   238,    -1,     8,     9,
      10,   243,    -1,   245,   246,   247,   248,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,
      -1,   185,   186,   187,   188,   189,   190,    -1,   192,   193,
      80,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      90,    -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,
      -1,   215,   216,   217,   218,    -1,   220,   221,    -1,    -1,
      -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,    -1,
       3,     4,     5,    -1,   238,     8,     9,    10,    -1,    -1,
      -1,    -1,   246,   247,   248,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,     3,     4,     5,    -1,   238,     8,
       9,    10,    -1,    -1,    -1,    -1,   246,   247,   248,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    -1,    -1,    -1,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,   182,
     183,    -1,   185,   186,   187,   188,   189,   190,    -1,   192,
     193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,   202,
      -1,    -1,    -1,   206,    -1,   208,   209,   210,   211,   212,
      -1,    -1,   215,   216,   217,   218,    -1,   220,   221,    -1,
      -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,   232,
      -1,     3,     4,     5,    -1,   238,     8,     9,    10,    -1,
      -1,    -1,    -1,   246,   247,   248,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     179,    -1,    -1,   182,   183,    -1,   185,   186,   187,   188,
     189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
     209,   210,   211,   212,    -1,    -1,   215,   216,   217,   218,
      -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,
      -1,    -1,   231,   232,    -1,     3,     4,     5,    -1,   238,
       8,     9,    10,    -1,    -1,   244,    -1,   246,   247,   248,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    47,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,    -1,
     182,   183,    -1,   185,   186,   187,   188,   189,   190,    -1,
     192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,   211,
     212,    -1,    -1,   215,   216,   217,   218,    -1,   220,   221,
      -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,   231,
     232,    -1,     3,     4,     5,    -1,   238,     8,     9,    10,
     242,    -1,    -1,    -1,   246,   247,   248,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    -1,    -1,    -1,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,   187,
     188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,
      -1,   209,   210,   211,   212,    -1,    -1,   215,   216,   217,
     218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,   227,
     228,    -1,    -1,   231,   232,    -1,     3,     4,     5,    -1,
     238,     8,     9,    10,    -1,    -1,    -1,    -1,   246,   247,
     248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    -1,    -1,    -1,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,    -1,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,    -1,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,    -1,
     231,   232,    -1,     3,     4,     5,    -1,   238,     8,     9,
      10,   242,    -1,    -1,    -1,   246,   247,   248,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,   186,
     187,   188,   189,   190,    -1,   192,   193,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,   206,
      -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,   216,
     217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,   226,
     227,   228,    -1,    -1,   231,   232,    -1,     3,     4,     5,
      -1,   238,     8,     9,    10,    -1,    -1,    -1,    -1,   246,
     247,   248,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   179,
      -1,    -1,   182,   183,    -1,   185,   186,   187,   188,   189,
     190,    -1,   192,   193,    -1,    -1,    -1,    -1,     3,     4,
       5,   201,   202,     8,     9,    10,   206,    -1,    -1,   209,
     210,   211,   212,    -1,    -1,   215,   216,   217,   218,    -1,
     220,   221,    -1,    -1,    -1,    -1,   226,   227,   228,    -1,
      -1,   231,   232,    -1,    -1,    -1,    -1,    -1,   238,    -1,
      -1,    -1,    -1,    -1,    -1,    50,   246,   247,   248,    -1,
      -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,    10,
      -1,    -1,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    80,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
     226,   227,   228,    -1,    -1,   231,   232,     3,     4,     5,
      -1,    -1,     8,     9,    10,    -1,    -1,    -1,    -1,    -1,
     246,   247,   248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,
     185,   186,   187,   188,   189,   190,    -1,   192,   193,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,
      -1,   206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,
     215,   216,   217,   218,    -1,   220,   221,     3,     4,     5,
      -1,    -1,     8,     9,    10,    -1,    -1,    -1,   179,    -1,
      -1,   182,   183,   238,   185,   186,   187,   188,   189,   190,
      -1,   192,   193,   248,    -1,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,    -1,   206,    -1,   208,   209,   210,
     211,   212,    -1,    -1,   215,   216,   217,   218,    -1,   220,
     221,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   238,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   248,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,   208,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   248,   179,    -1,    -1,   182,   183,    -1,   185,
     186,   187,   188,   189,   190,    -1,   192,   193,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   201,   202,    -1,    -1,    -1,
     206,    -1,    -1,   209,   210,   211,   212,    -1,    -1,   215,
     216,   217,   218,    -1,   220,   221,     1,    -1,     3,    11,
      12,     6,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,   238,    25,    -1,    -1,    28,    29,    30,    31,
      32,    26,   248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    36,    37,    38,    39,    40,    41,    42,    -1,    -1,
      45,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,
      65,    -1,    -1,    68,    -1,    70,    71,    72,    73,    -1,
      -1,    -1,    -1,    78,    79,    -1,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    -1,    -1,    -1,    94,
      95,    96,    97,    98,    99,    -1,    -1,   102,   103,   104,
     105,   106,    -1,    -1,   109,    -1,    -1,    -1,   113,   114,
      -1,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,    -1,    -1,   129,    -1,    -1,    -1,   133,   134,
     135,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     145,    -1,    -1,    -1,    -1,   150,   151,   152,    -1,    -1,
      -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,   173,   174,
      28,    29,    30,    31,    32,     3,    -1,    -1,    -1,   184,
      -1,    -1,    -1,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,    11,    12,   241,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     248,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    11,
      12,   239,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    11,    12,   242,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,
     242,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    11,    12,   242,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    11,    12,   242,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,
     242,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    11,    12,   242,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    11,    12,    -1,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    11,    12,   242,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,
      -1,    -1,   224,    -1,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,
     242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    11,    12,   242,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,   242,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,   242,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    11,    12,   242,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,
      30,    31,    32,    11,    12,    -1,    14,    15,    16,    17,
      18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,
      28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,
     224,    -1,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    11,    12,   242,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,   242,    -1,    -1,    -1,   224,    -1,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,    -1,    -1,
      -1,    -1,    11,    12,   242,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    11,    12,   241,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      11,    12,   241,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    11,    12,   241,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    11,    12,
     241,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,   224,    -1,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    11,    12,   241,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,   241,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    11,    12,
     241,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,   241,    -1,    -1,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,    -1,   224,
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,   239,    -1,    -1,    -1,
      -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   224,   225,    -1,   239,    -1,
      -1,    -1,   231,    -1,   233,   224,   235,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
     239,    -1,    -1,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,    -1,    -1,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,    -1,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    26,    -1,    -1,   239,    -1,    -1,    -1,
      -1,    -1,    35,    36,    37,    -1,    39,    40,    41,    42,
      -1,    -1,    45,    -1,    -1,    48,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,    -1,
      -1,    -1,    65,    -1,    -1,    68,    -1,    70,    71,    72,
      73,    -1,    -1,    -1,    -1,    78,    79,    -1,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    -1,    -1,
      -1,    94,    95,    96,    97,    98,    99,    -1,    -1,   102,
     103,   104,   105,   106,    -1,    -1,   109,    -1,    -1,    -1,
     113,   114,    -1,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,    -1,    -1,   129,    -1,    -1,    -1,
     133,   134,   135,   136,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   145,    -1,    -1,    -1,    -1,   150,   151,   152,
      -1,    -1,    -1,    -1,     1,    -1,     3,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     173,   174,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
      -1,   184,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,
      37,    -1,    39,    40,    41,    42,    -1,    -1,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,   225,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,
      -1,    -1,    -1,   150,   151,   152,    -1,    -1,    -1,    -1,
      -1,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,   173,   174,    28,    29,
      30,    31,    32,    -1,    -1,    11,    12,   184,    14,    15,
      16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,   225,    28,
      29,    30,    31,    32,    11,    12,    -1,    14,    15,    16,
      17,    18,    19,    20,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    28,    29,    30,    31,    32,    11,    12,    -1,    14,
      15,    16,    17,    18,    19,    20,    -1,    -1,    -1,    -1,
      25,    -1,    -1,    28,    29,    30,    31,    32,    11,    12,
      -1,    14,    15,    16,    17,    18,    19,    20,    -1,    -1,
      -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,    32,
      11,    12,    -1,    14,    15,    16,    17,    18,    19,    20,
      -1,    -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,
      31,    32,    11,    12,    -1,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
     200,    -1,    11,    12,   204,    14,    15,    16,    17,    18,
      19,    20,    -1,    -1,    -1,    -1,    25,    -1,    -1,    28,
      29,    30,    31,    32,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,    11,    12,    -1,
      14,    15,    16,    17,    18,    19,    20,    -1,    -1,    -1,
      -1,    25,    -1,    -1,    28,    29,    30,    31,    32,    11,
      12,    -1,    14,    15,    16,    17,    18,    19,    20,    -1,
      -1,    -1,    -1,    25,    -1,    -1,    28,    29,    30,    31,
      32,    11,    12,    -1,    14,    15,    16,    17,    18,    19,
      20,    -1,    -1,    -1,    -1,    25,   224,    -1,    28,    29,
      30,    31,    32,   231,   232,   233,    -1,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   224,    -1,    -1,    -1,    -1,    -1,    -1,
     231,    -1,   233,    -1,   235,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,     1,    -1,     3,    -1,    -1,     6,
      -1,    -1,    -1,    -1,   224,    -1,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,
      37,    -1,    39,    40,    41,    42,    -1,    -1,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,     6,
      -1,    -1,   149,   150,   151,   152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,    36,
      37,    38,    39,    40,    41,    42,    -1,   184,    45,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,     6,
      -1,    -1,   149,   150,   151,   152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,    36,
      37,    -1,    39,    40,    41,    42,    -1,   184,    45,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,     6,
      -1,    -1,    -1,   150,   151,   152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,    36,
      37,    -1,    39,    40,    41,    42,    -1,   184,    45,    -1,
      -1,    48,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,    -1,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,     1,    -1,     3,    -1,   145,     6,
      -1,    -1,    -1,   150,   151,   152,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    35,    36,
      37,    38,    39,    40,    41,    42,    -1,   184,    45,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,    -1,
      -1,    78,    79,    -1,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    94,    95,    96,
      97,    98,    99,    -1,    -1,   102,   103,   104,   105,   106,
      -1,    -1,   109,    -1,     3,    -1,   113,   114,    -1,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
      -1,    -1,   129,    -1,    -1,    -1,   133,   134,   135,   136,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    36,   145,    -1,
      39,    40,    41,   150,   151,   152,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   173,   174,    -1,    -1,
      -1,    70,    -1,    -1,    73,    -1,    -1,   184,    -1,    -1,
      79,    -1,    81,    82,    83,    84,    85,    86,    -1,    -1,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    98,
      99,    -1,    -1,   102,   103,   104,   105,   106,    -1,    -1,
      -1,    -1,    -1,    -1,   113,   114,    -1,    -1,   117,   118,
     119,   120,   121,   122,   123,   124,   125,    -1,    -1,    -1,
     129,    -1,    -1,    -1,   133,   134,   135,   136,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   173,   174,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   184
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    26,    91,   145,   164,   195,   213,   272,   273,   276,
     277,   295,   297,   301,   305,   342,   465,     3,    27,   278,
     279,     3,   238,     3,     3,     3,     0,   295,    76,    78,
     345,    26,   240,    27,   239,   238,     3,   241,   241,   296,
     296,     3,    27,   278,     3,     4,     5,     8,     9,    10,
      30,    31,    32,   179,   182,   183,   185,   186,   187,   188,
     189,   190,   192,   193,   201,   202,   206,   209,   210,   211,
     212,   215,   216,   217,   218,   220,   221,   226,   227,   228,
     231,   232,   238,   246,   247,   248,   274,   320,   324,   331,
     279,     3,    87,   461,   239,   165,   298,   302,   343,    27,
     238,     8,   324,   324,   324,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   324,
       1,   324,   324,   324,   324,   320,   321,   226,   227,   228,
     324,     1,   324,   320,   323,    11,    12,    14,    15,    16,
      17,    18,    19,    20,    25,    28,    29,    30,    31,    32,
     224,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   238,   244,   250,    99,   462,   239,   242,     5,   306,
     197,   203,   214,   299,   300,   180,   181,   194,   207,   222,
     303,   304,   243,   348,   320,   323,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     225,   242,   324,   324,   324,   248,   239,   249,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   320,   323,     3,   320,     3,     3,   241,
     239,     3,   241,   310,   191,   196,     3,     3,   198,   300,
     240,   240,   240,   240,   240,   199,   304,   238,   238,   347,
     242,   242,   242,   242,   242,   242,   242,   239,   242,   242,
     242,   242,   242,   242,   239,   242,   242,   239,   239,   239,
     242,   242,   242,   242,   242,   320,   323,   320,   225,   242,
      23,    24,   225,   251,   240,   463,    72,    87,    99,   459,
     460,     5,   244,   307,   241,   241,   241,   241,   320,     3,
       3,     3,     5,    88,   349,     3,   244,   248,   276,   334,
     335,   336,   400,   401,   402,    26,   346,   320,   320,   320,
     320,   320,   225,   249,   320,   320,   320,   320,   320,   239,
       3,   332,     3,     3,    87,    70,   454,   455,   459,   242,
       3,    47,   163,   166,   169,   308,   241,   241,   241,   241,
     241,     3,   383,   239,   242,   250,     3,   402,   403,    71,
      72,    87,   239,   242,   239,   241,   242,     3,   241,   242,
     242,   242,   242,   242,   320,     1,   249,   251,   251,   251,
      72,   464,   239,   241,   241,   241,     3,     3,   115,   447,
     170,   310,   331,   240,    88,   383,     1,   320,   238,   239,
     249,   113,   114,   121,   122,   123,   124,   125,   129,   133,
     134,   173,   174,   337,   374,   337,    99,   337,   375,   401,
       3,   336,    73,   344,   249,     3,   239,   242,     3,   241,
     240,   448,    56,   311,   170,   172,   170,   172,   320,   383,
     251,   225,   251,   248,   402,   402,   157,   338,   338,   338,
     338,     3,     1,     6,    37,    42,    48,    60,    61,    65,
      68,    71,    72,    78,    87,    88,    94,    95,   109,   116,
     126,   145,   150,   151,   152,   276,   280,   350,   361,   366,
     367,   406,    72,   241,   274,   224,   231,   233,   235,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   449,   450,
     451,   452,   453,   456,   457,     3,   241,   311,   310,   311,
     310,   200,   204,   384,   385,   386,   388,   320,   403,   242,
     250,   407,   408,   408,   408,   408,   240,   241,   332,     1,
     238,   312,   313,   238,   287,   288,   331,   407,   332,   238,
       1,   148,   360,   238,   375,   375,     1,   375,     1,    73,
      97,    98,   117,   157,   275,   376,   382,   383,   407,     3,
     238,   327,   328,   238,   328,     1,    57,    68,    69,   110,
     137,   138,   139,   140,   141,   142,   143,   144,   153,   154,
     155,   156,   159,   160,   161,   162,   238,   418,   419,   420,
     422,   424,   425,   360,   238,   285,   286,   238,    38,   367,
     332,     1,     3,    73,   117,   157,   275,   389,   390,   396,
     407,     3,    35,    36,    39,    40,    41,    45,    70,    73,
      79,    81,    82,    83,    84,    85,    86,    89,    96,    97,
      98,    99,   102,   103,   104,   105,   106,   117,   118,   119,
     120,   135,   136,   184,   329,   330,   374,    38,   241,   350,
     368,   369,   350,    55,   338,   374,     3,   447,   241,    58,
     450,   456,   453,   456,   225,   457,   241,   225,   309,   241,
     309,   320,   386,   238,   250,   251,   249,   320,     3,     3,
       3,     3,     5,   241,   240,   241,    66,    67,    92,    93,
     111,   112,   113,   114,   130,   131,   314,   315,   243,   290,
     291,   320,   239,   241,   240,   287,   241,     3,    54,    73,
      97,    98,   117,   157,   407,   411,   320,   338,   338,   241,
     338,   241,   379,   380,   407,   381,   241,   239,   377,   238,
     407,   314,   315,   320,   322,   239,   241,   314,   315,   241,
      57,   238,   420,   424,     3,     7,   427,   428,   238,   238,
     238,   238,   238,   238,   238,   238,     3,   426,   426,   426,
     426,   238,   238,   238,   238,     1,    80,    90,   421,   426,
      57,   418,   241,   240,   241,   240,     3,    75,    77,   108,
     408,     1,     3,   225,   367,   149,   241,   241,   240,   393,
     394,   407,   395,   241,   239,   391,   243,   397,     1,     4,
      33,    37,    38,    42,    43,    44,    46,    49,    61,    62,
      63,    64,    68,   100,   101,   128,   132,   243,   245,   248,
     289,   316,   331,   339,   434,   434,     1,     3,   412,   413,
       1,     3,   414,   415,     1,   415,     1,    97,   146,   147,
     372,   373,     1,   413,     3,   319,   439,   238,   290,   312,
     328,   238,   290,   328,   373,   225,   367,    51,   408,   338,
      56,   225,   225,   232,   252,   253,   254,   457,   458,   164,
     241,   241,   208,   231,   232,   320,   387,   387,   242,   225,
     240,   241,   320,   239,   239,   239,   239,     3,     9,    10,
     238,   294,   331,   339,   340,   341,   242,   287,   320,   240,
     407,     3,   242,   408,   408,   408,   382,   382,   378,   382,
     383,   382,     1,   244,   322,   404,   405,   238,   239,   242,
     239,   239,   242,   327,   239,   239,   242,   320,   241,   241,
     240,   240,   239,   241,    50,    80,    90,   324,   430,   430,
     430,   430,   430,   430,   430,   430,   250,   239,   241,   241,
     241,   241,   430,   430,   430,   430,   242,   426,   231,   232,
     429,   238,   294,   238,   294,     1,   238,   241,   242,   242,
     242,   291,   242,   239,     3,    52,   320,   396,   396,   392,
     396,   389,   396,     1,     9,   238,     1,   328,    11,   240,
     241,   238,   241,   331,   339,     1,    52,   225,   434,   437,
     238,   238,   238,   339,   331,   238,   339,   434,    74,   225,
     437,   238,   339,   238,   238,   238,   238,   294,   233,   238,
     331,   323,   241,   434,   438,   276,   238,   241,    11,   240,
     241,   240,   250,   409,   410,   239,   241,   241,   240,   409,
     239,   241,   241,   241,   241,   338,   241,   241,   238,    22,
     328,   290,   328,   241,   328,   241,   338,     3,    52,   357,
     291,   408,   252,   253,   254,   225,   241,   208,   208,   225,
     225,   320,   320,    27,   241,   315,   314,    67,   315,    66,
     314,   293,   320,   240,   239,   241,   358,   320,     1,   241,
     355,   332,   332,     3,   333,   382,   242,     3,   242,   239,
     242,     1,   322,   405,   315,   328,   314,   320,   315,   314,
     328,   242,   320,   238,   320,   427,   250,   320,   324,   320,
     324,   223,   239,   239,   239,   239,   239,   239,   239,   239,
     324,     3,   239,   239,   239,   239,   429,    13,    21,   292,
     293,     1,   292,    59,   242,   352,   351,   332,   241,     5,
     359,   149,   396,   244,   322,   398,   399,   241,   241,   320,
     320,   322,   241,   240,    52,     3,    52,   434,   320,   320,
     320,   241,   241,     1,   339,   240,     3,    74,     1,   320,
     241,   320,   320,     1,   320,   293,   276,     1,    80,    90,
     233,   317,   318,   320,   249,   438,   242,   323,   101,   245,
     289,   316,   320,   101,   289,   316,   320,   320,   320,   250,
     412,   320,   414,   407,   413,     3,   320,   241,   328,   241,
     241,   312,   408,   367,   368,     1,   332,   332,   458,   387,
     387,   251,   242,   242,   242,   242,   242,   242,   239,   242,
     225,   320,   340,    47,   323,   362,   363,   241,    54,   354,
     238,   241,   241,   240,   239,   241,   238,   404,   242,   242,
     242,   242,   241,   242,   242,   242,   241,   420,   424,   225,
     320,    34,   431,   223,   223,   320,   430,   430,   293,   430,
     430,   430,   430,   293,   251,   250,   430,   430,   430,   430,
      13,    21,   238,   426,   238,   426,   239,   242,   242,   242,
     241,    71,    72,    87,   445,   446,    71,    72,    87,   276,
     280,   440,   442,   443,   444,   241,   239,   367,     3,   242,
     239,   242,   241,   241,   242,   320,    52,   435,   242,   242,
     242,   242,   240,   320,    74,   436,   242,   242,   242,   242,
     242,   242,   242,   438,   242,   320,   320,   242,    86,   239,
     242,   241,   242,   238,   238,   320,   320,   241,   238,   320,
     320,   241,   225,   320,   413,   241,   239,   242,   241,   241,
       3,   370,   371,   291,    52,   241,   241,   241,   241,   242,
     251,   242,   251,   293,   320,   225,   225,    53,   363,   320,
     280,   325,   326,   442,   446,   320,     3,     1,   242,   320,
     328,   328,   328,   328,   241,   241,   320,   239,   239,   251,
     320,   320,   239,   239,     3,   239,   432,   433,   239,   239,
     239,   239,   239,   242,   324,   239,   239,   239,   239,   238,
     238,   426,   242,   426,   242,   293,   353,    73,    99,   117,
     275,   441,    73,   117,   275,   441,    73,   117,   275,   441,
     239,   241,   242,    73,   117,   275,   441,    73,   117,   275,
     441,    73,   117,   275,   441,   440,   438,     5,    52,   238,
     398,   241,   241,   280,   281,   282,     1,    47,   283,   284,
     323,     1,   284,     1,   284,   434,   320,   241,   282,   438,
     438,   434,   438,   434,   434,   276,   318,   318,   241,   320,
     241,   241,   320,   241,   241,   320,   225,   241,     3,   240,
     239,   241,     3,   371,   416,   417,   239,   242,   225,   365,
     364,   241,   326,   434,   242,   240,   242,   242,   241,   241,
     241,   241,   225,   320,    34,   324,   293,   293,   331,   242,
     239,   293,   293,   293,   293,   320,   241,   251,   293,   293,
     293,   293,   426,   426,    23,    24,   225,   423,   423,   282,
       3,     3,     3,   338,     3,     3,     3,   338,     3,     3,
       3,   338,     3,   445,   241,   332,   332,   332,   338,   332,
     332,   332,   338,   332,   332,   332,   338,    59,   242,   149,
     242,   320,   280,   437,    53,   225,   225,   438,     1,    53,
     283,   225,    53,    53,    53,    53,   241,   437,    51,    51,
     438,   242,   242,   251,   320,   242,   320,   370,   409,   241,
     239,   241,   293,   320,   369,   369,     3,    54,   241,   320,
     320,   242,   223,   432,   239,   241,   331,   432,   432,   239,
     432,   432,   239,   239,   432,   432,   423,   423,   320,   320,
     438,   408,   408,   408,   282,   241,   241,   241,   408,   241,
     241,   241,   408,   241,   241,   241,   408,   241,   242,    52,
     438,   438,   438,     1,   320,    74,   438,   438,   316,   316,
     251,     3,   416,   242,   240,   282,   320,   242,   293,   242,
     242,   293,   242,   242,   293,   293,   242,   242,   320,   320,
     242,   242,    59,     3,     3,     3,   438,   332,   332,   332,
     241,   241,   320,   320,   320,   434,   241,   432,   241,   241,
     432,   241,   241,   432,   432,   241,   241,   242,   242,   242,
     242,    59,   241,   241,   241,   339,     1,   339,   241,   241,
     242,    54,   242,   242,   242,   242,   242,   242,   240,   242,
     240,   356,   241,   241,   241,   241,   320,   434,   320,   368,
     242,   242,   434,   434
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:

/* Line 1806 of yacc.c  */
#line 401 "./parse.y"
    { (yyval.number) = (yyvsp[(1) - (1)].number); based_size = 0;}
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 403 "./parse.y"
    { (yyval.number) = (yyvsp[(1) - (1)].number); based_size = 0;}
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 405 "./parse.y"
    { (yyval.number) = pform_verinum_with_size((yyvsp[(1) - (2)].number),(yyvsp[(2) - (2)].number), (yylsp[(2) - (2)]).text, (yylsp[(2) - (2)]).first_line);
	       based_size = 0; }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 421 "./parse.y"
    { (yyval.named_pexprs) = 0; }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 425 "./parse.y"
    { (yyval.named_pexprs) = 0; }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 426 "./parse.y"
    { (yyval.named_pexprs) = (yyvsp[(2) - (3)].named_pexprs); }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 427 "./parse.y"
    { (yyval.named_pexprs) = (yyvsp[(1) - (3)].named_pexprs); }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 429 "./parse.y"
    { if ((yyvsp[(1) - (4)].named_pexprs)) {
	    svector<named_pexpr_t*>*tmp;
	    tmp = new svector<named_pexpr_t*>(*(yyvsp[(1) - (4)].named_pexprs), *(yyvsp[(3) - (4)].named_pexprs));
	    delete (yyvsp[(1) - (4)].named_pexprs);
	    delete (yyvsp[(3) - (4)].named_pexprs);
	    (yyval.named_pexprs) = tmp;
	} else (yyval.named_pexprs) = (yyvsp[(3) - (4)].named_pexprs);
      }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 441 "./parse.y"
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[(1) - (3)].named_pexprs),(yyvsp[(3) - (3)].named_pexpr));
		  delete (yyvsp[(1) - (3)].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 447 "./parse.y"
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 456 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(1) - (1)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(1) - (1)].text);
		  (yyval.named_pexpr) = tmp;
		}
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 463 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (3)].expr);
		  named_pexpr_t*tmp2 = new named_pexpr_t;
		  tmp2->name = lex_strings.make((yyvsp[(1) - (3)].text));
		  tmp2->parm = tmp;
		  delete[](yyvsp[(1) - (3)].text);
		  (yyval.named_pexpr) = tmp2;
		}
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 483 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (7)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[(6) - (7)].perm_strings), (yyvsp[(5) - (7)].exprs), (yyvsp[(4) - (7)].flag), dtype);
		  if ((yyvsp[(1) - (7)].named_pexprs)) delete (yyvsp[(1) - (7)].named_pexprs);
		}
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 496 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (6)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_set_net_range((yyvsp[(5) - (6)].perm_strings), 0, (yyvsp[(4) - (6)].flag), dtype);
		  if ((yyvsp[(1) - (6)].named_pexprs)) delete (yyvsp[(1) - (6)].named_pexprs);
		}
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 508 "./parse.y"
    { pform_set_reg_integer((yyvsp[(3) - (4)].perm_strings));
		  if ((yyvsp[(1) - (4)].named_pexprs)) delete (yyvsp[(1) - (4)].named_pexprs);
		}
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 513 "./parse.y"
    { pform_set_reg_time((yyvsp[(3) - (4)].perm_strings));
		}
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 522 "./parse.y"
    { delete (yyvsp[(3) - (4)].perm_strings); }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 524 "./parse.y"
    { delete (yyvsp[(3) - (4)].perm_strings); }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 527 "./parse.y"
    { pform_make_events((yyvsp[(2) - (3)].perm_strings), (yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		}
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 537 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in reg variable list.");
		  yyerrok;
		  if ((yyvsp[(1) - (4)].named_pexprs)) delete (yyvsp[(1) - (4)].named_pexprs);
		}
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 542 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in integer variable list.");
		  yyerrok;
		  if ((yyvsp[(1) - (4)].named_pexprs)) delete (yyvsp[(1) - (4)].named_pexprs);
		}
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 547 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in time variable list.");
		  yyerrok;
		}
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 551 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in real variable list.");
		  yyerrok;
		}
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 555 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "error: syntax error in realtime variable list.");
		  yyerrok;
		}
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 559 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error in parameter list.");
		  yyerrok;
		}
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 563 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error localparam list.");
		  yyerrok;
		}
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 580 "./parse.y"
    { PCase::Item*tmp = new PCase::Item;
		  tmp->expr = *(yyvsp[(1) - (3)].exprs);
		  tmp->stat = (yyvsp[(3) - (3)].statement);
		  delete (yyvsp[(1) - (3)].exprs);
		  (yyval.citem) = tmp;
		}
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 587 "./parse.y"
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[(3) - (3)].statement);
		  (yyval.citem) = tmp;
		}
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 592 "./parse.y"
    { PCase::Item*tmp = new PCase::Item;
		  tmp->stat = (yyvsp[(2) - (2)].statement);
		  (yyval.citem) = tmp;
		}
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 597 "./parse.y"
    { yyerror((yylsp[(2) - (3)]), "error: Incomprehensible case expression.");
		  yyerrok;
		}
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 604 "./parse.y"
    { svector<PCase::Item*>*tmp;
		  tmp = new svector<PCase::Item*>(*(yyvsp[(1) - (2)].citems), (yyvsp[(2) - (2)].citem));
		  delete (yyvsp[(1) - (2)].citems);
		  (yyval.citems) = tmp;
		}
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 610 "./parse.y"
    { svector<PCase::Item*>*tmp = new svector<PCase::Item*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].citem);
		  (yyval.citems) = tmp;
		}
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 629 "./parse.y"
    { pform_set_defparam(*(yyvsp[(1) - (3)].pform_name), (yyvsp[(3) - (3)].expr));
		  delete (yyvsp[(1) - (3)].pform_name);
		}
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 637 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: defparam may not include a range.");
		  delete (yyvsp[(1) - (2)].exprs);
		}
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 645 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(2) - (2)].expr);
		  (yyval.exprs) = tmp;
		}
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 650 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (4)].expr);
		  (yyval.exprs) = tmp;
		}
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 658 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(2) - (2)].expr);
		  (yyval.exprs) = tmp;
		}
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 663 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (4)].expr);
		  (yyval.exprs) = tmp;
		}
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 668 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[(3) - (6)].expr);
		  (*tmp)[1] = (yyvsp[(5) - (6)].expr);
		  (yyval.exprs) = tmp;
		}
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 674 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(3);
		  (*tmp)[0] = (yyvsp[(3) - (8)].expr);
		  (*tmp)[1] = (yyvsp[(5) - (8)].expr);
		  (*tmp)[2] = (yyvsp[(7) - (8)].expr);
		  (yyval.exprs) = tmp;
		}
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 683 "./parse.y"
    { (yyval.exprs) = (yyvsp[(1) - (1)].exprs); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 684 "./parse.y"
    { (yyval.exprs) = 0; }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 689 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
	        (*tmp)[0] = (yyvsp[(1) - (1)].expr);
		(yyval.exprs) = tmp;
	      }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 694 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), (yyvsp[(3) - (3)].expr));
		delete (yyvsp[(1) - (3)].exprs);
		(yyval.exprs) = tmp;
	      }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 702 "./parse.y"
    { PExpr*tmp = (yyvsp[(1) - (1)].expr);
		  (yyval.expr) = tmp;
		}
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 706 "./parse.y"
    { (yyval.expr) = pform_select_mtm_expr((yyvsp[(1) - (5)].expr), (yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].expr)); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 712 "./parse.y"
    { verinum*tmp = (yyvsp[(1) - (1)].number);
		  if (tmp == 0) {
			yyerror((yylsp[(1) - (1)]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PENumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[(1) - (1)]));
		  }
		  based_size = 0;
		}
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 723 "./parse.y"
    { verireal*tmp = (yyvsp[(1) - (1)].realtime);
		  if (tmp == 0) {
			yyerror((yylsp[(1) - (1)]), "internal error: delay.");
			(yyval.expr) = 0;
		  } else {
			(yyval.expr) = new PEFNumber(tmp);
			FILE_NAME((yyval.expr), (yylsp[(1) - (1)]));
		  }
		}
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 733 "./parse.y"
    { PEIdent*tmp = new PEIdent(lex_strings.make((yyvsp[(1) - (1)].text)));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		}
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 747 "./parse.y"
    { perm_string tmp3 = lex_strings.make((yyvsp[(3) - (8)].text));
	pform_set_type_attrib(tmp3, (yyvsp[(5) - (8)].text), (yyvsp[(7) - (8)].text));
	delete[] (yyvsp[(3) - (8)].text);
	delete[] (yyvsp[(5) - (8)].text);
      }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 762 "./parse.y"
    { pform_start_discipline((yyvsp[(2) - (3)].text)); }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 764 "./parse.y"
    { pform_end_discipline((yylsp[(1) - (6)])); delete[] (yyvsp[(2) - (6)].text); }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 774 "./parse.y"
    { pform_discipline_domain((yylsp[(1) - (3)]), IVL_DIS_DISCRETE); }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 776 "./parse.y"
    { pform_discipline_domain((yylsp[(1) - (3)]), IVL_DIS_CONTINUOUS); }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 778 "./parse.y"
    { pform_discipline_potential((yylsp[(1) - (3)]), (yyvsp[(2) - (3)].text)); delete[] (yyvsp[(2) - (3)].text); }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 780 "./parse.y"
    { pform_discipline_flow((yylsp[(1) - (3)]), (yyvsp[(2) - (3)].text)); delete[] (yyvsp[(2) - (3)].text); }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 785 "./parse.y"
    { pform_start_nature((yyvsp[(2) - (3)].text)); }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 788 "./parse.y"
    { pform_end_nature((yylsp[(1) - (6)])); delete[] (yyvsp[(2) - (6)].text); }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 798 "./parse.y"
    { delete[] (yyvsp[(3) - (4)].text); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 801 "./parse.y"
    { pform_nature_access((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].text)); delete[] (yyvsp[(3) - (4)].text); }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 803 "./parse.y"
    { delete[] (yyvsp[(3) - (4)].text); }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 805 "./parse.y"
    { delete[] (yyvsp[(3) - (4)].text); }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 813 "./parse.y"
    { cerr << (yylsp[(1) - (8)]) << ": sorry: config declarations are not supported and "
                "will be skipped." << endl;
	delete[] (yyvsp[(2) - (8)].text);
      }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 833 "./parse.y"
    { delete (yyvsp[(2) - (5)].pform_name); }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 835 "./parse.y"
    { delete (yyvsp[(2) - (6)].pform_name); }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 846 "./parse.y"
    { delete[] (yyvsp[(1) - (1)].text); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 848 "./parse.y"
    { delete[] (yyvsp[(1) - (3)].text); delete[] (yyvsp[(3) - (3)].text); }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 854 "./parse.y"
    { delete[] (yyvsp[(2) - (2)].text); }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 858 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(2) - (5)].drive).str0;
		  (yyval.drive).str1 = (yyvsp[(4) - (5)].drive).str1;
		}
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 862 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(4) - (5)].drive).str0;
		  (yyval.drive).str1 = (yyvsp[(2) - (5)].drive).str1;
		}
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 866 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(2) - (5)].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		}
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 870 "./parse.y"
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[(2) - (5)].drive).str1;
		}
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 874 "./parse.y"
    { (yyval.drive).str0 = (yyvsp[(4) - (5)].drive).str0;
		  (yyval.drive).str1 = PGate::HIGHZ;
		}
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 878 "./parse.y"
    { (yyval.drive).str0 = PGate::HIGHZ;
		  (yyval.drive).str1 = (yyvsp[(4) - (5)].drive).str1;
		}
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 884 "./parse.y"
    { (yyval.drive) = (yyvsp[(1) - (1)].drive); }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 885 "./parse.y"
    { (yyval.drive).str0 = PGate::STRONG; (yyval.drive).str1 = PGate::STRONG; }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 889 "./parse.y"
    { (yyval.drive).str0 = PGate::SUPPLY; }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 890 "./parse.y"
    { (yyval.drive).str0 = PGate::STRONG; }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 891 "./parse.y"
    { (yyval.drive).str0 = PGate::PULL; }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 892 "./parse.y"
    { (yyval.drive).str0 = PGate::WEAK; }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 896 "./parse.y"
    { (yyval.drive).str1 = PGate::SUPPLY; }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 897 "./parse.y"
    { (yyval.drive).str1 = PGate::STRONG; }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 898 "./parse.y"
    { (yyval.drive).str1 = PGate::PULL; }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 899 "./parse.y"
    { (yyval.drive).str1 = PGate::WEAK; }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 904 "./parse.y"
    { PEIdent*tmpi = new PEIdent(*(yyvsp[(2) - (2)].pform_name));
		  PEEvent*tmpe = new PEEvent(PEEvent::ANYEDGE, tmpi);
		  PEventStatement*tmps = new PEventStatement(tmpe);
		  FILE_NAME(tmps, (yylsp[(1) - (2)]));
		  (yyval.event_statement) = tmps;
		  delete (yyvsp[(2) - (2)].pform_name);
		}
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 912 "./parse.y"
    { PEventStatement*tmp = new PEventStatement(*(yyvsp[(3) - (4)].event_expr));
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  delete (yyvsp[(3) - (4)].event_expr);
		  (yyval.event_statement) = tmp;
		}
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 918 "./parse.y"
    { yyerror((yylsp[(1) - (4)]), "error: Malformed event control expression.");
		  (yyval.event_statement) = 0;
		}
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 925 "./parse.y"
    { (yyval.event_expr) = (yyvsp[(1) - (1)].event_expr); }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 927 "./parse.y"
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[(1) - (3)].event_expr), *(yyvsp[(3) - (3)].event_expr));
		  delete (yyvsp[(1) - (3)].event_expr);
		  delete (yyvsp[(3) - (3)].event_expr);
		  (yyval.event_expr) = tmp;
		}
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 933 "./parse.y"
    { svector<PEEvent*>*tmp = new svector<PEEvent*>(*(yyvsp[(1) - (3)].event_expr), *(yyvsp[(3) - (3)].event_expr));
		  delete (yyvsp[(1) - (3)].event_expr);
		  delete (yyvsp[(3) - (3)].event_expr);
		  (yyval.event_expr) = tmp;
		}
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 942 "./parse.y"
    { PEEvent*tmp = new PEEvent(PEEvent::POSEDGE, (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 949 "./parse.y"
    { PEEvent*tmp = new PEEvent(PEEvent::NEGEDGE, (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 956 "./parse.y"
    { PEEvent*tmp = new PEEvent(PEEvent::ANYEDGE, (yyvsp[(1) - (1)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  svector<PEEvent*>*tl = new svector<PEEvent*>(1);
		  (*tl)[0] = tmp;
		  (yyval.event_expr) = tl;
		}
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 970 "./parse.y"
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[(1) - (6)]), (yyvsp[(1) - (6)].text), (yyvsp[(3) - (6)].text), (yyvsp[(5) - (6)].text)); }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 972 "./parse.y"
    { (yyval.expr) = pform_make_branch_probe_expression((yylsp[(1) - (4)]), (yyvsp[(1) - (4)].text), (yyvsp[(3) - (4)].text)); }
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 977 "./parse.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); }
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 979 "./parse.y"
    { (yyval.expr) = (yyvsp[(2) - (2)].expr); }
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 981 "./parse.y"
    { PEUnary*tmp = new PEUnary('-', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 986 "./parse.y"
    { PEUnary*tmp = new PEUnary('~', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 991 "./parse.y"
    { PEUnary*tmp = new PEUnary('&', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 996 "./parse.y"
    { PEUnary*tmp = new PEUnary('!', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 1001 "./parse.y"
    { PEUnary*tmp = new PEUnary('|', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 1006 "./parse.y"
    { PEUnary*tmp = new PEUnary('^', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 1011 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: '~' '&'  is not a valid expression. "
			  "Please use operator '~&' instead.");
		  (yyval.expr) = 0;
		}
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 1016 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: '~' '|'  is not a valid expression. "
			  "Please use operator '~|' instead.");
		  (yyval.expr) = 0;
		}
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 1021 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: '~' '^'  is not a valid expression. "
			  "Please use operator '~^' instead.");
		  (yyval.expr) = 0;
		}
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 1026 "./parse.y"
    { PEUnary*tmp = new PEUnary('A', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 1031 "./parse.y"
    { PEUnary*tmp = new PEUnary('N', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 1036 "./parse.y"
    { PEUnary*tmp = new PEUnary('X', (yyvsp[(2) - (2)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (2)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 1041 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: Operand of unary ! "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		}
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 1046 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: Operand of reduction ^ "
			  "is not a primary expression.");
		  (yyval.expr) = 0;
		}
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 1051 "./parse.y"
    { PEBinary*tmp = new PEBinary('^', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 1056 "./parse.y"
    { PEBinary*tmp = new PEBPower('p', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 1061 "./parse.y"
    { PEBinary*tmp = new PEBinary('*', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 1066 "./parse.y"
    { PEBinary*tmp = new PEBinary('/', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 1071 "./parse.y"
    { PEBinary*tmp = new PEBinary('%', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 1076 "./parse.y"
    { PEBinary*tmp = new PEBinary('+', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 1081 "./parse.y"
    { PEBinary*tmp = new PEBinary('-', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 1086 "./parse.y"
    { PEBinary*tmp = new PEBinary('&', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 1091 "./parse.y"
    { PEBinary*tmp = new PEBinary('|', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 1096 "./parse.y"
    { PEBinary*tmp = new PEBinary('A', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 1101 "./parse.y"
    { PEBinary*tmp = new PEBinary('O', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 1106 "./parse.y"
    { PEBinary*tmp = new PEBinary('X', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 1111 "./parse.y"
    { PEBinary*tmp = new PEBComp('<', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 1116 "./parse.y"
    { PEBinary*tmp = new PEBComp('>', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 1121 "./parse.y"
    { PEBinary*tmp = new PEBShift('l', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 1126 "./parse.y"
    { PEBinary*tmp = new PEBShift('r', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 1131 "./parse.y"
    { PEBinary*tmp = new PEBShift('R', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 1136 "./parse.y"
    { PEBinary*tmp = new PEBComp('e', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 1141 "./parse.y"
    { PEBinary*tmp = new PEBComp('E', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 1146 "./parse.y"
    { PEBinary*tmp = new PEBComp('L', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 1151 "./parse.y"
    { PEBinary*tmp = new PEBComp('G', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 1156 "./parse.y"
    { PEBinary*tmp = new PEBComp('n', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 1161 "./parse.y"
    { PEBinary*tmp = new PEBComp('N', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 1166 "./parse.y"
    { PEBinary*tmp = new PEBLogic('o', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 1171 "./parse.y"
    { PEBinary*tmp = new PEBLogic('a', (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (3)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 1176 "./parse.y"
    { PETernary*tmp = new PETernary((yyvsp[(1) - (5)].expr), (yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(2) - (5)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 1184 "./parse.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 1186 "./parse.y"
    { switch (min_typ_max_flag) {
		      case MIN:
			(yyval.expr) = (yyvsp[(1) - (5)].expr);
			delete (yyvsp[(3) - (5)].expr);
			delete (yyvsp[(5) - (5)].expr);
			break;
		      case TYP:
			delete (yyvsp[(1) - (5)].expr);
			(yyval.expr) = (yyvsp[(3) - (5)].expr);
			delete (yyvsp[(5) - (5)].expr);
			break;
		      case MAX:
			delete (yyvsp[(1) - (5)].expr);
			delete (yyvsp[(3) - (5)].expr);
			(yyval.expr) = (yyvsp[(5) - (5)].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << (yyval.expr)->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		}
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 1233 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), (yyvsp[(3) - (3)].expr));
		  delete (yyvsp[(1) - (3)].exprs);
		  (yyval.exprs) = tmp;
		}
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 1238 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].expr);
		  (yyval.exprs) = tmp;
		}
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 1243 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = 0;
		  (yyval.exprs) = tmp;
		}
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 1249 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (2)].exprs), 0);
		  delete (yyvsp[(1) - (2)].exprs);
		  (yyval.exprs) = tmp;
		}
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 1257 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), (yyvsp[(3) - (3)].expr));
		  delete (yyvsp[(1) - (3)].exprs);
		  (yyval.exprs) = tmp;
		}
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 1262 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].expr);
		  (yyval.exprs) = tmp;
		}
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 1270 "./parse.y"
    { assert((yyvsp[(1) - (1)].number));
		  PENumber*tmp = new PENumber((yyvsp[(1) - (1)].number));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 1276 "./parse.y"
    { PEFNumber*tmp = new PEFNumber((yyvsp[(1) - (1)].realtime));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 1281 "./parse.y"
    { PEString*tmp = new PEString((yyvsp[(1) - (1)].text));
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		}
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 1286 "./parse.y"
    { perm_string tn = lex_strings.make((yyvsp[(1) - (1)].text));
		  PECallFunction*tmp = new PECallFunction(tn);
		  FILE_NAME(tmp, (yylsp[(1) - (1)]));
		  (yyval.expr) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		}
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 1297 "./parse.y"
    { PEIdent*tmp = new PEIdent(*(yyvsp[(1) - (1)].pform_name));
	  FILE_NAME(tmp, (yylsp[(1) - (1)]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[(1) - (1)].pform_name);
	}
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 1308 "./parse.y"
    { PECallFunction*tmp = new PECallFunction(*(yyvsp[(1) - (4)].pform_name), *(yyvsp[(3) - (4)].exprs));
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete (yyvsp[(1) - (4)].pform_name);
	(yyval.expr) = tmp;
      }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 1314 "./parse.y"
    { perm_string tn = lex_strings.make((yyvsp[(1) - (4)].text));
	PECallFunction*tmp = new PECallFunction(tn, *(yyvsp[(3) - (4)].exprs));
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete[](yyvsp[(1) - (4)].text);
	(yyval.expr) = tmp;
      }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 1325 "./parse.y"
    { perm_string tn = perm_string::literal("$acos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 1332 "./parse.y"
    { perm_string tn = perm_string::literal("$acosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 1339 "./parse.y"
    { perm_string tn = perm_string::literal("$asin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 1346 "./parse.y"
    { perm_string tn = perm_string::literal("$asinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 1353 "./parse.y"
    { perm_string tn = perm_string::literal("$atan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 1360 "./parse.y"
    { perm_string tn = perm_string::literal("$atanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 1367 "./parse.y"
    { perm_string tn = perm_string::literal("$atan2");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 1374 "./parse.y"
    { perm_string tn = perm_string::literal("$ceil");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 1381 "./parse.y"
    { perm_string tn = perm_string::literal("$cos");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 1388 "./parse.y"
    { perm_string tn = perm_string::literal("$cosh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 1395 "./parse.y"
    { perm_string tn = perm_string::literal("$exp");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 1402 "./parse.y"
    { perm_string tn = perm_string::literal("$floor");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 1409 "./parse.y"
    { perm_string tn = perm_string::literal("$hypot");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 1416 "./parse.y"
    { perm_string tn = perm_string::literal("$ln");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 1423 "./parse.y"
    { perm_string tn = perm_string::literal("$log10");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 1430 "./parse.y"
    { perm_string tn = perm_string::literal("$pow");
        PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 1437 "./parse.y"
    { perm_string tn = perm_string::literal("$sin");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 1444 "./parse.y"
    { perm_string tn = perm_string::literal("$sinh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 1451 "./parse.y"
    { perm_string tn = perm_string::literal("$sqrt");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 1458 "./parse.y"
    { perm_string tn = perm_string::literal("$tan");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 1465 "./parse.y"
    { perm_string tn = perm_string::literal("$tanh");
	PECallFunction*tmp = make_call_function(tn, (yyvsp[(3) - (4)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 1476 "./parse.y"
    { PEUnary*tmp = new PEUnary('m', (yyvsp[(3) - (4)].expr));
        FILE_NAME(tmp,(yylsp[(1) - (4)]));
	(yyval.expr) = tmp;
      }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 1482 "./parse.y"
    { PEBinary*tmp = new PEBinary('M', (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 1488 "./parse.y"
    { PEBinary*tmp = new PEBinary('m', (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
	FILE_NAME(tmp,(yylsp[(1) - (6)]));
	(yyval.expr) = tmp;
      }
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 1496 "./parse.y"
    { (yyval.expr) = (yyvsp[(2) - (3)].expr); }
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 1501 "./parse.y"
    { PEConcat*tmp = new PEConcat(*(yyvsp[(2) - (3)].exprs));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  delete (yyvsp[(2) - (3)].exprs);
		  (yyval.expr) = tmp;
		}
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 1507 "./parse.y"
    { PExpr*rep = (yyvsp[(2) - (6)].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[(4) - (6)].exprs), rep);
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  delete (yyvsp[(4) - (6)].exprs);
		  (yyval.expr) = tmp;
		}
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 1514 "./parse.y"
    { PExpr*rep = (yyvsp[(2) - (7)].expr);
		  PEConcat*tmp = new PEConcat(*(yyvsp[(4) - (7)].exprs), rep);
		  FILE_NAME(tmp, (yylsp[(1) - (7)]));
		  delete (yyvsp[(4) - (7)].exprs);
		  (yyval.expr) = tmp;
		  yyerror((yylsp[(5) - (7)]), "error: Syntax error between internal '}' "
			  "and closing '}' of repeat concatenation.");
		  yyerrok;
		}
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 1530 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); }
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 1532 "./parse.y"
    { if ((yyvsp[(1) - (2)].wires) && (yyvsp[(2) - (2)].wires)) {
		        svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (2)].wires), *(yyvsp[(2) - (2)].wires));
			delete (yyvsp[(1) - (2)].wires);
			delete (yyvsp[(2) - (2)].wires);
			(yyval.wires) = tmp;
		  } else if ((yyvsp[(1) - (2)].wires)) {
			(yyval.wires) = (yyvsp[(1) - (2)].wires);
		  } else {
			(yyval.wires) = (yyvsp[(2) - (2)].wires);
		  }
		}
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 1547 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 1549 "./parse.y"
    { (yyval.wires) = 0; }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 1556 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (4)].text);
		  tmp->parms = (yyvsp[(3) - (4)].exprs);
		  tmp->file  = (yylsp[(1) - (4)]).text;
		  tmp->lineno = (yylsp[(1) - (4)]).first_line;
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.gate) = tmp;
		}
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 1566 "./parse.y"
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[(2) - (5)].exprs);
		  tmp->name = (yyvsp[(1) - (5)].text);
		  tmp->parms = (yyvsp[(4) - (5)].exprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[(1) - (5)]).text;
		  tmp->lineno = (yylsp[(1) - (5)]).first_line;
		  delete[](yyvsp[(1) - (5)].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 1579 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = "";
		  tmp->parms = (yyvsp[(2) - (3)].exprs);
		  tmp->file  = (yylsp[(1) - (3)]).text;
		  tmp->lineno = (yylsp[(1) - (3)]).first_line;
		  (yyval.gate) = tmp;
		}
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 1590 "./parse.y"
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[(2) - (2)].exprs);
		  tmp->name = (yyvsp[(1) - (2)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[(1) - (2)]).text;
		  tmp->lineno = (yylsp[(1) - (2)]).first_line;
		  delete[](yyvsp[(1) - (2)].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 1607 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (4)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[(3) - (4)].named_pexprs);
		  tmp->file  = (yylsp[(1) - (4)]).text;
		  tmp->lineno = (yylsp[(1) - (4)]).first_line;
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.gate) = tmp;
		}
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 1618 "./parse.y"
    { lgate*tmp = new lgate;
		  svector<PExpr*>*rng = (yyvsp[(2) - (5)].exprs);
		  tmp->name = (yyvsp[(1) - (5)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = (yyvsp[(4) - (5)].named_pexprs);
		  tmp->range[0] = (*rng)[0];
		  tmp->range[1] = (*rng)[1];
		  tmp->file  = (yylsp[(1) - (5)]).text;
		  tmp->lineno = (yylsp[(1) - (5)]).first_line;
		  delete[](yyvsp[(1) - (5)].text);
		  delete rng;
		  (yyval.gate) = tmp;
		}
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 1633 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (4)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[(1) - (4)]).text;
		  tmp->lineno = (yylsp[(1) - (4)]).first_line;
		  yyerror((yylsp[(2) - (4)]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.gate) = tmp;
		}
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 1646 "./parse.y"
    { lgate*tmp = new lgate;
		  tmp->name = (yyvsp[(1) - (5)].text);
		  tmp->parms = 0;
		  tmp->parms_by_name = 0;
		  tmp->file  = (yylsp[(1) - (5)]).text;
		  tmp->lineno = (yylsp[(1) - (5)]).first_line;
		  yyerror((yylsp[(3) - (5)]), "error: Syntax error in instance port "
			  "expression(s).");
		  delete[](yyvsp[(1) - (5)].text);
		  (yyval.gate) = tmp;
		}
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 1661 "./parse.y"
    { svector<lgate>*tmp1 = (yyvsp[(1) - (3)].gates);
		  lgate*tmp2 = (yyvsp[(3) - (3)].gate);
		  svector<lgate>*out = new svector<lgate> (*tmp1, *tmp2);
		  delete tmp1;
		  delete tmp2;
		  (yyval.gates) = out;
		}
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 1669 "./parse.y"
    { svector<lgate>*tmp = new svector<lgate>(1);
		  (*tmp)[0] = *(yyvsp[(1) - (1)].gate);
		  delete (yyvsp[(1) - (1)].gate);
		  (yyval.gates) = tmp;
		}
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1677 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::AND; }
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1678 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NAND; }
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 1679 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::OR; }
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 1680 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOR; }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1681 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::XOR; }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1682 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::XNOR; }
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 1683 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::BUF; }
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 1684 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::BUFIF0; }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1685 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::BUFIF1; }
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 1686 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOT; }
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1687 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOTIF0; }
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1688 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NOTIF1; }
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 1692 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::NMOS; }
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1693 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RNMOS; }
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1694 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::PMOS; }
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 1695 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RPMOS; }
    break;

  case 254:

/* Line 1806 of yacc.c  */
#line 1696 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::CMOS; }
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 1697 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RCMOS; }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 1698 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::TRAN; }
    break;

  case 257:

/* Line 1806 of yacc.c  */
#line 1699 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RTRAN; }
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 1700 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::TRANIF0; }
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 1701 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::TRANIF1; }
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1702 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RTRANIF0; }
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1703 "./parse.y"
    { (yyval.gatetype) = PGBuiltin::RTRANIF1; }
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1714 "./parse.y"
    { (yyval.pform_name) = new pform_name_t;
	  (yyval.pform_name)->push_back(name_component_t(lex_strings.make((yyvsp[(1) - (1)].text))));
	  delete[](yyvsp[(1) - (1)].text);
	}
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1719 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (3)].pform_name);
	  tmp->push_back(name_component_t(lex_strings.make((yyvsp[(3) - (3)].text))));
	  delete[](yyvsp[(3) - (3)].text);
	  (yyval.pform_name) = tmp;
	}
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1725 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (4)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[(3) - (4)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
    break;

  case 265:

/* Line 1806 of yacc.c  */
#line 1734 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (6)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 1744 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (6)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_UP;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1754 "./parse.y"
    { pform_name_t * tmp = (yyvsp[(1) - (6)].pform_name);
	  name_component_t&tail = tmp->back();
	  index_component_t itmp;
	  itmp.sel = index_component_t::SEL_IDX_DO;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);
	  tail.index.push_back(itmp);
	  (yyval.pform_name) = tmp;
	}
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1770 "./parse.y"
    { (yyval.perm_strings) = list_from_identifier((yyvsp[(1) - (1)].text)); }
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1772 "./parse.y"
    { (yyval.perm_strings) = list_from_identifier((yyvsp[(1) - (3)].perm_strings), (yyvsp[(3) - (3)].text)); }
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1777 "./parse.y"
    { (yyval.port_list) = make_port_list((yyvsp[(1) - (1)].text), 0); }
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 1779 "./parse.y"
    { (yyval.port_list) = make_port_list((yyvsp[(1) - (3)].text), (yyvsp[(3) - (3)].expr)); }
    break;

  case 272:

/* Line 1806 of yacc.c  */
#line 1781 "./parse.y"
    { (yyval.port_list) = make_port_list((yyvsp[(1) - (3)].port_list), (yyvsp[(3) - (3)].text), 0); }
    break;

  case 273:

/* Line 1806 of yacc.c  */
#line 1783 "./parse.y"
    { (yyval.port_list) = make_port_list((yyvsp[(1) - (5)].port_list), (yyvsp[(3) - (5)].text), (yyvsp[(5) - (5)].expr)); }
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1805 "./parse.y"
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].mport);
		  (yyval.mports) = tmp;
		}
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 1811 "./parse.y"
    { vector<Module::port_t*>*tmp = (yyvsp[(1) - (3)].mports);
		  tmp->push_back((yyvsp[(3) - (3)].mport));
		  (yyval.mports) = tmp;
		}
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 1819 "./parse.y"
    { vector<Module::port_t*>*tmp
			  = new vector<Module::port_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].mport);
		  (yyval.mports) = tmp;
		}
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 1825 "./parse.y"
    { vector<Module::port_t*>*tmp = (yyvsp[(1) - (3)].mports);
		  tmp->push_back((yyvsp[(3) - (3)].mport));
		  (yyval.mports) = tmp;
		}
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1830 "./parse.y"
    { Module::port_t*ptmp;
		  perm_string name = lex_strings.make((yyvsp[(3) - (3)].text));
		  ptmp = pform_module_port_reference(name, (yylsp[(3) - (3)]).text,
						     (yylsp[(3) - (3)]).first_line);
		  vector<Module::port_t*>*tmp = (yyvsp[(1) - (3)].mports);
		  tmp->push_back(ptmp);

		    /* Get the port declaration details, the port type
		       and what not, from context data stored by the
		       last port_declaration rule. */
		  pform_module_define_port((yylsp[(3) - (3)]), name,
					port_declaration_context.port_type,
					port_declaration_context.port_net_type,
					port_declaration_context.sign_flag,
					port_declaration_context.range, 0);
		  delete[](yyvsp[(3) - (3)].text);
		  (yyval.mports) = tmp;
		}
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1849 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: NULL port declarations are not "
		              "allowed.");
		}
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1854 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: ';' is an invalid port declaration "
		              "separator.");
		}
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1863 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::PINPUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::PINPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      }
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1880 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::PINOUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::PINOUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      }
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1897 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::POUTPUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      }
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1914 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (6)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (6)]).text,
					   (yylsp[(2) - (6)]).first_line);
	pform_module_define_port((yylsp[(2) - (6)]), name, NetNet::POUTPUT,
				 (yyvsp[(3) - (6)].nettype), (yyvsp[(4) - (6)].flag), (yyvsp[(5) - (6)].exprs), (yyvsp[(1) - (6)].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (6)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (6)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (6)].exprs);
	delete (yyvsp[(1) - (6)].named_pexprs);
	delete[](yyvsp[(6) - (6)].text);
	(yyval.mport) = ptmp;
      }
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1931 "./parse.y"
    { Module::port_t*ptmp;
	perm_string name = lex_strings.make((yyvsp[(6) - (8)].text));
	ptmp = pform_module_port_reference(name, (yylsp[(2) - (8)]).text,
					   (yylsp[(2) - (8)]).first_line);
	pform_module_define_port((yylsp[(2) - (8)]), name, NetNet::POUTPUT,
				 (yyvsp[(3) - (8)].nettype), (yyvsp[(4) - (8)].flag), (yyvsp[(5) - (8)].exprs), (yyvsp[(1) - (8)].named_pexprs));
	port_declaration_context.port_type = NetNet::POUTPUT;
	port_declaration_context.port_net_type = (yyvsp[(3) - (8)].nettype);
	port_declaration_context.sign_flag = (yyvsp[(4) - (8)].flag);
	delete port_declaration_context.range;
	port_declaration_context.range = (yyvsp[(5) - (8)].exprs);

	pform_make_reginit((yylsp[(6) - (8)]), name, (yyvsp[(8) - (8)].expr));

	delete (yyvsp[(1) - (8)].named_pexprs);
	delete[](yyvsp[(6) - (8)].text);
	(yyval.mport) = ptmp;
      }
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 1954 "./parse.y"
    { (yyval.nettype) = (yyvsp[(1) - (1)].nettype); }
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 1955 "./parse.y"
    { (yyval.nettype) = NetNet::IMPLICIT; }
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 1958 "./parse.y"
    { (yyval.flag) = true; }
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1958 "./parse.y"
    {(yyval.flag) = false; }
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1966 "./parse.y"
    { PEIdent*tmp = new PEIdent(*(yyvsp[(1) - (1)].pform_name));
	  FILE_NAME(tmp, (yylsp[(1) - (1)]));
	  (yyval.expr) = tmp;
	  delete (yyvsp[(1) - (1)].pform_name);
	}
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 1972 "./parse.y"
    { PEConcat*tmp = new PEConcat(*(yyvsp[(2) - (3)].exprs));
	  FILE_NAME(tmp, (yylsp[(1) - (3)]));
	  delete (yyvsp[(2) - (3)].exprs);
	  (yyval.expr) = tmp;
	}
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 1984 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(2);
		  (*tmp)[0] = (yyvsp[(1) - (3)].expr);
		  (*tmp)[1] = (yyvsp[(3) - (3)].expr);
		  (yyval.exprs) = tmp;
		}
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 1993 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(*(yyvsp[(1) - (3)].exprs), *(yyvsp[(3) - (3)].exprs));
		  delete (yyvsp[(1) - (3)].exprs);
		  delete (yyvsp[(3) - (3)].exprs);
		  (yyval.exprs) = tmp;
		}
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 1999 "./parse.y"
    { (yyval.exprs) = (yyvsp[(1) - (1)].exprs); }
    break;

  case 295:

/* Line 1806 of yacc.c  */
#line 2008 "./parse.y"
    { pform_startmodule((yyvsp[(3) - (3)].text), (yylsp[(2) - (3)]).text, (yylsp[(2) - (3)]).first_line, (yyvsp[(1) - (3)].named_pexprs)); }
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 2012 "./parse.y"
    { pform_module_set_ports((yyvsp[(6) - (8)].mports)); }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 2015 "./parse.y"
    { Module::UCDriveType ucd;
		  switch (uc_drive) {
		      case UCD_NONE:
		      default:
			ucd = Module::UCD_NONE;
			break;
		      case UCD_PULL0:
			ucd = Module::UCD_PULL0;
			break;
		      case UCD_PULL1:
			ucd = Module::UCD_PULL1;
			break;
		  }
		  pform_endmodule((yyvsp[(3) - (11)].text), in_celldefine, ucd);
		  delete[](yyvsp[(3) - (11)].text);
		}
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 2037 "./parse.y"
    { (yyval.mports) = 0; }
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 2038 "./parse.y"
    { (yyval.mports) = 0; }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 2042 "./parse.y"
    { (yyval.mports) = (yyvsp[(2) - (3)].mports); }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 2043 "./parse.y"
    { (yyval.mports) = (yyvsp[(2) - (3)].mports); }
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 2044 "./parse.y"
    { (yyval.mports) = 0; }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 2074 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (8)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[(2) - (8)]), (yyvsp[(5) - (8)].exprs), (yyvsp[(4) - (8)].flag), (yyvsp[(7) - (8)].perm_strings), (yyvsp[(2) - (8)].nettype),
				 NetNet::NOT_A_PORT, dtype, (yyvsp[(1) - (8)].named_pexprs));
		  if ((yyvsp[(6) - (8)].exprs) != 0) {
			yyerror((yylsp[(6) - (8)]), "sorry: net delays not supported.");
			delete (yyvsp[(6) - (8)].exprs);
		  }
		  if ((yyvsp[(1) - (8)].named_pexprs)) delete (yyvsp[(1) - (8)].named_pexprs);
		}
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 2094 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (8)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[(2) - (8)]), (yyvsp[(5) - (8)].exprs), (yyvsp[(4) - (8)].flag), (yyvsp[(6) - (8)].exprs),
				 str_strength, (yyvsp[(7) - (8)].net_decl_assign), (yyvsp[(2) - (8)].nettype), dtype);
		  if ((yyvsp[(1) - (8)].named_pexprs)) {
			yyerror((yylsp[(2) - (8)]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[(1) - (8)].named_pexprs);
		  }
		}
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 2113 "./parse.y"
    { ivl_variable_type_t dtype = (yyvsp[(3) - (7)].datatype);
		  if (dtype == IVL_VT_NO_TYPE)
			dtype = IVL_VT_LOGIC;
		  pform_makewire((yylsp[(2) - (7)]), 0, (yyvsp[(4) - (7)].flag), 0, (yyvsp[(5) - (7)].drive), (yyvsp[(6) - (7)].net_decl_assign), (yyvsp[(2) - (7)].nettype), dtype);
		  if ((yyvsp[(1) - (7)].named_pexprs)) {
			yyerror((yylsp[(2) - (7)]), "sorry: Attributes not supported "
				"on net declaration assignments.");
			delete (yyvsp[(1) - (7)].named_pexprs);
		  }
		}
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 2125 "./parse.y"
    { yyerror((yylsp[(1) - (6)]), "sorry: trireg nets not supported.");
		  delete (yyvsp[(3) - (6)].exprs);
		  delete (yyvsp[(4) - (6)].exprs);
		}
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 2131 "./parse.y"
    { pform_set_port_type((yylsp[(1) - (6)]), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(3) - (6)].exprs), (yyvsp[(2) - (6)].flag), (yyvsp[(1) - (6)].porttype));
		}
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 2139 "./parse.y"
    { pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(2) - (6)].nettype), (yyvsp[(1) - (6)].porttype), IVL_VT_NO_TYPE, 0,
		                 SR_BOTH);
		}
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 2144 "./parse.y"
    { list<pair<perm_string,PExpr*> >::const_iterator pp;
		  list<perm_string>*tmp = new list<perm_string>;
		  for (pp = (yyvsp[(5) - (6)].port_list)->begin(); pp != (yyvsp[(5) - (6)].port_list)->end(); pp++) {
			tmp->push_back((*pp).first);
		  }
		  pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), tmp, (yyvsp[(2) - (6)].nettype), NetNet::POUTPUT,
		                 IVL_VT_NO_TYPE, 0, SR_BOTH);
		  for (pp = (yyvsp[(5) - (6)].port_list)->begin(); pp != (yyvsp[(5) - (6)].port_list)->end(); pp++) {
			if ((*pp).second) {
			      pform_make_reginit((yylsp[(1) - (6)]), (*pp).first, (*pp).second);
			}
		  }
		  delete (yyvsp[(5) - (6)].port_list);
		}
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 2164 "./parse.y"
    { pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(2) - (6)].nettype), NetNet::PINPUT,
				 IVL_VT_NO_TYPE, 0);
		  yyerror((yylsp[(2) - (6)]), "error: reg variables cannot be inputs.");
		}
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 2170 "./parse.y"
    { pform_makewire((yylsp[(1) - (6)]), (yyvsp[(4) - (6)].exprs), (yyvsp[(3) - (6)].flag), (yyvsp[(5) - (6)].perm_strings), (yyvsp[(2) - (6)].nettype), NetNet::PINOUT,
				 IVL_VT_NO_TYPE, 0);
		  yyerror((yylsp[(2) - (6)]), "error: reg variables cannot be inouts.");
		}
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 2176 "./parse.y"
    { yyerror((yylsp[(1) - (6)]), "error: Invalid variable list"
			  " in port declaration.");
		  if ((yyvsp[(3) - (6)].exprs)) delete (yyvsp[(3) - (6)].exprs);
		  if ((yyvsp[(4) - (6)].exprs)) delete (yyvsp[(4) - (6)].exprs);
		  yyerrok;
		}
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 2187 "./parse.y"
    { pform_attach_discipline((yylsp[(1) - (3)]), (yyvsp[(1) - (3)].discipline), (yyvsp[(2) - (3)].perm_strings)); }
    break;

  case 323:

/* Line 1806 of yacc.c  */
#line 2203 "./parse.y"
    { pform_makegates((yyvsp[(2) - (4)].gatetype), str_strength, 0, (yyvsp[(3) - (4)].gates), (yyvsp[(1) - (4)].named_pexprs));
		}
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 2207 "./parse.y"
    { pform_makegates((yyvsp[(2) - (5)].gatetype), str_strength, (yyvsp[(3) - (5)].exprs), (yyvsp[(4) - (5)].gates), (yyvsp[(1) - (5)].named_pexprs));
		}
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 2211 "./parse.y"
    { pform_makegates((yyvsp[(2) - (5)].gatetype), (yyvsp[(3) - (5)].drive), 0, (yyvsp[(4) - (5)].gates), (yyvsp[(1) - (5)].named_pexprs));
		}
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 2215 "./parse.y"
    { pform_makegates((yyvsp[(2) - (6)].gatetype), (yyvsp[(3) - (6)].drive), (yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].gates), (yyvsp[(1) - (6)].named_pexprs));
		}
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 2220 "./parse.y"
    { pform_makegates((yyvsp[(2) - (4)].gatetype), str_strength, 0, (yyvsp[(3) - (4)].gates), (yyvsp[(1) - (4)].named_pexprs));
		}
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 2224 "./parse.y"
    { pform_makegates((yyvsp[(2) - (5)].gatetype), str_strength, (yyvsp[(3) - (5)].exprs), (yyvsp[(4) - (5)].gates), (yyvsp[(1) - (5)].named_pexprs));
		}
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 2231 "./parse.y"
    { pform_makegates(PGBuiltin::PULLUP, pull_strength, 0,
				  (yyvsp[(2) - (3)].gates), 0);
		}
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 2235 "./parse.y"
    { pform_makegates(PGBuiltin::PULLDOWN, pull_strength,
				  0, (yyvsp[(2) - (3)].gates), 0);
		}
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 2240 "./parse.y"
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[(3) - (6)].drive), 0, (yyvsp[(5) - (6)].gates), 0);
		}
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 2244 "./parse.y"
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[(3) - (8)].drive), 0, (yyvsp[(7) - (8)].gates), 0);
		}
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 2248 "./parse.y"
    { pform_makegates(PGBuiltin::PULLUP, (yyvsp[(5) - (8)].drive), 0, (yyvsp[(7) - (8)].gates), 0);
		}
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 2252 "./parse.y"
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[(3) - (6)].drive), 0, (yyvsp[(5) - (6)].gates), 0);
		}
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 2256 "./parse.y"
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[(5) - (8)].drive), 0, (yyvsp[(7) - (8)].gates), 0);
		}
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 2260 "./parse.y"
    { pform_makegates(PGBuiltin::PULLDOWN, (yyvsp[(3) - (8)].drive), 0, (yyvsp[(7) - (8)].gates), 0);
		}
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 2269 "./parse.y"
    { perm_string tmp1 = lex_strings.make((yyvsp[(2) - (5)].text));
		  pform_make_modgates(tmp1, (yyvsp[(3) - (5)].parmvalue), (yyvsp[(4) - (5)].gates));
		  delete[](yyvsp[(2) - (5)].text);
		  if ((yyvsp[(1) - (5)].named_pexprs)) delete (yyvsp[(1) - (5)].named_pexprs);
		}
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 2277 "./parse.y"
    { yyerror((yylsp[(2) - (5)]), "error: Invalid module instantiation");
		  delete[](yyvsp[(2) - (5)].text);
		  if ((yyvsp[(1) - (5)].named_pexprs)) delete (yyvsp[(1) - (5)].named_pexprs);
		}
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 2287 "./parse.y"
    { pform_make_pgassign_list((yyvsp[(4) - (5)].exprs), (yyvsp[(3) - (5)].exprs), (yyvsp[(2) - (5)].drive), (yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line); }
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 2292 "./parse.y"
    { PProcess*tmp = pform_make_behavior(IVL_PR_ALWAYS, (yyvsp[(3) - (3)].statement), (yyvsp[(1) - (3)].named_pexprs));
	FILE_NAME(tmp, (yylsp[(2) - (3)]));
      }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 2296 "./parse.y"
    { PProcess*tmp = pform_make_behavior(IVL_PR_INITIAL, (yyvsp[(3) - (3)].statement), (yyvsp[(1) - (3)].named_pexprs));
	FILE_NAME(tmp, (yylsp[(2) - (3)]));
      }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 2301 "./parse.y"
    { pform_make_analog_behavior((yylsp[(2) - (3)]), IVL_PR_ALWAYS, (yyvsp[(3) - (3)].statement)); }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 2312 "./parse.y"
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].text), (yyvsp[(2) - (4)].flag));
      }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 2318 "./parse.y"
    { current_task->set_ports((yyvsp[(6) - (8)].wires));
	current_task->set_statement((yyvsp[(7) - (8)].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[(3) - (8)].text);
      }
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 2326 "./parse.y"
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].text), (yyvsp[(2) - (4)].flag));
      }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 2333 "./parse.y"
    { current_task->set_ports((yyvsp[(6) - (11)].wires));
	current_task->set_statement((yyvsp[(10) - (11)].statement));
	pform_pop_scope();
	current_task = 0;
	delete[](yyvsp[(3) - (11)].text);
      }
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 2341 "./parse.y"
    { assert(current_task == 0);
	current_task = pform_push_task_scope((yylsp[(1) - (6)]), (yyvsp[(3) - (6)].text), (yyvsp[(2) - (6)].flag));
      }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 2347 "./parse.y"
    { current_task->set_ports(0);
	current_task->set_statement((yyvsp[(9) - (10)].statement));
	pform_pop_scope();
	current_task = 0;
	cerr << (yylsp[(3) - (10)]) << ": warning: task definition for \"" << (yyvsp[(3) - (10)].text)
	     << "\" has an empty port declaration list!" << endl;
	delete[](yyvsp[(3) - (10)].text);
      }
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 2357 "./parse.y"
    {
	assert(current_task == 0);
	delete[](yyvsp[(3) - (5)].text);
      }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 2368 "./parse.y"
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[(1) - (5)]), (yyvsp[(4) - (5)].text), (yyvsp[(2) - (5)].flag));
      }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 2373 "./parse.y"
    { current_function->set_ports((yyvsp[(7) - (9)].wires));
	current_function->set_statement((yyvsp[(8) - (9)].statement));
	current_function->set_return((yyvsp[(3) - (9)].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[(4) - (9)].text);
      }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 2382 "./parse.y"
    { assert(current_function == 0);
	current_function = pform_push_function_scope((yylsp[(1) - (4)]), (yyvsp[(4) - (4)].text), (yyvsp[(2) - (4)].flag));
      }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 2389 "./parse.y"
    { current_function->set_ports((yyvsp[(7) - (12)].wires));
	current_function->set_statement((yyvsp[(11) - (12)].statement));
	current_function->set_return((yyvsp[(3) - (12)].function_type));
	pform_pop_scope();
	current_function = 0;
	delete[](yyvsp[(4) - (12)].text);
      }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 2397 "./parse.y"
    {
	assert(current_function == 0);
	delete[](yyvsp[(4) - (6)].text);
      }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 2409 "./parse.y"
    { pform_genvars((yylsp[(1) - (3)]), (yyvsp[(2) - (3)].perm_strings)); }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 2414 "./parse.y"
    { pform_start_generate_for((yylsp[(1) - (12)]), (yyvsp[(3) - (12)].text), (yyvsp[(5) - (12)].expr), (yyvsp[(7) - (12)].expr), (yyvsp[(9) - (12)].text), (yyvsp[(11) - (12)].expr)); }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 2416 "./parse.y"
    { pform_endgenerate(); }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 2421 "./parse.y"
    { pform_start_generate_else((yylsp[(1) - (3)])); }
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 2423 "./parse.y"
    { pform_endgenerate(); }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 2427 "./parse.y"
    { pform_endgenerate(); }
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 2430 "./parse.y"
    { pform_start_generate_case((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].expr)); }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 2433 "./parse.y"
    { pform_endgenerate(); }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 2437 "./parse.y"
    { /* Detect and warn about anachronistic begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[(2) - (5)]) << ": warning: Anachronistic use of begin/end to surround generate schemes." << endl;
	}
      }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 2443 "./parse.y"
    {
	pform_start_generate_nblock((yylsp[(2) - (4)]), (yyvsp[(4) - (4)].text));
      }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 2446 "./parse.y"
    { /* Detect and warn about anachronistic named begin/end use */
	if (generation_flag > GN_VER2001) {
	      warn_count += 1;
	      cerr << (yylsp[(2) - (8)]) << ": warning: Anachronistic use of named begin/end to surround generate schemes." << endl;
	}
	pform_endgenerate();
      }
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 2457 "./parse.y"
    { /* empty lists are legal syntax. */ }
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 2460 "./parse.y"
    {
		}
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 2464 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error in specify block");
		  yyerrok;
		}
    break;

  case 370:

/* Line 1806 of yacc.c  */
#line 2473 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: missing endmodule or attempt to "
		              "nest modules.");
		  pform_error_nested_modules();
		  yyerrok;
		}
    break;

  case 371:

/* Line 1806 of yacc.c  */
#line 2480 "./parse.y"
    { yyerror((yylsp[(2) - (2)]), "error: invalid module item.");
		  yyerrok;
		}
    break;

  case 372:

/* Line 1806 of yacc.c  */
#line 2485 "./parse.y"
    { yyerror((yylsp[(1) - (5)]), "error: syntax error in left side "
			  "of continuous assignment.");
		  yyerrok;
		}
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 2491 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: syntax error in "
			  "continuous assignment");
		  yyerrok;
		}
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 2497 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "error: I give up on this "
			  "function definition.");
		  yyerrok;
		}
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 2506 "./parse.y"
    { perm_string tmp3 = lex_strings.make((yyvsp[(3) - (9)].text));
		  perm_string tmp5 = lex_strings.make((yyvsp[(5) - (9)].text));
		  pform_set_attrib(tmp3, tmp5, (yyvsp[(7) - (9)].text));
		  delete[] (yyvsp[(3) - (9)].text);
		  delete[] (yyvsp[(5) - (9)].text);
		}
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 2513 "./parse.y"
    { yyerror((yylsp[(1) - (5)]), "error: Malformed $attribute parameter list."); }
    break;

  case 377:

/* Line 1806 of yacc.c  */
#line 2517 "./parse.y"
    { (yyval.flag) = true; }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 2518 "./parse.y"
    { (yyval.flag) = false;}
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 2521 "./parse.y"
    { pform_start_generate_if((yylsp[(1) - (4)]), (yyvsp[(3) - (4)].expr)); }
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 2529 "./parse.y"
    { pform_generate_case_item((yylsp[(1) - (2)]), (yyvsp[(1) - (2)].exprs)); }
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 2530 "./parse.y"
    { pform_endgenerate(); }
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 2531 "./parse.y"
    { pform_generate_case_item((yylsp[(1) - (2)]), 0); }
    break;

  case 385:

/* Line 1806 of yacc.c  */
#line 2532 "./parse.y"
    { pform_endgenerate(); }
    break;

  case 392:

/* Line 1806 of yacc.c  */
#line 2555 "./parse.y"
    { pform_generate_block_name((yyvsp[(3) - (5)].text)); }
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 2570 "./parse.y"
    { net_decl_assign_t*tmp = new net_decl_assign_t;
	tmp->next = tmp;
	tmp->name = lex_strings.make((yyvsp[(1) - (3)].text));
	tmp->expr = (yyvsp[(3) - (3)].expr);
	delete[](yyvsp[(1) - (3)].text);
	(yyval.net_decl_assign) = tmp;
      }
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 2581 "./parse.y"
    { net_decl_assign_t*tmp = (yyvsp[(1) - (3)].net_decl_assign);
		  (yyvsp[(3) - (3)].net_decl_assign)->next = tmp->next;
		  tmp->next = (yyvsp[(3) - (3)].net_decl_assign);
		  (yyval.net_decl_assign) = tmp;
		}
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 2587 "./parse.y"
    { (yyval.net_decl_assign) = (yyvsp[(1) - (1)].net_decl_assign);
		}
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 2592 "./parse.y"
    { (yyval.datatype) = IVL_VT_LOGIC; }
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 2593 "./parse.y"
    { (yyval.datatype) = IVL_VT_BOOL; }
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 2594 "./parse.y"
    { (yyval.datatype) = IVL_VT_REAL; }
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 2597 "./parse.y"
    { (yyval.datatype) = (yyvsp[(1) - (1)].datatype); }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 2597 "./parse.y"
    { (yyval.datatype) = IVL_VT_NO_TYPE; }
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 2600 "./parse.y"
    { (yyval.nettype) = NetNet::WIRE; }
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 2601 "./parse.y"
    { (yyval.nettype) = NetNet::TRI; }
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 2602 "./parse.y"
    { (yyval.nettype) = NetNet::TRI1; }
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 2603 "./parse.y"
    { (yyval.nettype) = NetNet::SUPPLY0; }
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 2604 "./parse.y"
    { (yyval.nettype) = NetNet::WAND; }
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 2605 "./parse.y"
    { (yyval.nettype) = NetNet::TRIAND; }
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 2606 "./parse.y"
    { (yyval.nettype) = NetNet::TRI0; }
    break;

  case 410:

/* Line 1806 of yacc.c  */
#line 2607 "./parse.y"
    { (yyval.nettype) = NetNet::SUPPLY1; }
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 2608 "./parse.y"
    { (yyval.nettype) = NetNet::WOR; }
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 2609 "./parse.y"
    { (yyval.nettype) = NetNet::TRIOR; }
    break;

  case 413:

/* Line 1806 of yacc.c  */
#line 2610 "./parse.y"
    { (yyval.nettype) = NetNet::UWIRE;
		      cerr << (yylsp[(1) - (1)]).text << ":" << (yylsp[(1) - (1)]).first_line << ": warning: "
		              "'wone' is deprecated, please use 'uwire' "
		              "instead." << endl;
		    }
    break;

  case 414:

/* Line 1806 of yacc.c  */
#line 2615 "./parse.y"
    { (yyval.nettype) = NetNet::UWIRE; }
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 2619 "./parse.y"
    { (yyval.nettype) = NetNet::REG; }
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 2628 "./parse.y"
    { param_active_range = (yyvsp[(1) - (1)].exprs);
        param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 418:

/* Line 1806 of yacc.c  */
#line 2633 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 2638 "./parse.y"
    { param_active_range = (yyvsp[(2) - (2)].exprs);
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 420:

/* Line 1806 of yacc.c  */
#line 2643 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 2648 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum(integer_width-1, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The default range is [31:0] */
        param_active_range = range_stub;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 422:

/* Line 1806 of yacc.c  */
#line 2660 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 2665 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum((uint64_t)63, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The range is [63:0] */
        param_active_range = range_stub;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 424:

/* Line 1806 of yacc.c  */
#line 2677 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 425:

/* Line 1806 of yacc.c  */
#line 2682 "./parse.y"
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_REAL;
      }
    break;

  case 426:

/* Line 1806 of yacc.c  */
#line 2687 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 429:

/* Line 1806 of yacc.c  */
#line 2700 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (4)].expr);
	pform_set_parameter((yylsp[(1) - (4)]), lex_strings.make((yyvsp[(1) - (4)].text)), param_active_type,
			    param_active_signed, param_active_range, tmp, (yyvsp[(4) - (4)].value_range));
	delete[](yyvsp[(1) - (4)].text);
      }
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 2707 "./parse.y"
    { (yyval.value_range) = (yyvsp[(1) - (1)].value_range); }
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 2707 "./parse.y"
    { (yyval.value_range) = 0; }
    break;

  case 432:

/* Line 1806 of yacc.c  */
#line 2711 "./parse.y"
    { (yyval.value_range) = (yyvsp[(2) - (2)].value_range); (yyval.value_range)->next = (yyvsp[(1) - (2)].value_range); }
    break;

  case 433:

/* Line 1806 of yacc.c  */
#line 2713 "./parse.y"
    { (yyval.value_range) = (yyvsp[(1) - (1)].value_range); (yyval.value_range)->next = 0; }
    break;

  case 434:

/* Line 1806 of yacc.c  */
#line 2718 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), false, (yyvsp[(3) - (6)].expr), false, (yyvsp[(5) - (6)].expr)); }
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 2720 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), false, (yyvsp[(3) - (6)].expr), true, (yyvsp[(5) - (6)].expr)); }
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 2722 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), true, (yyvsp[(3) - (6)].expr), false, (yyvsp[(5) - (6)].expr)); }
    break;

  case 437:

/* Line 1806 of yacc.c  */
#line 2724 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range((yyvsp[(1) - (6)].flag), true, (yyvsp[(3) - (6)].expr), true, (yyvsp[(5) - (6)].expr)); }
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 2726 "./parse.y"
    { (yyval.value_range) = pform_parameter_value_range(true, false, (yyvsp[(2) - (2)].expr), false, (yyvsp[(2) - (2)].expr)); }
    break;

  case 439:

/* Line 1806 of yacc.c  */
#line 2730 "./parse.y"
    { (yyval.expr) = (yyvsp[(1) - (1)].expr); }
    break;

  case 440:

/* Line 1806 of yacc.c  */
#line 2731 "./parse.y"
    { (yyval.expr) = 0; }
    break;

  case 441:

/* Line 1806 of yacc.c  */
#line 2732 "./parse.y"
    { (yyval.expr) = 0; }
    break;

  case 442:

/* Line 1806 of yacc.c  */
#line 2733 "./parse.y"
    { (yyval.expr) = 0; }
    break;

  case 443:

/* Line 1806 of yacc.c  */
#line 2736 "./parse.y"
    { (yyval.flag) = false; }
    break;

  case 444:

/* Line 1806 of yacc.c  */
#line 2736 "./parse.y"
    { (yyval.flag) = true; }
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 2745 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (3)].expr);
	pform_set_localparam((yylsp[(1) - (3)]), lex_strings.make((yyvsp[(1) - (3)].text)),
			     param_active_type,
			     param_active_signed,
			     param_active_range, tmp);
	delete[](yyvsp[(1) - (3)].text);
      }
    break;

  case 447:

/* Line 1806 of yacc.c  */
#line 2757 "./parse.y"
    { param_active_range = (yyvsp[(1) - (1)].exprs);
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 2762 "./parse.y"
    { param_active_range = 0;
        param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 2767 "./parse.y"
    { param_active_range = (yyvsp[(2) - (2)].exprs);
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 2772 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 451:

/* Line 1806 of yacc.c  */
#line 2777 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum(integer_width-1, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The default range is [31:0] */
        param_active_range = range_stub;
	param_active_signed = true;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 452:

/* Line 1806 of yacc.c  */
#line 2789 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 453:

/* Line 1806 of yacc.c  */
#line 2794 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
        PExpr*re;
        re = new PENumber(new verinum((uint64_t)63, integer_width));
        (*range_stub)[0] = re;
        re = new PENumber(new verinum((uint64_t)0, integer_width));
        (*range_stub)[1] = re;
        /* The range is [63:0] */
        param_active_range = range_stub;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 454:

/* Line 1806 of yacc.c  */
#line 2806 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 2811 "./parse.y"
    { param_active_range = 0;
	param_active_signed = true;
	param_active_type = IVL_VT_REAL;
      }
    break;

  case 456:

/* Line 1806 of yacc.c  */
#line 2816 "./parse.y"
    { param_active_range = 0;
	param_active_signed = false;
	param_active_type = IVL_VT_LOGIC;
      }
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 2845 "./parse.y"
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = (yyvsp[(3) - (4)].exprs);
		  tmp->by_name = 0;
		  (yyval.parmvalue) = tmp;
		}
    break;

  case 460:

/* Line 1806 of yacc.c  */
#line 2851 "./parse.y"
    { struct parmvalue_t*tmp = new struct parmvalue_t;
		  tmp->by_order = 0;
		  tmp->by_name = (yyvsp[(3) - (4)].named_pexprs);
		  (yyval.parmvalue) = tmp;
		}
    break;

  case 461:

/* Line 1806 of yacc.c  */
#line 2857 "./parse.y"
    { assert((yyvsp[(2) - (2)].number));
		  PENumber*tmp = new PENumber((yyvsp[(2) - (2)].number));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));

		  struct parmvalue_t*lst = new struct parmvalue_t;
		  lst->by_order = new svector<PExpr*>(1);
		  (*lst->by_order)[0] = tmp;
		  lst->by_name = 0;
		  (yyval.parmvalue) = lst;
		  based_size = 0;
		}
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 2869 "./parse.y"
    { yyerror((yylsp[(1) - (2)]), "error: syntax error in parameter value "
			  "assignment list.");
		  (yyval.parmvalue) = 0;
		}
    break;

  case 463:

/* Line 1806 of yacc.c  */
#line 2874 "./parse.y"
    { (yyval.parmvalue) = 0; }
    break;

  case 464:

/* Line 1806 of yacc.c  */
#line 2879 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  tmp->parm = (yyvsp[(4) - (5)].expr);
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.named_pexpr) = tmp;
		}
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 2886 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (4)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(2) - (4)].text);
		  (yyval.named_pexpr) = tmp;
		}
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 2896 "./parse.y"
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 2901 "./parse.y"
    { svector<named_pexpr_t*>*tmp =
			new svector<named_pexpr_t*>(*(yyvsp[(1) - (3)].named_pexprs),(yyvsp[(3) - (3)].named_pexpr));
		  delete (yyvsp[(1) - (3)].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
    break;

  case 468:

/* Line 1806 of yacc.c  */
#line 2924 "./parse.y"
    { (yyval.mport) = (yyvsp[(1) - (1)].mport); }
    break;

  case 469:

/* Line 1806 of yacc.c  */
#line 2932 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(4) - (5)].mport);
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.mport) = tmp;
		}
    break;

  case 470:

/* Line 1806 of yacc.c  */
#line 2943 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(2) - (3)].mport);
		  tmp->name = perm_string();
		  (yyval.mport) = tmp;
		}
    break;

  case 471:

/* Line 1806 of yacc.c  */
#line 2952 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(5) - (7)].mport);
		  tmp->name = lex_strings.make((yyvsp[(2) - (7)].text));
		  delete[](yyvsp[(2) - (7)].text);
		  (yyval.mport) = tmp;
		}
    break;

  case 472:

/* Line 1806 of yacc.c  */
#line 2960 "./parse.y"
    { (yyval.mport) = (yyvsp[(1) - (1)].mport); }
    break;

  case 473:

/* Line 1806 of yacc.c  */
#line 2961 "./parse.y"
    { (yyval.mport) = 0; }
    break;

  case 474:

/* Line 1806 of yacc.c  */
#line 2978 "./parse.y"
    { Module::port_t*ptmp;
	  perm_string name = lex_strings.make((yyvsp[(1) - (1)].text));
	  ptmp = pform_module_port_reference(name, (yylsp[(1) - (1)]).text, (yylsp[(1) - (1)]).first_line);
	  delete[](yyvsp[(1) - (1)].text);
	  (yyval.mport) = ptmp;
	}
    break;

  case 475:

/* Line 1806 of yacc.c  */
#line 2986 "./parse.y"
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_PART;
	  itmp.msb = (yyvsp[(3) - (6)].expr);
	  itmp.lsb = (yyvsp[(5) - (6)].expr);

	  name_component_t ntmp (lex_strings.make((yyvsp[(1) - (6)].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*wtmp = new PEIdent(pname);
	  FILE_NAME(wtmp, (yylsp[(1) - (6)]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(wtmp);

	  delete[](yyvsp[(1) - (6)].text);
	  (yyval.mport) = ptmp;
	}
    break;

  case 476:

/* Line 1806 of yacc.c  */
#line 3009 "./parse.y"
    { index_component_t itmp;
	  itmp.sel = index_component_t::SEL_BIT;
	  itmp.msb = (yyvsp[(3) - (4)].expr);
	  itmp.lsb = 0;

	  name_component_t ntmp (lex_strings.make((yyvsp[(1) - (4)].text)));
	  ntmp.index.push_back(itmp);

	  pform_name_t pname;
	  pname.push_back(ntmp);

	  PEIdent*tmp = new PEIdent(pname);
	  FILE_NAME(tmp, (yylsp[(1) - (4)]));

	  Module::port_t*ptmp = new Module::port_t;
	  ptmp->name = perm_string();
	  ptmp->expr.push_back(tmp);
	  delete[](yyvsp[(1) - (4)].text);
	  (yyval.mport) = ptmp;
	}
    break;

  case 477:

/* Line 1806 of yacc.c  */
#line 3031 "./parse.y"
    { yyerror((yylsp[(1) - (4)]), "error: invalid port bit select");
	  Module::port_t*ptmp = new Module::port_t;
	  PEIdent*wtmp = new PEIdent(lex_strings.make((yyvsp[(1) - (4)].text)));
	  FILE_NAME(wtmp, (yylsp[(1) - (4)]));
	  ptmp->name = lex_strings.make((yyvsp[(1) - (4)].text));
	  ptmp->expr.push_back(wtmp);
	  delete[](yyvsp[(1) - (4)].text);
	  (yyval.mport) = ptmp;
	}
    break;

  case 478:

/* Line 1806 of yacc.c  */
#line 3045 "./parse.y"
    { (yyval.mport) = (yyvsp[(1) - (1)].mport); }
    break;

  case 479:

/* Line 1806 of yacc.c  */
#line 3047 "./parse.y"
    { Module::port_t*tmp = (yyvsp[(1) - (3)].mport);
		  append(tmp->expr, (yyvsp[(3) - (3)].mport)->expr);
		  delete (yyvsp[(3) - (3)].mport);
		  (yyval.mport) = tmp;
		}
    break;

  case 480:

/* Line 1806 of yacc.c  */
#line 3060 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  tmp->parm = (yyvsp[(4) - (5)].expr);
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.named_pexpr) = tmp;
		}
    break;

  case 481:

/* Line 1806 of yacc.c  */
#line 3067 "./parse.y"
    { yyerror((yylsp[(3) - (5)]), "error: invalid port connection expression.");
		  named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (5)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.named_pexpr) = tmp;
		}
    break;

  case 482:

/* Line 1806 of yacc.c  */
#line 3075 "./parse.y"
    { named_pexpr_t*tmp = new named_pexpr_t;
		  tmp->name = lex_strings.make((yyvsp[(2) - (4)].text));
		  tmp->parm = 0;
		  delete[](yyvsp[(2) - (4)].text);
		  (yyval.named_pexpr) = tmp;
		}
    break;

  case 483:

/* Line 1806 of yacc.c  */
#line 3085 "./parse.y"
    { svector<named_pexpr_t*>*tmp;
		  tmp = new svector<named_pexpr_t*>(*(yyvsp[(1) - (3)].named_pexprs), (yyvsp[(3) - (3)].named_pexpr));
		  delete (yyvsp[(1) - (3)].named_pexprs);
		  (yyval.named_pexprs) = tmp;
		}
    break;

  case 484:

/* Line 1806 of yacc.c  */
#line 3091 "./parse.y"
    { svector<named_pexpr_t*>*tmp = new svector<named_pexpr_t*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].named_pexpr);
		  (yyval.named_pexprs) = tmp;
		}
    break;

  case 485:

/* Line 1806 of yacc.c  */
#line 3098 "./parse.y"
    { (yyval.porttype) = NetNet::PINPUT; }
    break;

  case 486:

/* Line 1806 of yacc.c  */
#line 3099 "./parse.y"
    { (yyval.porttype) = NetNet::POUTPUT; }
    break;

  case 487:

/* Line 1806 of yacc.c  */
#line 3100 "./parse.y"
    { (yyval.porttype) = NetNet::PINOUT; }
    break;

  case 488:

/* Line 1806 of yacc.c  */
#line 3105 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*> (2);
		  (*tmp)[0] = (yyvsp[(2) - (5)].expr);
		  (*tmp)[1] = (yyvsp[(4) - (5)].expr);
		  (yyval.exprs) = tmp;
		}
    break;

  case 490:

/* Line 1806 of yacc.c  */
#line 3114 "./parse.y"
    { (yyval.exprs) = 0; }
    break;

  case 491:

/* Line 1806 of yacc.c  */
#line 3117 "./parse.y"
    { (yyval.dimensions) = 0; }
    break;

  case 492:

/* Line 1806 of yacc.c  */
#line 3118 "./parse.y"
    { (yyval.dimensions) = (yyvsp[(1) - (1)].dimensions); }
    break;

  case 493:

/* Line 1806 of yacc.c  */
#line 3122 "./parse.y"
    { list<index_component_t> *tmp = new list<index_component_t>;
		  index_component_t index;
		  index.msb = (yyvsp[(2) - (5)].expr);
		  index.lsb = (yyvsp[(4) - (5)].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		}
    break;

  case 494:

/* Line 1806 of yacc.c  */
#line 3130 "./parse.y"
    { list<index_component_t> *tmp = (yyvsp[(1) - (6)].dimensions);
		  index_component_t index;
		  index.msb = (yyvsp[(3) - (6)].expr);
		  index.lsb = (yyvsp[(5) - (6)].expr);
		  tmp->push_back(index);
		  (yyval.dimensions) = tmp;
		}
    break;

  case 495:

/* Line 1806 of yacc.c  */
#line 3140 "./parse.y"
    { (yyval.function_type).range = (yyvsp[(1) - (1)].exprs); (yyval.function_type).type = PTF_REG; }
    break;

  case 496:

/* Line 1806 of yacc.c  */
#line 3141 "./parse.y"
    { (yyval.function_type).range = (yyvsp[(2) - (2)].exprs); (yyval.function_type).type = PTF_REG_S; }
    break;

  case 497:

/* Line 1806 of yacc.c  */
#line 3142 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_INTEGER; }
    break;

  case 498:

/* Line 1806 of yacc.c  */
#line 3143 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REAL; }
    break;

  case 499:

/* Line 1806 of yacc.c  */
#line 3144 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REALTIME; }
    break;

  case 500:

/* Line 1806 of yacc.c  */
#line 3145 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_TIME; }
    break;

  case 501:

/* Line 1806 of yacc.c  */
#line 3146 "./parse.y"
    { (yyval.function_type).range = 0;  (yyval.function_type).type = PTF_REG; }
    break;

  case 502:

/* Line 1806 of yacc.c  */
#line 3156 "./parse.y"
    { perm_string ident_name = lex_strings.make((yyvsp[(1) - (2)].text));
	pform_makewire((yylsp[(1) - (2)]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[(2) - (2)].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[(2) - (2)].dimensions)->size() > 1) {
		    yyerror((yylsp[(2) - (2)]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[(2) - (2)].dimensions)->front();
	      pform_set_reg_idx(ident_name, index.msb, index.lsb);
	      delete (yyvsp[(2) - (2)].dimensions);
	}
	(yyval.text) = (yyvsp[(1) - (2)].text);
      }
    break;

  case 503:

/* Line 1806 of yacc.c  */
#line 3172 "./parse.y"
    { perm_string ident_name = lex_strings.make((yyvsp[(1) - (3)].text));
	pform_makewire((yylsp[(1) - (3)]), ident_name, NetNet::REG,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	pform_make_reginit((yylsp[(1) - (3)]), ident_name, (yyvsp[(3) - (3)].expr));
	(yyval.text) = (yyvsp[(1) - (3)].text);
      }
    break;

  case 504:

/* Line 1806 of yacc.c  */
#line 3182 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		}
    break;

  case 505:

/* Line 1806 of yacc.c  */
#line 3188 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (3)].text);
		}
    break;

  case 506:

/* Line 1806 of yacc.c  */
#line 3197 "./parse.y"
    { perm_string name = lex_strings.make((yyvsp[(1) - (2)].text));
        pform_makewire((yylsp[(1) - (2)]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
        if ((yyvsp[(2) - (2)].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[(2) - (2)].dimensions)->size() > 1) {
		    yyerror((yylsp[(2) - (2)]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[(2) - (2)].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[(2) - (2)].dimensions);
        }
	(yyval.text) = (yyvsp[(1) - (2)].text);
      }
    break;

  case 507:

/* Line 1806 of yacc.c  */
#line 3212 "./parse.y"
    { perm_string name = lex_strings.make((yyvsp[(1) - (3)].text));
	pform_makewire((yylsp[(1) - (3)]), name, NetNet::REG, NetNet::NOT_A_PORT, IVL_VT_REAL, 0);
	pform_make_reginit((yylsp[(1) - (3)]), name, (yyvsp[(3) - (3)].expr));
	(yyval.text) = (yyvsp[(1) - (3)].text);
      }
    break;

  case 508:

/* Line 1806 of yacc.c  */
#line 3221 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[(1) - (1)].text);
      }
    break;

  case 509:

/* Line 1806 of yacc.c  */
#line 3227 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
	(yyval.perm_strings) = tmp;
	delete[](yyvsp[(3) - (3)].text);
      }
    break;

  case 510:

/* Line 1806 of yacc.c  */
#line 3236 "./parse.y"
    { perm_string name = lex_strings.make((yyvsp[(1) - (2)].text));
	pform_makewire((yylsp[(1) - (2)]), name, NetNet::IMPLICIT,
		       NetNet::NOT_A_PORT, IVL_VT_NO_TYPE, 0);
	if ((yyvsp[(2) - (2)].dimensions) != 0) {
	      index_component_t index;
	      if ((yyvsp[(2) - (2)].dimensions)->size() > 1) {
		    yyerror((yylsp[(2) - (2)]), "sorry: only 1 dimensional arrays "
			    "are currently supported.");
	      }
	      index = (yyvsp[(2) - (2)].dimensions)->front();
	      pform_set_reg_idx(name, index.msb, index.lsb);
	      delete (yyvsp[(2) - (2)].dimensions);
	}
	(yyval.text) = (yyvsp[(1) - (2)].text);
      }
    break;

  case 511:

/* Line 1806 of yacc.c  */
#line 3255 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		}
    break;

  case 512:

/* Line 1806 of yacc.c  */
#line 3261 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (3)].text);
		}
    break;

  case 514:

/* Line 1806 of yacc.c  */
#line 3271 "./parse.y"
    { pform_module_specify_path((yyvsp[(1) - (2)].specpath));
		}
    break;

  case 515:

/* Line 1806 of yacc.c  */
#line 3274 "./parse.y"
    { pform_module_specify_path((yyvsp[(1) - (2)].specpath));
		}
    break;

  case 516:

/* Line 1806 of yacc.c  */
#line 3277 "./parse.y"
    { PSpecPath*tmp = (yyvsp[(5) - (6)].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[(3) - (6)].expr);
		  }
		  pform_module_specify_path(tmp);
		}
    break;

  case 517:

/* Line 1806 of yacc.c  */
#line 3285 "./parse.y"
    { PSpecPath*tmp = (yyvsp[(5) - (6)].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = (yyvsp[(3) - (6)].expr);
		  }
		  pform_module_specify_path(tmp);
		}
    break;

  case 518:

/* Line 1806 of yacc.c  */
#line 3293 "./parse.y"
    { PSpecPath*tmp = (yyvsp[(2) - (3)].specpath);
		  if (tmp) {
			tmp->conditional = true;
			tmp->condition = 0;
		  }
		  pform_module_specify_path(tmp);
		}
    break;

  case 519:

/* Line 1806 of yacc.c  */
#line 3301 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "Sorry: ifnone with an edge-sensitive path is "
		              "not supported.");
		  yyerrok;
		}
    break;

  case 520:

/* Line 1806 of yacc.c  */
#line 3307 "./parse.y"
    { delete (yyvsp[(7) - (12)].expr);
		  delete (yyvsp[(9) - (12)].expr);
		}
    break;

  case 521:

/* Line 1806 of yacc.c  */
#line 3312 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		}
    break;

  case 522:

/* Line 1806 of yacc.c  */
#line 3316 "./parse.y"
    { delete (yyvsp[(7) - (12)].expr);
		  delete (yyvsp[(9) - (12)].expr);
		}
    break;

  case 523:

/* Line 1806 of yacc.c  */
#line 3321 "./parse.y"
    { delete (yyvsp[(5) - (8)].expr);
		}
    break;

  case 524:

/* Line 1806 of yacc.c  */
#line 3325 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		}
    break;

  case 525:

/* Line 1806 of yacc.c  */
#line 3329 "./parse.y"
    { delete (yyvsp[(7) - (12)].expr);
		  delete (yyvsp[(9) - (12)].expr);
		}
    break;

  case 526:

/* Line 1806 of yacc.c  */
#line 3334 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		}
    break;

  case 527:

/* Line 1806 of yacc.c  */
#line 3338 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		}
    break;

  case 528:

/* Line 1806 of yacc.c  */
#line 3342 "./parse.y"
    { delete (yyvsp[(7) - (12)].expr);
		  delete (yyvsp[(9) - (12)].expr);
		}
    break;

  case 529:

/* Line 1806 of yacc.c  */
#line 3347 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		}
    break;

  case 530:

/* Line 1806 of yacc.c  */
#line 3351 "./parse.y"
    { delete (yyvsp[(7) - (10)].expr);
		}
    break;

  case 531:

/* Line 1806 of yacc.c  */
#line 3355 "./parse.y"
    { delete (yyvsp[(5) - (10)].expr);
		  delete (yyvsp[(7) - (10)].expr);
		}
    break;

  case 532:

/* Line 1806 of yacc.c  */
#line 3359 "./parse.y"
    { delete (yyvsp[(5) - (7)].expr);
		}
    break;

  case 533:

/* Line 1806 of yacc.c  */
#line 3362 "./parse.y"
    { delete (yyvsp[(2) - (3)].perm_strings);
		}
    break;

  case 534:

/* Line 1806 of yacc.c  */
#line 3365 "./parse.y"
    { delete (yyvsp[(2) - (3)].perm_strings);
		}
    break;

  case 535:

/* Line 1806 of yacc.c  */
#line 3368 "./parse.y"
    { delete (yyvsp[(2) - (3)].perm_strings);
		}
    break;

  case 536:

/* Line 1806 of yacc.c  */
#line 3371 "./parse.y"
    { delete (yyvsp[(2) - (3)].perm_strings);
		}
    break;

  case 539:

/* Line 1806 of yacc.c  */
#line 3382 "./parse.y"
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (5)].specpath), (yyvsp[(4) - (5)].exprs)); }
    break;

  case 540:

/* Line 1806 of yacc.c  */
#line 3384 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (3)].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (3)].specpath), tmp);
		}
    break;

  case 541:

/* Line 1806 of yacc.c  */
#line 3390 "./parse.y"
    { (yyval.flag) = true; }
    break;

  case 542:

/* Line 1806 of yacc.c  */
#line 3390 "./parse.y"
    { (yyval.flag) = false; }
    break;

  case 543:

/* Line 1806 of yacc.c  */
#line 3395 "./parse.y"
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (10)]), edge_flag, (yyvsp[(2) - (10)].perm_strings), (yyvsp[(3) - (10)].letter), false, (yyvsp[(6) - (10)].perm_strings), (yyvsp[(8) - (10)].expr)); }
    break;

  case 544:

/* Line 1806 of yacc.c  */
#line 3399 "./parse.y"
    { int edge_flag = (yyvsp[(2) - (11)].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (11)]), edge_flag, (yyvsp[(3) - (11)].perm_strings), (yyvsp[(4) - (11)].letter), false, (yyvsp[(7) - (11)].perm_strings), (yyvsp[(9) - (11)].expr));}
    break;

  case 545:

/* Line 1806 of yacc.c  */
#line 3403 "./parse.y"
    { int edge_flag = 0;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (10)]), edge_flag, (yyvsp[(2) - (10)].perm_strings), (yyvsp[(3) - (10)].letter), true, (yyvsp[(6) - (10)].perm_strings), (yyvsp[(8) - (10)].expr)); }
    break;

  case 546:

/* Line 1806 of yacc.c  */
#line 3407 "./parse.y"
    { int edge_flag = (yyvsp[(2) - (11)].flag)? 1 : -1;
		      (yyval.specpath) = pform_make_specify_edge_path((yylsp[(1) - (11)]), edge_flag, (yyvsp[(3) - (11)].perm_strings), (yyvsp[(4) - (11)].letter), true, (yyvsp[(7) - (11)].perm_strings), (yyvsp[(9) - (11)].expr)); }
    break;

  case 550:

/* Line 1806 of yacc.c  */
#line 3419 "./parse.y"
    { (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (5)].specpath), (yyvsp[(4) - (5)].exprs)); }
    break;

  case 551:

/* Line 1806 of yacc.c  */
#line 3421 "./parse.y"
    { svector<PExpr*>*tmp = new svector<PExpr*>(1);
		  (*tmp)[0] = (yyvsp[(3) - (3)].expr);
		  (yyval.specpath) = pform_assign_path_delay((yyvsp[(1) - (3)].specpath), tmp);
		}
    break;

  case 552:

/* Line 1806 of yacc.c  */
#line 3426 "./parse.y"
    { yyerror((yylsp[(3) - (5)]), "Syntax error in delay value list.");
		  yyerrok;
		  (yyval.specpath) = 0;
		}
    break;

  case 553:

/* Line 1806 of yacc.c  */
#line 3435 "./parse.y"
    { (yyval.specpath) = pform_make_specify_path((yylsp[(1) - (6)]), (yyvsp[(2) - (6)].perm_strings), (yyvsp[(3) - (6)].letter), false, (yyvsp[(5) - (6)].perm_strings)); }
    break;

  case 554:

/* Line 1806 of yacc.c  */
#line 3438 "./parse.y"
    { (yyval.specpath) = pform_make_specify_path((yylsp[(1) - (6)]), (yyvsp[(2) - (6)].perm_strings), (yyvsp[(3) - (6)].letter), true, (yyvsp[(5) - (6)].perm_strings)); }
    break;

  case 555:

/* Line 1806 of yacc.c  */
#line 3440 "./parse.y"
    { yyerror((yylsp[(1) - (3)]), "Invalid simple path");
		  yyerrok;
		}
    break;

  case 556:

/* Line 1806 of yacc.c  */
#line 3447 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (1)].text);
		}
    break;

  case 557:

/* Line 1806 of yacc.c  */
#line 3453 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(1) - (4)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(1) - (4)].text);
		}
    break;

  case 558:

/* Line 1806 of yacc.c  */
#line 3459 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (3)].text);
		}
    break;

  case 559:

/* Line 1806 of yacc.c  */
#line 3465 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (6)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(3) - (6)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(3) - (6)].text);
		}
    break;

  case 560:

/* Line 1806 of yacc.c  */
#line 3474 "./parse.y"
    { PExpr*tmp = (yyvsp[(3) - (3)].expr);
		  pform_set_specparam(lex_strings.make((yyvsp[(1) - (3)].text)), tmp);
		  delete[](yyvsp[(1) - (3)].text);
		}
    break;

  case 561:

/* Line 1806 of yacc.c  */
#line 3479 "./parse.y"
    { PExpr*tmp = 0;
		  switch (min_typ_max_flag) {
		      case MIN:
			tmp = (yyvsp[(3) - (7)].expr);
			delete (yyvsp[(5) - (7)].expr);
			delete (yyvsp[(7) - (7)].expr);
			break;
		      case TYP:
			delete (yyvsp[(3) - (7)].expr);
			tmp = (yyvsp[(5) - (7)].expr);
			delete (yyvsp[(7) - (7)].expr);
			break;
		      case MAX:
			delete (yyvsp[(3) - (7)].expr);
			delete (yyvsp[(5) - (7)].expr);
			tmp = (yyvsp[(7) - (7)].expr);
			break;
		  }
		  if (min_typ_max_warn > 0) {
		        cerr << tmp->get_fileline() << ": warning: choosing ";
		        switch (min_typ_max_flag) {
		            case MIN:
		              cerr << "min";
		              break;
		            case TYP:
		              cerr << "typ";
		              break;
		            case MAX:
		              cerr << "max";
		              break;
		        }
		        cerr << " expression." << endl;
		        min_typ_max_warn -= 1;
		  }
		  pform_set_specparam(lex_strings.make((yyvsp[(1) - (7)].text)), tmp);
		  delete[](yyvsp[(1) - (7)].text);
		}
    break;

  case 562:

/* Line 1806 of yacc.c  */
#line 3517 "./parse.y"
    { delete[](yyvsp[(1) - (3)].text);
		  delete (yyvsp[(3) - (3)].expr);
		}
    break;

  case 563:

/* Line 1806 of yacc.c  */
#line 3521 "./parse.y"
    { delete[](yyvsp[(1) - (7)].text);
		  delete (yyvsp[(4) - (7)].expr);
		  delete (yyvsp[(6) - (7)].expr);
		}
    break;

  case 566:

/* Line 1806 of yacc.c  */
#line 3533 "./parse.y"
    { (yyval.letter) = '+'; }
    break;

  case 567:

/* Line 1806 of yacc.c  */
#line 3534 "./parse.y"
    { (yyval.letter) = '-'; }
    break;

  case 568:

/* Line 1806 of yacc.c  */
#line 3535 "./parse.y"
    { (yyval.letter) = 0;   }
    break;

  case 569:

/* Line 1806 of yacc.c  */
#line 3540 "./parse.y"
    { delete (yyvsp[(2) - (2)].expr); }
    break;

  case 570:

/* Line 1806 of yacc.c  */
#line 3542 "./parse.y"
    { delete (yyvsp[(2) - (2)].expr); }
    break;

  case 571:

/* Line 1806 of yacc.c  */
#line 3544 "./parse.y"
    { delete (yyvsp[(2) - (4)].expr);
      delete (yyvsp[(4) - (4)].expr);
    }
    break;

  case 572:

/* Line 1806 of yacc.c  */
#line 3548 "./parse.y"
    { delete (yyvsp[(2) - (4)].expr);
      delete (yyvsp[(4) - (4)].expr);
    }
    break;

  case 573:

/* Line 1806 of yacc.c  */
#line 3552 "./parse.y"
    { delete (yyvsp[(5) - (5)].expr); }
    break;

  case 574:

/* Line 1806 of yacc.c  */
#line 3554 "./parse.y"
    { delete (yyvsp[(5) - (7)].expr);
      delete (yyvsp[(7) - (7)].expr);
    }
    break;

  case 575:

/* Line 1806 of yacc.c  */
#line 3558 "./parse.y"
    { delete (yyvsp[(1) - (3)].expr);
      delete (yyvsp[(3) - (3)].expr);
    }
    break;

  case 576:

/* Line 1806 of yacc.c  */
#line 3562 "./parse.y"
    { delete (yyvsp[(1) - (1)].expr); }
    break;

  case 579:

/* Line 1806 of yacc.c  */
#line 3576 "./parse.y"
    {  }
    break;

  case 580:

/* Line 1806 of yacc.c  */
#line 3578 "./parse.y"
    {  }
    break;

  case 581:

/* Line 1806 of yacc.c  */
#line 3582 "./parse.y"
    { args_after_notifier = 0; }
    break;

  case 582:

/* Line 1806 of yacc.c  */
#line 3584 "./parse.y"
    { args_after_notifier = 0; delete (yyvsp[(2) - (2)].pform_name); }
    break;

  case 583:

/* Line 1806 of yacc.c  */
#line 3586 "./parse.y"
    {  args_after_notifier += 1; }
    break;

  case 584:

/* Line 1806 of yacc.c  */
#line 3588 "./parse.y"
    { args_after_notifier += 1;
		  if (args_after_notifier >= 3)  {
                    cerr << (yylsp[(3) - (3)]) << ": warning: timing checks are not supported "
		                  "and delayed signal \"" << *(yyvsp[(3) - (3)].pform_name)
		         << "\" will not be driven." << endl;
		  }
                  delete (yyvsp[(3) - (3)].pform_name); }
    break;

  case 585:

/* Line 1806 of yacc.c  */
#line 3597 "./parse.y"
    { args_after_notifier = 0; delete[](yyvsp[(1) - (1)].text); }
    break;

  case 586:

/* Line 1806 of yacc.c  */
#line 3609 "./parse.y"
    { PCAssign*tmp = new PCAssign((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 587:

/* Line 1806 of yacc.c  */
#line 3615 "./parse.y"
    { PDeassign*tmp = new PDeassign((yyvsp[(2) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 588:

/* Line 1806 of yacc.c  */
#line 3625 "./parse.y"
    { PForce*tmp = new PForce((yyvsp[(2) - (5)].expr), (yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 589:

/* Line 1806 of yacc.c  */
#line 3630 "./parse.y"
    { PRelease*tmp = new PRelease((yyvsp[(2) - (3)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 590:

/* Line 1806 of yacc.c  */
#line 3642 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (3)]));
	tmp->set_statement(*(yyvsp[(2) - (3)].statement_list));
	delete (yyvsp[(2) - (3)].statement_list);
	(yyval.statement) = tmp;
      }
    break;

  case 591:

/* Line 1806 of yacc.c  */
#line 3649 "./parse.y"
    { PBlock*tmp = pform_push_block_scope((yyvsp[(3) - (3)].text), PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (3)]));
	current_block_stack.push(tmp);
      }
    break;

  case 592:

/* Line 1806 of yacc.c  */
#line 3655 "./parse.y"
    { pform_pop_scope();
	assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	tmp->set_statement(*(yyvsp[(6) - (7)].statement_list));
	delete[](yyvsp[(3) - (7)].text);
	delete (yyvsp[(6) - (7)].statement_list);
	(yyval.statement) = tmp;
      }
    break;

  case 593:

/* Line 1806 of yacc.c  */
#line 3665 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (2)]));
	(yyval.statement) = tmp;
      }
    break;

  case 594:

/* Line 1806 of yacc.c  */
#line 3670 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_SEQ);
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete[](yyvsp[(3) - (4)].text);
	(yyval.statement) = tmp;
      }
    break;

  case 595:

/* Line 1806 of yacc.c  */
#line 3676 "./parse.y"
    { yyerrok; }
    break;

  case 596:

/* Line 1806 of yacc.c  */
#line 3684 "./parse.y"
    { PBlock*tmp = pform_push_block_scope((yyvsp[(3) - (3)].text), PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[(1) - (3)]));
	current_block_stack.push(tmp);
      }
    break;

  case 597:

/* Line 1806 of yacc.c  */
#line 3690 "./parse.y"
    { pform_pop_scope();
        assert(! current_block_stack.empty());
	PBlock*tmp = current_block_stack.top();
	current_block_stack.pop();
	tmp->set_statement(*(yyvsp[(6) - (7)].statement_list));
	delete[](yyvsp[(3) - (7)].text);
	delete (yyvsp[(6) - (7)].statement_list);
	(yyval.statement) = tmp;
      }
    break;

  case 598:

/* Line 1806 of yacc.c  */
#line 3700 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[(1) - (2)]));
	(yyval.statement) = tmp;
      }
    break;

  case 599:

/* Line 1806 of yacc.c  */
#line 3705 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	delete[](yyvsp[(3) - (4)].text);
	(yyval.statement) = tmp;
      }
    break;

  case 600:

/* Line 1806 of yacc.c  */
#line 3712 "./parse.y"
    { PDisable*tmp = new PDisable(*(yyvsp[(2) - (3)].pform_name));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  delete (yyvsp[(2) - (3)].pform_name);
		  (yyval.statement) = tmp;
		}
    break;

  case 601:

/* Line 1806 of yacc.c  */
#line 3718 "./parse.y"
    { PTrigger*tmp = new PTrigger(*(yyvsp[(2) - (3)].pform_name));
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  delete (yyvsp[(2) - (3)].pform_name);
		  (yyval.statement) = tmp;
		}
    break;

  case 602:

/* Line 1806 of yacc.c  */
#line 3724 "./parse.y"
    { PForever*tmp = new PForever((yyvsp[(2) - (2)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 603:

/* Line 1806 of yacc.c  */
#line 3729 "./parse.y"
    { PBlock*tmp = new PBlock(PBlock::BL_PAR);
		  FILE_NAME(tmp, (yylsp[(1) - (3)]));
		  tmp->set_statement(*(yyvsp[(2) - (3)].statement_list));
		  delete (yyvsp[(2) - (3)].statement_list);
		  (yyval.statement) = tmp;
		}
    break;

  case 604:

/* Line 1806 of yacc.c  */
#line 3736 "./parse.y"
    { PRepeat*tmp = new PRepeat((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 605:

/* Line 1806 of yacc.c  */
#line 3741 "./parse.y"
    { PCase*tmp = new PCase(NetCase::EQ, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].citems));
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 606:

/* Line 1806 of yacc.c  */
#line 3746 "./parse.y"
    { PCase*tmp = new PCase(NetCase::EQX, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].citems));
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 607:

/* Line 1806 of yacc.c  */
#line 3751 "./parse.y"
    { PCase*tmp = new PCase(NetCase::EQZ, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].citems));
		  FILE_NAME(tmp, (yylsp[(1) - (6)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 608:

/* Line 1806 of yacc.c  */
#line 3756 "./parse.y"
    { yyerrok; }
    break;

  case 609:

/* Line 1806 of yacc.c  */
#line 3758 "./parse.y"
    { yyerrok; }
    break;

  case 610:

/* Line 1806 of yacc.c  */
#line 3760 "./parse.y"
    { yyerrok; }
    break;

  case 611:

/* Line 1806 of yacc.c  */
#line 3762 "./parse.y"
    { PCondit*tmp = new PCondit((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].statement), 0);
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 612:

/* Line 1806 of yacc.c  */
#line 3767 "./parse.y"
    { PCondit*tmp = new PCondit((yyvsp[(3) - (7)].expr), (yyvsp[(5) - (7)].statement), (yyvsp[(7) - (7)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (7)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 613:

/* Line 1806 of yacc.c  */
#line 3772 "./parse.y"
    { yyerror((yylsp[(1) - (5)]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[(5) - (5)].statement);
		}
    break;

  case 614:

/* Line 1806 of yacc.c  */
#line 3776 "./parse.y"
    { yyerror((yylsp[(1) - (7)]), "error: Malformed conditional expression.");
		  (yyval.statement) = (yyvsp[(5) - (7)].statement);
		}
    break;

  case 615:

/* Line 1806 of yacc.c  */
#line 3781 "./parse.y"
    { PForStatement*tmp = new PForStatement((yyvsp[(3) - (13)].expr), (yyvsp[(5) - (13)].expr), (yyvsp[(7) - (13)].expr), (yyvsp[(9) - (13)].expr), (yyvsp[(11) - (13)].expr), (yyvsp[(13) - (13)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (13)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 616:

/* Line 1806 of yacc.c  */
#line 3787 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (11)]), "error: Error in for loop step assignment.");
		}
    break;

  case 617:

/* Line 1806 of yacc.c  */
#line 3792 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (13)]), "error: Error in for loop condition expression.");
		}
    break;

  case 618:

/* Line 1806 of yacc.c  */
#line 3796 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (5)]), "error: Incomprehensible for loop.");
		}
    break;

  case 619:

/* Line 1806 of yacc.c  */
#line 3800 "./parse.y"
    { PWhile*tmp = new PWhile((yyvsp[(3) - (5)].expr), (yyvsp[(5) - (5)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 620:

/* Line 1806 of yacc.c  */
#line 3805 "./parse.y"
    { (yyval.statement) = 0;
		  yyerror((yylsp[(1) - (5)]), "error: Error in while loop condition.");
		}
    break;

  case 621:

/* Line 1806 of yacc.c  */
#line 3809 "./parse.y"
    { PExpr*del = (*(yyvsp[(1) - (2)].exprs))[0];
		  assert((yyvsp[(1) - (2)].exprs)->count() == 1);
		  PDelayStatement*tmp = new PDelayStatement(del, (yyvsp[(2) - (2)].statement));
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 622:

/* Line 1806 of yacc.c  */
#line 3816 "./parse.y"
    { PEventStatement*tmp = (yyvsp[(1) - (3)].event_statement);
	if (tmp == 0) {
	      yyerror((yylsp[(1) - (3)]), "error: Invalid event control.");
	      (yyval.statement) = 0;
	} else {
	      if ((yyvsp[(3) - (3)].statement)) pform_bind_attributes((yyvsp[(3) - (3)].statement)->attributes,(yyvsp[(2) - (3)].named_pexprs));
	      tmp->set_statement((yyvsp[(3) - (3)].statement));
	      (yyval.statement) = tmp;
	}
      }
    break;

  case 623:

/* Line 1806 of yacc.c  */
#line 3827 "./parse.y"
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[(1) - (4)]));
	if ((yyvsp[(4) - (4)].statement)) pform_bind_attributes((yyvsp[(4) - (4)].statement)->attributes,(yyvsp[(3) - (4)].named_pexprs));
	tmp->set_statement((yyvsp[(4) - (4)].statement));
	(yyval.statement) = tmp;
      }
    break;

  case 624:

/* Line 1806 of yacc.c  */
#line 3834 "./parse.y"
    { PEventStatement*tmp = new PEventStatement;
	FILE_NAME(tmp, (yylsp[(1) - (6)]));
	if ((yyvsp[(6) - (6)].statement)) pform_bind_attributes((yyvsp[(6) - (6)].statement)->attributes,(yyvsp[(5) - (6)].named_pexprs));
	tmp->set_statement((yyvsp[(6) - (6)].statement));
	(yyval.statement) = tmp;
      }
    break;

  case 625:

/* Line 1806 of yacc.c  */
#line 3841 "./parse.y"
    { PAssign*tmp = new PAssign((yyvsp[(1) - (4)].expr),(yyvsp[(3) - (4)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 626:

/* Line 1806 of yacc.c  */
#line 3846 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
    break;

  case 627:

/* Line 1806 of yacc.c  */
#line 3851 "./parse.y"
    { PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (4)].expr),(yyvsp[(3) - (4)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 628:

/* Line 1806 of yacc.c  */
#line 3856 "./parse.y"
    { yyerror((yylsp[(2) - (4)]), "Syntax in assignment statement l-value.");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
    break;

  case 629:

/* Line 1806 of yacc.c  */
#line 3861 "./parse.y"
    { assert((yyvsp[(3) - (5)].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[(3) - (5)].exprs))[0];
		  PAssign*tmp = new PAssign((yyvsp[(1) - (5)].expr),del,(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 630:

/* Line 1806 of yacc.c  */
#line 3868 "./parse.y"
    { assert((yyvsp[(3) - (5)].exprs)->count() == 1);
		  PExpr*del = (*(yyvsp[(3) - (5)].exprs))[0];
		  PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (5)].expr),del,(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 631:

/* Line 1806 of yacc.c  */
#line 3875 "./parse.y"
    { PAssign*tmp = new PAssign((yyvsp[(1) - (5)].expr),0,(yyvsp[(3) - (5)].event_statement),(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 632:

/* Line 1806 of yacc.c  */
#line 3880 "./parse.y"
    { PAssign*tmp = new PAssign((yyvsp[(1) - (9)].expr),(yyvsp[(5) - (9)].expr),(yyvsp[(7) - (9)].event_statement),(yyvsp[(8) - (9)].expr));
		  FILE_NAME(tmp,(yylsp[(1) - (9)]));
		  tmp->set_lineno((yylsp[(1) - (9)]).first_line);
		  (yyval.statement) = tmp;
		}
    break;

  case 633:

/* Line 1806 of yacc.c  */
#line 3886 "./parse.y"
    { PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (5)].expr),0,(yyvsp[(3) - (5)].event_statement),(yyvsp[(4) - (5)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 634:

/* Line 1806 of yacc.c  */
#line 3891 "./parse.y"
    { PAssignNB*tmp = new PAssignNB((yyvsp[(1) - (9)].expr),(yyvsp[(5) - (9)].expr),(yyvsp[(7) - (9)].event_statement),(yyvsp[(8) - (9)].expr));
		  FILE_NAME(tmp, (yylsp[(1) - (9)]));
		  (yyval.statement) = tmp;
		}
    break;

  case 635:

/* Line 1806 of yacc.c  */
#line 3896 "./parse.y"
    { PEventStatement*tmp;
		  PEEvent*etmp = new PEEvent(PEEvent::POSITIVE, (yyvsp[(3) - (5)].expr));
		  tmp = new PEventStatement(etmp);
		  FILE_NAME(tmp,(yylsp[(1) - (5)]));
		  tmp->set_statement((yyvsp[(5) - (5)].statement));
		  (yyval.statement) = tmp;
		}
    break;

  case 636:

/* Line 1806 of yacc.c  */
#line 3904 "./parse.y"
    { PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[(1) - (5)].text)), *(yyvsp[(3) - (5)].exprs));
		  FILE_NAME(tmp,(yylsp[(1) - (5)]));
		  delete[](yyvsp[(1) - (5)].text);
		  delete (yyvsp[(3) - (5)].exprs);
		  (yyval.statement) = tmp;
		}
    break;

  case 637:

/* Line 1806 of yacc.c  */
#line 3911 "./parse.y"
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(lex_strings.make((yyvsp[(1) - (2)].text)), pt);
		  FILE_NAME(tmp,(yylsp[(1) - (2)]));
		  delete[](yyvsp[(1) - (2)].text);
		  (yyval.statement) = tmp;
		}
    break;

  case 638:

/* Line 1806 of yacc.c  */
#line 3918 "./parse.y"
    { PCallTask*tmp = new PCallTask(*(yyvsp[(1) - (5)].pform_name), *(yyvsp[(3) - (5)].exprs));
		  FILE_NAME(tmp, (yylsp[(1) - (5)]));
		  delete (yyvsp[(1) - (5)].pform_name);
		  delete (yyvsp[(3) - (5)].exprs);
		  (yyval.statement) = tmp;
		}
    break;

  case 639:

/* Line 1806 of yacc.c  */
#line 3930 "./parse.y"
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[(1) - (4)].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[(1) - (4)]));
		  delete (yyvsp[(1) - (4)].pform_name);
		  (yyval.statement) = tmp;
		}
    break;

  case 640:

/* Line 1806 of yacc.c  */
#line 3937 "./parse.y"
    { svector<PExpr*>pt (0);
		  PCallTask*tmp = new PCallTask(*(yyvsp[(1) - (2)].pform_name), pt);
		  FILE_NAME(tmp, (yylsp[(1) - (2)]));
		  delete (yyvsp[(1) - (2)].pform_name);
		  (yyval.statement) = tmp;
		}
    break;

  case 641:

/* Line 1806 of yacc.c  */
#line 3944 "./parse.y"
    { yyerror((yylsp[(2) - (2)]), "error: malformed statement");
		  yyerrok;
		  (yyval.statement) = new PNoop;
		}
    break;

  case 642:

/* Line 1806 of yacc.c  */
#line 3952 "./parse.y"
    { svector<Statement*>*tmp = new svector<Statement*>(*(yyvsp[(1) - (2)].statement_list), (yyvsp[(2) - (2)].statement));
		  delete (yyvsp[(1) - (2)].statement_list);
		  (yyval.statement_list) = tmp;
		}
    break;

  case 643:

/* Line 1806 of yacc.c  */
#line 3957 "./parse.y"
    { svector<Statement*>*tmp = new svector<Statement*>(1);
		  (*tmp)[0] = (yyvsp[(1) - (1)].statement);
		  (yyval.statement_list) = tmp;
		}
    break;

  case 644:

/* Line 1806 of yacc.c  */
#line 3965 "./parse.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 645:

/* Line 1806 of yacc.c  */
#line 3967 "./parse.y"
    { (yyval.statement) = 0; }
    break;

  case 646:

/* Line 1806 of yacc.c  */
#line 3972 "./parse.y"
    { (yyval.statement) = pform_contribution_statement((yylsp[(2) - (4)]), (yyvsp[(1) - (4)].expr), (yyvsp[(3) - (4)].expr)); }
    break;

  case 647:

/* Line 1806 of yacc.c  */
#line 3978 "./parse.y"
    { (yyval.wires) = new svector<PWire*>(0); }
    break;

  case 648:

/* Line 1806 of yacc.c  */
#line 3979 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); }
    break;

  case 649:

/* Line 1806 of yacc.c  */
#line 3983 "./parse.y"
    { (yyval.flag) = true; }
    break;

  case 650:

/* Line 1806 of yacc.c  */
#line 3984 "./parse.y"
    { (yyval.flag) = false; }
    break;

  case 651:

/* Line 1806 of yacc.c  */
#line 3989 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						(yyvsp[(2) - (6)].flag) ? IVL_VT_LOGIC :
						     IVL_VT_NO_TYPE,
						(yyvsp[(3) - (6)].flag), (yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].perm_strings),
						(yylsp[(1) - (6)]).text, (yylsp[(1) - (6)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 652:

/* Line 1806 of yacc.c  */
#line 3998 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						(yyvsp[(2) - (6)].flag) ? IVL_VT_LOGIC :
						     IVL_VT_NO_TYPE,
						(yyvsp[(3) - (6)].flag), (yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].perm_strings),
						(yylsp[(1) - (6)]).text, (yylsp[(1) - (6)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 653:

/* Line 1806 of yacc.c  */
#line 4007 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						(yyvsp[(2) - (6)].flag) ? IVL_VT_LOGIC :
						     IVL_VT_NO_TYPE,
						(yyvsp[(3) - (6)].flag), (yyvsp[(4) - (6)].exprs), (yyvsp[(5) - (6)].perm_strings),
						(yylsp[(1) - (6)]).text, (yylsp[(1) - (6)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 654:

/* Line 1806 of yacc.c  */
#line 4020 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line, true);
		  (yyval.wires) = tmp;
		}
    break;

  case 655:

/* Line 1806 of yacc.c  */
#line 4035 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line, true);
		  (yyval.wires) = tmp;
		}
    break;

  case 656:

/* Line 1806 of yacc.c  */
#line 4050 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line, true);
		  (yyval.wires) = tmp;
		}
    break;

  case 657:

/* Line 1806 of yacc.c  */
#line 4068 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 658:

/* Line 1806 of yacc.c  */
#line 4082 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 659:

/* Line 1806 of yacc.c  */
#line 4096 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 660:

/* Line 1806 of yacc.c  */
#line 4113 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 661:

/* Line 1806 of yacc.c  */
#line 4121 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, true,
						0, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 662:

/* Line 1806 of yacc.c  */
#line 4129 "./parse.y"
    { svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, true,
						0, (yyvsp[(3) - (4)].perm_strings),
						(yylsp[(1) - (4)]).text, (yylsp[(1) - (4)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 663:

/* Line 1806 of yacc.c  */
#line 4140 "./parse.y"
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (2)].wires), *(yyvsp[(2) - (2)].wires));
		  delete (yyvsp[(1) - (2)].wires);
		  delete (yyvsp[(2) - (2)].wires);
		  (yyval.wires) = tmp;
		}
    break;

  case 664:

/* Line 1806 of yacc.c  */
#line 4146 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); }
    break;

  case 665:

/* Line 1806 of yacc.c  */
#line 4151 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); }
    break;

  case 666:

/* Line 1806 of yacc.c  */
#line 4153 "./parse.y"
    { (yyval.wires) = 0; }
    break;

  case 667:

/* Line 1806 of yacc.c  */
#line 4159 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[(3) - (5)].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[(4) - (5)].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (5)].flag),
						(yyvsp[(4) - (5)].exprs), list_from_identifier((yyvsp[(5) - (5)].text)),
						(yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 668:

/* Line 1806 of yacc.c  */
#line 4173 "./parse.y"
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[(3) - (5)].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[(4) - (5)].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (5)].flag),
						(yyvsp[(4) - (5)].exprs), list_from_identifier((yyvsp[(5) - (5)].text)),
						(yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 669:

/* Line 1806 of yacc.c  */
#line 4186 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = (yyvsp[(3) - (5)].flag);
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range((yyvsp[(4) - (5)].exprs));
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, (yyvsp[(3) - (5)].flag),
						(yyvsp[(4) - (5)].exprs), list_from_identifier((yyvsp[(5) - (5)].text)),
						(yylsp[(1) - (5)]).text, (yylsp[(1) - (5)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 670:

/* Line 1806 of yacc.c  */
#line 4202 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line, true);
		  (yyval.wires) = tmp;
		}
    break;

  case 671:

/* Line 1806 of yacc.c  */
#line 4223 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line, true);
		  (yyval.wires) = tmp;
		}
    break;

  case 672:

/* Line 1806 of yacc.c  */
#line 4244 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum(integer_width-1,
						integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = true;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, true,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line, true);
		  (yyval.wires) = tmp;
		}
    break;

  case 673:

/* Line 1806 of yacc.c  */
#line 4268 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 674:

/* Line 1806 of yacc.c  */
#line 4288 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 675:

/* Line 1806 of yacc.c  */
#line 4308 "./parse.y"
    { svector<PExpr*>*range_stub = new svector<PExpr*>(2);
		  PExpr*re;
		  re = new PENumber(new verinum((uint64_t)63, integer_width));
		  (*range_stub)[0] = re;
		  re = new PENumber(new verinum((uint64_t)0, integer_width));
		  (*range_stub)[1] = re;
		  port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_LOGIC;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = copy_range(range_stub);
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_LOGIC, false,
						range_stub,
						list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 676:

/* Line 1806 of yacc.c  */
#line 4331 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 677:

/* Line 1806 of yacc.c  */
#line 4344 "./parse.y"
    { port_declaration_context.port_type = NetNet::POUTPUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::POUTPUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 678:

/* Line 1806 of yacc.c  */
#line 4357 "./parse.y"
    { port_declaration_context.port_type = NetNet::PINOUT;
		  port_declaration_context.var_type = IVL_VT_REAL;
		  port_declaration_context.sign_flag = false;
		  delete port_declaration_context.range;
		  port_declaration_context.range = 0;
		  svector<PWire*>*tmp
			= pform_make_task_ports(NetNet::PINOUT,
						IVL_VT_REAL, false,
						0, list_from_identifier((yyvsp[(3) - (3)].text)),
						(yylsp[(1) - (3)]).text, (yylsp[(1) - (3)]).first_line);
		  (yyval.wires) = tmp;
		}
    break;

  case 679:

/* Line 1806 of yacc.c  */
#line 4373 "./parse.y"
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (3)].wires), *(yyvsp[(3) - (3)].wires));
		  delete (yyvsp[(1) - (3)].wires);
		  delete (yyvsp[(3) - (3)].wires);
		  (yyval.wires) = tmp;
		}
    break;

  case 680:

/* Line 1806 of yacc.c  */
#line 4379 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); }
    break;

  case 681:

/* Line 1806 of yacc.c  */
#line 4381 "./parse.y"
    { svector<PWire*>*new_decl
			= pform_make_task_ports(
				port_declaration_context.port_type,
				port_declaration_context.var_type,
				port_declaration_context.sign_flag,
				copy_range(port_declaration_context.range),
				list_from_identifier((yyvsp[(3) - (3)].text)),
				(yylsp[(3) - (3)]).text, (yylsp[(3) - (3)]).first_line);
		  svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (3)].wires), *new_decl);
		  delete (yyvsp[(1) - (3)].wires);
		  delete new_decl;
		  (yyval.wires) = tmp;
		}
    break;

  case 682:

/* Line 1806 of yacc.c  */
#line 4395 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: NULL port declarations are not "
		              "allowed.");
		}
    break;

  case 683:

/* Line 1806 of yacc.c  */
#line 4400 "./parse.y"
    {
		  yyerror((yylsp[(2) - (2)]), "error: ';' is an invalid port declaration "
		              "separator.");
		}
    break;

  case 684:

/* Line 1806 of yacc.c  */
#line 4408 "./parse.y"
    { lex_start_table(); }
    break;

  case 685:

/* Line 1806 of yacc.c  */
#line 4410 "./parse.y"
    { lex_end_table(); (yyval.strings) = (yyvsp[(3) - (4)].strings); }
    break;

  case 688:

/* Line 1806 of yacc.c  */
#line 4420 "./parse.y"
    { char*tmp = new char[strlen((yyvsp[(1) - (4)].text))+3];
		  strcpy(tmp, (yyvsp[(1) - (4)].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[(3) - (4)].letter);
		  *tp++ = 0;
		  delete[](yyvsp[(1) - (4)].text);
		  (yyval.text) = tmp;
		}
    break;

  case 689:

/* Line 1806 of yacc.c  */
#line 4433 "./parse.y"
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[(1) - (1)].text));
		  delete[](yyvsp[(1) - (1)].text);
		  (yyval.strings) = tmp;
		}
    break;

  case 690:

/* Line 1806 of yacc.c  */
#line 4439 "./parse.y"
    { list<string>*tmp = (yyvsp[(1) - (2)].strings);
		  tmp->push_back((yyvsp[(2) - (2)].text));
		  delete[](yyvsp[(2) - (2)].text);
		  (yyval.strings) = tmp;
		}
    break;

  case 691:

/* Line 1806 of yacc.c  */
#line 4448 "./parse.y"
    { list<string>*tmp = new list<string>;
		  tmp->push_back((yyvsp[(1) - (1)].text));
		  delete[](yyvsp[(1) - (1)].text);
		  (yyval.strings) = tmp;
		}
    break;

  case 692:

/* Line 1806 of yacc.c  */
#line 4454 "./parse.y"
    { list<string>*tmp = (yyvsp[(1) - (2)].strings);
		  tmp->push_back((yyvsp[(2) - (2)].text));
		  delete[](yyvsp[(2) - (2)].text);
		  (yyval.strings) = tmp;
		}
    break;

  case 693:

/* Line 1806 of yacc.c  */
#line 4463 "./parse.y"
    { char*tmp = new char[strlen((yyvsp[(1) - (6)].text))+5];
		  strcpy(tmp, (yyvsp[(1) - (6)].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = ':';
		  *tp++ = (yyvsp[(3) - (6)].letter);
		  *tp++ = ':';
		  *tp++ = (yyvsp[(5) - (6)].letter);
		  *tp++ = 0;
		  (yyval.text) = tmp;
		}
    break;

  case 694:

/* Line 1806 of yacc.c  */
#line 4477 "./parse.y"
    { PExpr*etmp = new PENumber((yyvsp[(4) - (5)].number));
		  PEIdent*itmp = new PEIdent(lex_strings.make((yyvsp[(2) - (5)].text)));
		  PAssign*atmp = new PAssign(itmp, etmp);
		  FILE_NAME(atmp, (yylsp[(2) - (5)]));
		  delete[](yyvsp[(2) - (5)].text);
		  (yyval.statement) = atmp;
		}
    break;

  case 695:

/* Line 1806 of yacc.c  */
#line 4487 "./parse.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); }
    break;

  case 696:

/* Line 1806 of yacc.c  */
#line 4488 "./parse.y"
    { (yyval.statement) = 0; }
    break;

  case 697:

/* Line 1806 of yacc.c  */
#line 4493 "./parse.y"
    { char*tmp = new char[2];
		  tmp[0] = (yyvsp[(1) - (1)].letter);
		  tmp[1] = 0;
		  (yyval.text) = tmp;
		}
    break;

  case 698:

/* Line 1806 of yacc.c  */
#line 4499 "./parse.y"
    { char*tmp = new char[strlen((yyvsp[(1) - (2)].text))+2];
		  strcpy(tmp, (yyvsp[(1) - (2)].text));
		  char*tp = tmp+strlen(tmp);
		  *tp++ = (yyvsp[(2) - (2)].letter);
		  *tp++ = 0;
		  delete[](yyvsp[(1) - (2)].text);
		  (yyval.text) = tmp;
		}
    break;

  case 699:

/* Line 1806 of yacc.c  */
#line 4510 "./parse.y"
    { (yyval.letter) = '0'; }
    break;

  case 700:

/* Line 1806 of yacc.c  */
#line 4511 "./parse.y"
    { (yyval.letter) = '1'; }
    break;

  case 701:

/* Line 1806 of yacc.c  */
#line 4512 "./parse.y"
    { (yyval.letter) = 'x'; }
    break;

  case 702:

/* Line 1806 of yacc.c  */
#line 4513 "./parse.y"
    { (yyval.letter) = '?'; }
    break;

  case 703:

/* Line 1806 of yacc.c  */
#line 4514 "./parse.y"
    { (yyval.letter) = 'b'; }
    break;

  case 704:

/* Line 1806 of yacc.c  */
#line 4515 "./parse.y"
    { (yyval.letter) = '*'; }
    break;

  case 705:

/* Line 1806 of yacc.c  */
#line 4516 "./parse.y"
    { (yyval.letter) = '%'; }
    break;

  case 706:

/* Line 1806 of yacc.c  */
#line 4517 "./parse.y"
    { (yyval.letter) = 'f'; }
    break;

  case 707:

/* Line 1806 of yacc.c  */
#line 4518 "./parse.y"
    { (yyval.letter) = 'F'; }
    break;

  case 708:

/* Line 1806 of yacc.c  */
#line 4519 "./parse.y"
    { (yyval.letter) = 'l'; }
    break;

  case 709:

/* Line 1806 of yacc.c  */
#line 4520 "./parse.y"
    { (yyval.letter) = 'H'; }
    break;

  case 710:

/* Line 1806 of yacc.c  */
#line 4521 "./parse.y"
    { (yyval.letter) = 'B'; }
    break;

  case 711:

/* Line 1806 of yacc.c  */
#line 4522 "./parse.y"
    { (yyval.letter) = 'r'; }
    break;

  case 712:

/* Line 1806 of yacc.c  */
#line 4523 "./parse.y"
    { (yyval.letter) = 'R'; }
    break;

  case 713:

/* Line 1806 of yacc.c  */
#line 4524 "./parse.y"
    { (yyval.letter) = 'M'; }
    break;

  case 714:

/* Line 1806 of yacc.c  */
#line 4525 "./parse.y"
    { (yyval.letter) = 'n'; }
    break;

  case 715:

/* Line 1806 of yacc.c  */
#line 4526 "./parse.y"
    { (yyval.letter) = 'N'; }
    break;

  case 716:

/* Line 1806 of yacc.c  */
#line 4527 "./parse.y"
    { (yyval.letter) = 'p'; }
    break;

  case 717:

/* Line 1806 of yacc.c  */
#line 4528 "./parse.y"
    { (yyval.letter) = 'P'; }
    break;

  case 718:

/* Line 1806 of yacc.c  */
#line 4529 "./parse.y"
    { (yyval.letter) = 'Q'; }
    break;

  case 719:

/* Line 1806 of yacc.c  */
#line 4530 "./parse.y"
    { (yyval.letter) = 'q'; }
    break;

  case 720:

/* Line 1806 of yacc.c  */
#line 4531 "./parse.y"
    { (yyval.letter) = '_'; }
    break;

  case 721:

/* Line 1806 of yacc.c  */
#line 4532 "./parse.y"
    { (yyval.letter) = '+'; }
    break;

  case 722:

/* Line 1806 of yacc.c  */
#line 4536 "./parse.y"
    { (yyval.letter) = '0'; }
    break;

  case 723:

/* Line 1806 of yacc.c  */
#line 4537 "./parse.y"
    { (yyval.letter) = '1'; }
    break;

  case 724:

/* Line 1806 of yacc.c  */
#line 4538 "./parse.y"
    { (yyval.letter) = 'x'; }
    break;

  case 725:

/* Line 1806 of yacc.c  */
#line 4539 "./parse.y"
    { (yyval.letter) = '-'; }
    break;

  case 726:

/* Line 1806 of yacc.c  */
#line 4547 "./parse.y"
    { (yyval.wires) = pform_make_udp_input_ports((yyvsp[(2) - (3)].perm_strings)); }
    break;

  case 727:

/* Line 1806 of yacc.c  */
#line 4549 "./parse.y"
    { perm_string pname = lex_strings.make((yyvsp[(2) - (3)].text));
	PWire*pp = new PWire(pname, NetNet::IMPLICIT, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[(2) - (3)].text);
      }
    break;

  case 728:

/* Line 1806 of yacc.c  */
#line 4557 "./parse.y"
    { perm_string pname = lex_strings.make((yyvsp[(2) - (3)].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::PIMPLICIT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[(2) - (3)].text);
      }
    break;

  case 729:

/* Line 1806 of yacc.c  */
#line 4565 "./parse.y"
    { perm_string pname = lex_strings.make((yyvsp[(3) - (4)].text));
	PWire*pp = new PWire(pname, NetNet::REG, NetNet::POUTPUT, IVL_VT_LOGIC);
	svector<PWire*>*tmp = new svector<PWire*>(1);
	(*tmp)[0] = pp;
	(yyval.wires) = tmp;
	delete[](yyvsp[(3) - (4)].text);
      }
    break;

  case 730:

/* Line 1806 of yacc.c  */
#line 4576 "./parse.y"
    { (yyval.wires) = (yyvsp[(1) - (1)].wires); }
    break;

  case 731:

/* Line 1806 of yacc.c  */
#line 4578 "./parse.y"
    { svector<PWire*>*tmp = new svector<PWire*>(*(yyvsp[(1) - (2)].wires), *(yyvsp[(2) - (2)].wires));
		  delete (yyvsp[(1) - (2)].wires);
		  delete (yyvsp[(2) - (2)].wires);
		  (yyval.wires) = tmp;
		}
    break;

  case 732:

/* Line 1806 of yacc.c  */
#line 4587 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
	tmp->push_back(lex_strings.make((yyvsp[(1) - (1)].text)));
	delete[](yyvsp[(1) - (1)].text);
	(yyval.perm_strings) = tmp;
      }
    break;

  case 733:

/* Line 1806 of yacc.c  */
#line 4593 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (3)].perm_strings);
	tmp->push_back(lex_strings.make((yyvsp[(3) - (3)].text)));
	delete[](yyvsp[(3) - (3)].text);
	(yyval.perm_strings) = tmp;
      }
    break;

  case 734:

/* Line 1806 of yacc.c  */
#line 4600 "./parse.y"
    { (yyval.flag) = true; }
    break;

  case 735:

/* Line 1806 of yacc.c  */
#line 4600 "./parse.y"
    { (yyval.flag) = false; }
    break;

  case 736:

/* Line 1806 of yacc.c  */
#line 4603 "./parse.y"
    { (yyval.expr) = (yyvsp[(2) - (2)].expr); }
    break;

  case 737:

/* Line 1806 of yacc.c  */
#line 4604 "./parse.y"
    { (yyval.expr) = 0; }
    break;

  case 738:

/* Line 1806 of yacc.c  */
#line 4609 "./parse.y"
    { list<perm_string>*tmp = new list<perm_string>;
		  tmp->push_back(lex_strings.make((yyvsp[(2) - (2)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(2) - (2)].text);
		}
    break;

  case 739:

/* Line 1806 of yacc.c  */
#line 4615 "./parse.y"
    { list<perm_string>*tmp = (yyvsp[(1) - (4)].perm_strings);
		  tmp->push_back(lex_strings.make((yyvsp[(4) - (4)].text)));
		  (yyval.perm_strings) = tmp;
		  delete[](yyvsp[(4) - (4)].text);
		}
    break;

  case 740:

/* Line 1806 of yacc.c  */
#line 4633 "./parse.y"
    { perm_string tmp2 = lex_strings.make((yyvsp[(2) - (10)].text));
		  pform_make_udp(tmp2, (yyvsp[(4) - (10)].perm_strings), (yyvsp[(7) - (10)].wires), (yyvsp[(9) - (10)].strings), (yyvsp[(8) - (10)].statement),
				 (yylsp[(2) - (10)]).text, (yylsp[(2) - (10)]).first_line);
		  delete[](yyvsp[(2) - (10)].text);
		}
    break;

  case 741:

/* Line 1806 of yacc.c  */
#line 4648 "./parse.y"
    { perm_string tmp2 = lex_strings.make((yyvsp[(2) - (13)].text));
		  perm_string tmp6 = lex_strings.make((yyvsp[(6) - (13)].text));
		  pform_make_udp(tmp2, (yyvsp[(5) - (13)].flag), tmp6, (yyvsp[(7) - (13)].expr), (yyvsp[(9) - (13)].perm_strings), (yyvsp[(12) - (13)].strings),
				 (yylsp[(2) - (13)]).text, (yylsp[(2) - (13)]).first_line);
		  delete[](yyvsp[(2) - (13)].text);
		  delete[](yyvsp[(6) - (13)].text);
		}
    break;



/* Line 1806 of yacc.c  */
#line 12076 "parse.cc"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



